searchData={"content_type":"text/markdown","items":[{"doc":"ExTeal Actions allow you to perform one off tasks on your ExTeal Index resources with custom conditions.\nFor example you might want to batch update a group of articles to a published state.\n\nEach ExTeal action should contain a `commit/3` function.\n\n**Fields have not been implemented yet**\n\nThe commit function is responsible for modifying the state of the application to achieve the desired actions.\nLet's look at the `PublishAction` action:\n\n```\ndefmodule PortfolioWeb.ExTeal.PublishAction do\n  use ExTeal.Action\n  alias ExTeal.ActionResponse\n\n  def title, do: \"Publish\" // defaults to Publish Action\n  def key, do: \"publish\" // default to publish-action\n\n  def commit(conn, fields, query) do\n    resources = Repo.all(query) //having the raw query gives you the option to batch large requests.\n\n    with {:ok, _results}  \n      ActionResponse.error(\"Error publishing\")\n    end\n  end\nend\n```\n\nThe commit should return an ActionResponse struct. The ActionResponse types that are available are 'success', 'error', 'redirect', 'download' and 'push'.","ref":"ExTeal.Action.html","title":"ExTeal.Action","type":"behaviour"},{"doc":"","ref":"ExTeal.Action.html#action_for_key/2","title":"ExTeal.Action.action_for_key/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#actionable_query/2","title":"ExTeal.Action.actionable_query/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#apply_action/2","title":"ExTeal.Action.apply_action/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#build_for/2","title":"ExTeal.Action.build_for/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#c:commit/3","title":"ExTeal.Action.commit/3","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#error/1","title":"ExTeal.Action.error/1","type":"function"},{"doc":"Override the default key for the action","ref":"ExTeal.Action.html#c:key/0","title":"ExTeal.Action.key/0","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#message/1","title":"ExTeal.Action.message/1","type":"function"},{"doc":"","ref":"ExTeal.Action.html#c:options/1","title":"ExTeal.Action.options/1","type":"callback"},{"doc":"Override the default title for the action","ref":"ExTeal.Action.html#c:title/0","title":"ExTeal.Action.title/0","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#t:action_responses/0","title":"ExTeal.Action.action_responses/0","type":"type"},{"doc":"Used to return the result of an action\nand specifies how the ux should respond","ref":"ExTeal.ActionResponse.html","title":"ExTeal.ActionResponse","type":"module"},{"doc":"Download a file at a specific url","ref":"ExTeal.ActionResponse.html#download/1","title":"ExTeal.ActionResponse.download/1","type":"function"},{"doc":"Display a custom 'error' message.","ref":"ExTeal.ActionResponse.html#error/1","title":"ExTeal.ActionResponse.error/1","type":"function"},{"doc":"Push the user to a new location in the vue app.","ref":"ExTeal.ActionResponse.html#push/1","title":"ExTeal.ActionResponse.push/1","type":"function"},{"doc":"Redirect the user to a url","ref":"ExTeal.ActionResponse.html#redirect/1","title":"ExTeal.ActionResponse.redirect/1","type":"function"},{"doc":"Display a custom 'success' message.","ref":"ExTeal.ActionResponse.html#success/1","title":"ExTeal.ActionResponse.success/1","type":"function"},{"doc":"","ref":"ExTeal.ActionResponse.html#t:t/0","title":"ExTeal.ActionResponse.t/0","type":"type"},{"doc":"API Responder that manages cards\n- `GET /dashboard/:name` - Return the dashboard and it's cards\n- `GET /resource/:resource_name/cards` - Return the cards for a resource","ref":"ExTeal.Api.CardResponder.html","title":"ExTeal.Api.CardResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.CardResponder.html#dashboard/2","title":"ExTeal.Api.CardResponder.dashboard/2","type":"function"},{"doc":"","ref":"ExTeal.Api.CardResponder.html#resource/2","title":"ExTeal.Api.CardResponder.resource/2","type":"function"},{"doc":"Translates a changeset into an error","ref":"ExTeal.Api.ErrorSerializer.html","title":"ExTeal.Api.ErrorSerializer","type":"module"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#flatten/1","title":"ExTeal.Api.ErrorSerializer.flatten/1","type":"function"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#handle_error/2","title":"ExTeal.Api.ErrorSerializer.handle_error/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#render/1","title":"ExTeal.Api.ErrorSerializer.render/1","type":"function"},{"doc":"Traverses and translates changeset errors.\n\nSee `Ecto.Changeset.traverse_errors/2`","ref":"ExTeal.Api.ErrorSerializer.html#translate_errors/1","title":"ExTeal.Api.ErrorSerializer.translate_errors/1","type":"function"},{"doc":"API Responder that manages the many to many relationships via:\n\n- `GET attachable` - Querying the potentially related\n- `POST attach` - Adding a related resource\n- `DELETE detach` - Removing a related resource\n- `GET creation-pivot-fields` - Fetch the pivot fields associated with a relationship","ref":"ExTeal.Api.ManyToMany.html","title":"ExTeal.Api.ManyToMany","type":"module"},{"doc":"Given a request of `POST /api/posts/1/attach/tags`\nthat contains a set of params like:\n\n    %{\n      \"viaRelationship\" => \"tags\",\n      \"tags\" => \"2\"\n    }\n\nThis function attaches the tag with id 2 to the posts tags relationship.","ref":"ExTeal.Api.ManyToMany.html#attach/4","title":"ExTeal.Api.ManyToMany.attach/4","type":"function"},{"doc":"Given a request of `GET /api/resource_uri/resource_id/attachable/field_name`\nThis function returns a response that contains the attachable schemas associated with the many to many relationship at `field_name`","ref":"ExTeal.Api.ManyToMany.html#attachable/4","title":"ExTeal.Api.ManyToMany.attachable/4","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many\nrelationship.  Fields are only for attaching to a many to many","ref":"ExTeal.Api.ManyToMany.html#creation_pivot_fields/3","title":"ExTeal.Api.ManyToMany.creation_pivot_fields/3","type":"function"},{"doc":"Given a request of `DELETE /api/posts/1/attach/tags/2`\nthat contains a set of params like:\n\nThis function detaches the tag with id 2 from the posts tags relationship.","ref":"ExTeal.Api.ManyToMany.html#detach/4","title":"ExTeal.Api.ManyToMany.detach/4","type":"function"},{"doc":"Batch Updates a pivot schema's fields for reordering a relationship","ref":"ExTeal.Api.ManyToMany.html#reorder/4","title":"ExTeal.Api.ManyToMany.reorder/4","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many relationship\nfor an existing relationship.","ref":"ExTeal.Api.ManyToMany.html#update_pivot/5","title":"ExTeal.Api.ManyToMany.update_pivot/5","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many relationship\nfor an existing relationship.","ref":"ExTeal.Api.ManyToMany.html#update_pivot_fields/5","title":"ExTeal.Api.ManyToMany.update_pivot_fields/5","type":"function"},{"doc":"API Responder for Metrics","ref":"ExTeal.Api.MetricResponder.html","title":"ExTeal.Api.MetricResponder","type":"module"},{"doc":"Return the metric based on it's uri for a dashboard","ref":"ExTeal.Api.MetricResponder.html#get/2","title":"ExTeal.Api.MetricResponder.get/2","type":"function"},{"doc":"Return a metric based on it's uri, resource and resource id","ref":"ExTeal.Api.MetricResponder.html#resource_detail/4","title":"ExTeal.Api.MetricResponder.resource_detail/4","type":"function"},{"doc":"Return a metric based on it's uri and the resource it's displayed on","ref":"ExTeal.Api.MetricResponder.html#resource_index/3","title":"ExTeal.Api.MetricResponder.resource_index/3","type":"function"},{"doc":"Simple Plug that routes a request to the\nappropriate plugin","ref":"ExTeal.Api.PluginResponder.html","title":"ExTeal.Api.PluginResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.PluginResponder.html#call/2","title":"ExTeal.Api.PluginResponder.call/2","type":"function"},{"doc":"","ref":"ExTeal.Api.PluginResponder.html#init/1","title":"ExTeal.Api.PluginResponder.init/1","type":"function"},{"doc":"Hands requests of a certain type to the appropriate resource,\nand returns the resources response as serialized json","ref":"ExTeal.Api.ResourceResponder.html","title":"ExTeal.Api.ResourceResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#actions_for/2","title":"ExTeal.Api.ResourceResponder.actions_for/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#commit_action/2","title":"ExTeal.Api.ResourceResponder.commit_action/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#create/2","title":"ExTeal.Api.ResourceResponder.create/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#creation_fields/2","title":"ExTeal.Api.ResourceResponder.creation_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#delete/2","title":"ExTeal.Api.ResourceResponder.delete/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#export/2","title":"ExTeal.Api.ResourceResponder.export/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#field/3","title":"ExTeal.Api.ResourceResponder.field/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#field_filters/2","title":"ExTeal.Api.ResourceResponder.field_filters/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#filters_for/2","title":"ExTeal.Api.ResourceResponder.filters_for/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#index/2","title":"ExTeal.Api.ResourceResponder.index/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#relatable/3","title":"ExTeal.Api.ResourceResponder.relatable/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#reorder/2","title":"ExTeal.Api.ResourceResponder.reorder/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#show/3","title":"ExTeal.Api.ResourceResponder.show/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#update/3","title":"ExTeal.Api.ResourceResponder.update/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#update_fields/3","title":"ExTeal.Api.ResourceResponder.update_fields/3","type":"function"},{"doc":"Defines a behavior for configuring the main teal application.\n\nIt relies on (and uses):","ref":"ExTeal.Application.Configuration.html","title":"ExTeal.Application.Configuration","type":"behaviour"},{"doc":"Returns the name of the teal application that is used in the html titles of all pages.","ref":"ExTeal.Application.Configuration.html#c:application_name/0","title":"ExTeal.Application.Configuration.application_name/0","type":"callback"},{"doc":"Define which plugin is responsible for providing attachment uploads\nfor rich text content.  Teal does not currently provide a default for\nthis.  If you do not need to upload attachments, you can return `nil`.\n\nProviders from plugins must implement a `window.{PROVIDER_NAME}.uploadFile` that\naccepts a `File` and a `progressCallback` callback function. The function should\nreturn a ` ` that resolves to the response from\nuploading the file.","ref":"ExTeal.Application.Configuration.html#c:asset_upload_provider/0","title":"ExTeal.Application.Configuration.asset_upload_provider/0","type":"callback"},{"doc":"Returns an array of dashboards","ref":"ExTeal.Application.Configuration.html#c:dashboards/0","title":"ExTeal.Application.Configuration.dashboards/0","type":"callback"},{"doc":"Returns the json configuration required for the vue app.","ref":"ExTeal.Application.Configuration.html#c:json_configuration/1","title":"ExTeal.Application.Configuration.json_configuration/1","type":"callback"},{"doc":"Returns the path to the logo that is used in the admin panel.","ref":"ExTeal.Application.Configuration.html#c:logo_image_path/0","title":"ExTeal.Application.Configuration.logo_image_path/0","type":"callback"},{"doc":"Define the order in which groups are shown in the sidebar.  By default only the\ngeneral 'Resources' group is used, but by overriding the `nav_groups/1` function in the manifest,\nyou can define the order of the groups.","ref":"ExTeal.Application.Configuration.html#c:nav_groups/1","title":"ExTeal.Application.Configuration.nav_groups/1","type":"callback"},{"doc":"","ref":"ExTeal.Application.Configuration.html#parse_json/1","title":"ExTeal.Application.Configuration.parse_json/1","type":"function"},{"doc":"Returns the base path that the teal app is located.","ref":"ExTeal.Application.Configuration.html#c:path/0","title":"ExTeal.Application.Configuration.path/0","type":"callback"},{"doc":"Functionality for fetching Vue Assets","ref":"ExTeal.Asset.html","title":"ExTeal.Asset","type":"module"},{"doc":"","ref":"ExTeal.Asset.html#all_assets/0","title":"ExTeal.Asset.all_assets/0","type":"function"},{"doc":"Struct used to represent a JS Script\nthat is served by Teal and required by a plugin\non the front end.","ref":"ExTeal.Asset.Script.html","title":"ExTeal.Asset.Script","type":"module"},{"doc":"","ref":"ExTeal.Asset.Script.html#t:t/0","title":"ExTeal.Asset.Script.t/0","type":"type"},{"doc":"Struct used to represent a CSS Stylesheet\nthat is served by Teal and required by a plugin\non the front end.","ref":"ExTeal.Asset.Style.html","title":"ExTeal.Asset.Style","type":"module"},{"doc":"","ref":"ExTeal.Asset.Style.html#t:t/0","title":"ExTeal.Asset.Style.t/0","type":"type"},{"doc":"Generic Provider that allows anyone to interact with\nExTeal.","ref":"ExTeal.Auth.GuestProvider.html","title":"ExTeal.Auth.GuestProvider","type":"module"},{"doc":"","ref":"ExTeal.Auth.GuestProvider.html#dropdown_content/1","title":"ExTeal.Auth.GuestProvider.dropdown_content/1","type":"function"},{"doc":"Interface for providing authorization and authentication to ExTeal.","ref":"ExTeal.AuthProvider.html","title":"ExTeal.AuthProvider","type":"behaviour"},{"doc":"Used to display the current user on the nav bar.\n\nShould return a user_payload map.  If your User struct\ndoes not have a user image associated with it, consider using the gravatar api.","ref":"ExTeal.AuthProvider.html#c:current_user_for/1","title":"ExTeal.AuthProvider.current_user_for/1","type":"callback"},{"doc":"Used to build the content of the dropdown menu for a user.\n\nThe content of the user dropdown is dynamic and can be overriden to provide\nadditional links and html.\n\nThe function should return a list of strings that will be used to build list\nelements.","ref":"ExTeal.AuthProvider.html#c:dropdown_content/1","title":"ExTeal.AuthProvider.dropdown_content/1","type":"callback"},{"doc":"Data to be displayed on the front end","ref":"ExTeal.AuthProvider.html#t:user_payload/0","title":"ExTeal.AuthProvider.user_payload/0","type":"type"},{"doc":"Represents a Card that can be displayed on a dashboard or resource","ref":"ExTeal.Card.html","title":"ExTeal.Card","type":"behaviour"},{"doc":"","ref":"ExTeal.Card.html#c:component/0","title":"ExTeal.Card.component/0","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:only_on_detail/1","title":"ExTeal.Card.only_on_detail/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:only_on_index/1","title":"ExTeal.Card.only_on_index/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:options/1","title":"ExTeal.Card.options/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#to_struct/2","title":"ExTeal.Card.to_struct/2","type":"function"},{"doc":"","ref":"ExTeal.Card.html#c:width/0","title":"ExTeal.Card.width/0","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#t:t/0","title":"ExTeal.Card.t/0","type":"type"},{"doc":"Not the thing you get the mail, but a card that appears\non the dashboard.","ref":"ExTeal.Cards.Greeting.html","title":"ExTeal.Cards.Greeting","type":"behaviour"},{"doc":"64px x 64px image url to display next to the greeting","ref":"ExTeal.Cards.Greeting.html#c:avatar_url/1","title":"ExTeal.Cards.Greeting.avatar_url/1","type":"callback"},{"doc":"Greeting for a user viewing the card.  Defaults to 'Welcome back,'","ref":"ExTeal.Cards.Greeting.html#c:greeting/0","title":"ExTeal.Cards.Greeting.greeting/0","type":"callback"},{"doc":"Potentially HTML Rich text to display below the users title.\nBeware any unescaped / unsanitary HTML.","ref":"ExTeal.Cards.Greeting.html#c:helper_text/1","title":"ExTeal.Cards.Greeting.helper_text/1","type":"callback"},{"doc":"A list of links to display on a greeting card.","ref":"ExTeal.Cards.Greeting.html#c:links/1","title":"ExTeal.Cards.Greeting.links/1","type":"callback"},{"doc":"The name to greet the user by, use the conn to pull the\ncurrently authorized user.","ref":"ExTeal.Cards.Greeting.html#c:user_name/1","title":"ExTeal.Cards.Greeting.user_name/1","type":"callback"},{"doc":"The users title, useful in applications with RBAC or permissions","ref":"ExTeal.Cards.Greeting.html#c:user_title/1","title":"ExTeal.Cards.Greeting.user_title/1","type":"callback"},{"doc":"Each link should be a map with the following keys:\n  - `label` (required) the text to display on the link\n  - `url` (required) the url to link to\n  - `button_classes` (optional) a string of classes to apply to the link\n\nButtons default to a btn btn-default btn-secondary class definition if an override is not provided","ref":"ExTeal.Cards.Greeting.html#t:link/0","title":"ExTeal.Cards.Greeting.link/0","type":"type"},{"doc":"Sometimes you need a summary table that doesn't easily fit into a single resource.\nSometimes you need a collection of summary tables on a dashboard.\n\nThis is where the ResourceIndex comes in. It's a way to show a resource index table\non a dashboard.","ref":"ExTeal.Cards.ResourceIndex.html","title":"ExTeal.Cards.ResourceIndex","type":"behaviour"},{"doc":"The teal resource used for the table","ref":"ExTeal.Cards.ResourceIndex.html#c:resource/0","title":"ExTeal.Cards.ResourceIndex.resource/0","type":"callback"},{"doc":"Module used to represent a dashboard which contains a grid of metrics, this will one day be extendable to include\nplugin or custom cards in the future.","ref":"ExTeal.Dashboard.html","title":"ExTeal.Dashboard","type":"behaviour"},{"doc":"Return the modules that represent cards on the\ndashboard.","ref":"ExTeal.Dashboard.html#c:cards/1","title":"ExTeal.Dashboard.cards/1","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#cards_to_json/2","title":"ExTeal.Dashboard.cards_to_json/2","type":"function"},{"doc":"Show or Hide a dashboard based on the current connection. Defaults to true","ref":"ExTeal.Dashboard.html#c:display?/1","title":"ExTeal.Dashboard.display?/1","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#map_to_json/1","title":"ExTeal.Dashboard.map_to_json/1","type":"function"},{"doc":"","ref":"ExTeal.Dashboard.html#c:title/0","title":"ExTeal.Dashboard.title/0","type":"callback"},{"doc":"Unique URI that allows the dashboard to look up cards.  Should be url safe.","ref":"ExTeal.Dashboard.html#c:uri/0","title":"ExTeal.Dashboard.uri/0","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#t:range/0","title":"ExTeal.Dashboard.range/0","type":"type"},{"doc":"Generates a panel that contains the fields for a single embed, defined by its\nfield name","ref":"ExTeal.Embedded.html","title":"ExTeal.Embedded","type":"module"},{"doc":"","ref":"ExTeal.Embedded.html#new/3","title":"ExTeal.Embedded.new/3","type":"function"},{"doc":"The core struct that represents a field on a resource served by ExTeal.","ref":"ExTeal.Field.html","title":"ExTeal.Field","type":"behaviour"},{"doc":"","ref":"ExTeal.Field.html#c:apply_options_for/4","title":"ExTeal.Field.apply_options_for/4","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#c:default_sortable/0","title":"ExTeal.Field.default_sortable/0","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#field_name/2","title":"ExTeal.Field.field_name/2","type":"function"},{"doc":"Override the default filter for the field.","ref":"ExTeal.Field.html#filter_as/2","title":"ExTeal.Field.filter_as/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:filterable_as/0","title":"ExTeal.Field.filterable_as/0","type":"callback"},{"doc":"Use a getter function to display a computed field on the resource.\n\nThe getter function is given a schema and expects a string result","ref":"ExTeal.Field.html#get/2","title":"ExTeal.Field.get/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#help_text/2","title":"ExTeal.Field.help_text/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:make/2","title":"ExTeal.Field.make/2","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#nested_value_for/2","title":"ExTeal.Field.nested_value_for/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:sanitize_as/0","title":"ExTeal.Field.sanitize_as/0","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#struct_from_field/3","title":"ExTeal.Field.struct_from_field/3","type":"function"},{"doc":"Define the options for the select field.  The function accepts a list of\noptions that are either strings or maps with of `value` and `label` keys.  If\nthe list members are strings, the value will be used for both the value and label\nof the ` ` element it represents.\n\n`options` are expected to be an enumerable which will be used to generate\neach respective `option`.  The enumerable may have:\n\n  * keyword lists - each keyword list is expected to have the keys `:key` and\n    `:value`.  Additional keys such as `:disabled` may be given to customize\n    the option\n\n  * two-item tuples - where the first element is an atom, string or integer to\n    be used as the option label and the second element is an atom, string or\n    integer to be used as the option value\n\n  * atom, string or integer - which will be used as both label and value for\n    the generated select","ref":"ExTeal.Field.html#transform_options/1","title":"ExTeal.Field.transform_options/1","type":"function"},{"doc":"If `options` is a map or keyword list where the firs element is a string, atom,\nor integer and the second element is a list or a map, it is assumed the key\nwill be wrapped in an ` ` and teh value will be used to generate\n` ` nested under the group.  This functionality is only handled in the UI for\nselect fields, boolean groups will not respond.\n\nThis functionality is equivalent to `Phoenix.HTML.Form.select/3`","ref":"ExTeal.Field.html#transform_options/1-optgroups","title":"Optgroups - ExTeal.Field.transform_options/1","type":"function"},{"doc":"","ref":"ExTeal.Field.html#value_for/3","title":"ExTeal.Field.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:value_for/3","title":"ExTeal.Field.value_for/3","type":"callback"},{"doc":"Mark a field as virtual, which will update how teal queries the database for the field.\n\nThis is relevant for fields that are based on schemaless queries in resources that represent complex\nqueries in read-only situations.  For example, if a resource has a records definition like:\n\n    from(p in \"posts\", select: %{user_id: p.user_id, count: count(p.id)}, group_by: p.user_id)\n\nSorting by that resource would fail without marking the `Number.make(:count)` field as\nvirtual.  Virtual fields allow Teal to sort by computed fields that are not backed\nby a direct database reference, assuming the field is named with `Ecto.Query.API.selected_as/2`:\n\n    from(\n      p in \"posts\",\n      select: %{user_id: p.user_id, count: p.id |> count() |> selected_as(:count)},\n      group_by: p.user_id\n    )\n\nA resource can then use `Number.make(:count) |> Field.virtual()` to mark the field as virtual.","ref":"ExTeal.Field.html#virtual/1","title":"ExTeal.Field.virtual/1","type":"function"},{"doc":"","ref":"ExTeal.Field.html#t:t/0","title":"ExTeal.Field.t/0","type":"type"},{"doc":"Functionality for gathering and parsing filters for a resource index\nbased on the fields present on the resource.","ref":"ExTeal.FieldFilter.html","title":"ExTeal.FieldFilter","type":"behaviour"},{"doc":"Default serialization of a field filter","ref":"ExTeal.FieldFilter.html#default_serialization/3","title":"ExTeal.FieldFilter.default_serialization/3","type":"function"},{"doc":"Build a field filter by extending the incoming query with the following arguments:\n\n- The query being built (Ecto.Queryable from the Index module)\n- The configuration of the field filter as a string keyed map:\n  - \"operator\" a string representing the operation selected by\n    the user that is being performed\n  - \"operand\" a string or map representing the value to apply against the operand and query\n- The field struct being queried\n- The resource module for the resource being queried","ref":"ExTeal.FieldFilter.html#c:filter/4","title":"ExTeal.FieldFilter.filter/4","type":"callback"},{"doc":"Iterates over a resources fields, and serializes them into a response\nthat can be used by the vue app to build some logic","ref":"ExTeal.FieldFilter.html#for_resource/2","title":"ExTeal.FieldFilter.for_resource/2","type":"function"},{"doc":"Type of filter component to use in the user interface.","ref":"ExTeal.FieldFilter.html#c:interface_type/0","title":"ExTeal.FieldFilter.interface_type/0","type":"callback"},{"doc":"Define the available operators for the filter and the behaviour of each.\n\nEach available operator is defined by a map with the following keys:\n- `op` (required) the operator being defined\n- `no_operand` (optional) set to true for an operator that does not require an operand.\n- `component` (optional) override the default operand component, which defaults to a string field.","ref":"ExTeal.FieldFilter.html#c:operators/1","title":"ExTeal.FieldFilter.operators/1","type":"callback"},{"doc":"Iterate over the fields from an index query, build the related field\nfilter and apply their queries.","ref":"ExTeal.FieldFilter.html#query/4","title":"ExTeal.FieldFilter.query/4","type":"function"},{"doc":"Builds the map that allows the user interface to represent the field filter\nand all of it's configuration.\n\nCan be configured for customization on a per filter basis.","ref":"ExTeal.FieldFilter.html#c:serialize/2","title":"ExTeal.FieldFilter.serialize/2","type":"callback"},{"doc":"","ref":"ExTeal.FieldFilter.html#t:serialized_filter/0","title":"ExTeal.FieldFilter.serialized_filter/0","type":"type"},{"doc":"","ref":"ExTeal.FieldFilter.html#t:valid_type/0","title":"ExTeal.FieldFilter.valid_type/0","type":"type"},{"doc":"Field Filter for belongs to fields","ref":"ExTeal.FieldFilter.BelongsTo.html","title":"ExTeal.FieldFilter.BelongsTo","type":"module"},{"doc":"Field Filter for boolean fields\n\nAvailable operators are:\n\n* `true`\n* `false`","ref":"ExTeal.FieldFilter.Boolean.html","title":"ExTeal.FieldFilter.Boolean","type":"module"},{"doc":"Field Filter for date fields\n\nAvailable operators are:\n\n* `=`\n* `!=`\n* `>`\n* `>=`\n* `<`\n* `<=`\n* `is empty`\n* `not empty`","ref":"ExTeal.FieldFilter.Date.html","title":"ExTeal.FieldFilter.Date","type":"module"},{"doc":"Field Filter for date time fields\n\nAvailable operators are:\n\n* `=`\n* `!=`\n* `>`\n* `>=`\n* `<`\n* `<=`\n* `is empty`\n* `not empty`","ref":"ExTeal.FieldFilter.DateTime.html","title":"ExTeal.FieldFilter.DateTime","type":"module"},{"doc":"","ref":"ExTeal.FieldFilter.DateTime.html#value_cast_to_field_type/3","title":"ExTeal.FieldFilter.DateTime.value_cast_to_field_type/3","type":"function"},{"doc":"Field Filter for number fields\n\nAvailable operators are:\n\n* `=`\n* `!=`\n* `>`\n* `>=`\n* `<`\n* `<=`\n* `is empty`\n* `not empty`","ref":"ExTeal.FieldFilter.Number.html","title":"ExTeal.FieldFilter.Number","type":"module"},{"doc":"Simple Field Filter that builds operators\nfrom the options stored on the field","ref":"ExTeal.FieldFilter.Select.html","title":"ExTeal.FieldFilter.Select","type":"module"},{"doc":"Field Filter for text fields\n\nAvailable operators are:\n\n* `=`\n* `!=`\n* `contains`\n* `does not contain`\n* `is empty`\n* `not empty`","ref":"ExTeal.FieldFilter.Text.html","title":"ExTeal.FieldFilter.Text","type":"module"},{"doc":"Functions that allow a resource to configure\nwhich fields can be displayed on which parts\nof the resource.","ref":"ExTeal.FieldVisibility.html","title":"ExTeal.FieldVisibility","type":"module"},{"doc":"Marks the field as safe to render as html","ref":"ExTeal.FieldVisibility.html#as_html/1","title":"ExTeal.FieldVisibility.as_html/1","type":"function"},{"doc":"Conditionally render a field on a resource as a whole based on the current\nrequest.  Helpful for filtering out fields based on the current\nusers permissions.","ref":"ExTeal.FieldVisibility.html#can_see?/2","title":"ExTeal.FieldVisibility.can_see?/2","type":"function"},{"doc":"Field is only visible on Details and Index","ref":"ExTeal.FieldVisibility.html#except_on_forms/1","title":"ExTeal.FieldVisibility.except_on_forms/1","type":"function"},{"doc":"Hide field is hidden on the detail","ref":"ExTeal.FieldVisibility.html#hide_from_detail/1","title":"ExTeal.FieldVisibility.hide_from_detail/1","type":"function"},{"doc":"Hide field is hidden on the index","ref":"ExTeal.FieldVisibility.html#hide_from_index/1","title":"ExTeal.FieldVisibility.hide_from_index/1","type":"function"},{"doc":"Hide field is hidden when creating a resource","ref":"ExTeal.FieldVisibility.html#hide_when_creating/1","title":"ExTeal.FieldVisibility.hide_when_creating/1","type":"function"},{"doc":"Hide field is hidden when updating a resource","ref":"ExTeal.FieldVisibility.html#hide_when_updating/1","title":"ExTeal.FieldVisibility.hide_when_updating/1","type":"function"},{"doc":"Field is only visible on Details","ref":"ExTeal.FieldVisibility.html#only_on_details/1","title":"ExTeal.FieldVisibility.only_on_details/1","type":"function"},{"doc":"Field is only visible on Create and New","ref":"ExTeal.FieldVisibility.html#only_on_forms/1","title":"ExTeal.FieldVisibility.only_on_forms/1","type":"function"},{"doc":"Field is only visible on Index","ref":"ExTeal.FieldVisibility.html#only_on_index/1","title":"ExTeal.FieldVisibility.only_on_index/1","type":"function"},{"doc":"Marks a relational field as searchable\n\nOnly applies to many to many relationships","ref":"ExTeal.FieldVisibility.html#searchable/1","title":"ExTeal.FieldVisibility.searchable/1","type":"function"},{"doc":"Show field on the index","ref":"ExTeal.FieldVisibility.html#show_on_index/1","title":"ExTeal.FieldVisibility.show_on_index/1","type":"function"},{"doc":"Stack a fields value or form underneath its label","ref":"ExTeal.FieldVisibility.html#stacked/1","title":"ExTeal.FieldVisibility.stacked/1","type":"function"},{"doc":"The `Array` field may be used to represent an Ecto `array`.","ref":"ExTeal.Fields.Array.html","title":"ExTeal.Fields.Array","type":"module"},{"doc":"","ref":"ExTeal.Fields.Array.html#apply_options_for/4","title":"ExTeal.Fields.Array.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#as_html/0","title":"ExTeal.Fields.Array.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#component/0","title":"ExTeal.Fields.Array.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#default_sortable/0","title":"ExTeal.Fields.Array.default_sortable/0","type":"function"},{"doc":"Enable a draggable ui for the field, allowing a user to reorder the items in the array","ref":"ExTeal.Fields.Array.html#draggable/1","title":"ExTeal.Fields.Array.draggable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#field_name/2","title":"ExTeal.Fields.Array.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#filterable_as/0","title":"ExTeal.Fields.Array.filterable_as/0","type":"function"},{"doc":"Hide the 'create button' in the user interface","ref":"ExTeal.Fields.Array.html#hide_create_button/1","title":"ExTeal.Fields.Array.hide_create_button/1","type":"function"},{"doc":"Put the 'add item' at the bottom of the list instead of the tops","ref":"ExTeal.Fields.Array.html#list_above/1","title":"ExTeal.Fields.Array.list_above/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#make/2","title":"ExTeal.Fields.Array.make/2","type":"function"},{"doc":"Set a maximum height of the list in pixels","ref":"ExTeal.Fields.Array.html#max_height/2","title":"ExTeal.Fields.Array.max_height/2","type":"function"},{"doc":"Set a maximum number of items in the list","ref":"ExTeal.Fields.Array.html#max_items/2","title":"ExTeal.Fields.Array.max_items/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#options/0","title":"ExTeal.Fields.Array.options/0","type":"function"},{"doc":"Set the placeholder for the 'add item' inputs","ref":"ExTeal.Fields.Array.html#placeholder/2","title":"ExTeal.Fields.Array.placeholder/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#prefix_component/0","title":"ExTeal.Fields.Array.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#sanitize_as/0","title":"ExTeal.Fields.Array.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_detail/0","title":"ExTeal.Fields.Array.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_edit/0","title":"ExTeal.Fields.Array.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_index/0","title":"ExTeal.Fields.Array.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_new/0","title":"ExTeal.Fields.Array.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#value_for/3","title":"ExTeal.Fields.Array.value_for/3","type":"function"},{"doc":"The `BelongsTo` field corresponds to a `belongs_to` ecto relationship.  For example,\nlet's assume a `Post` schema `belongs_to` a `User` schema.  We may add the relationship\nto our `Post` ExTeal resource like so:\n\n    alias ExTeal.Fields.BelongsTo\n\n    BelongsTo.make(:user)","ref":"ExTeal.Fields.BelongsTo.html","title":"ExTeal.Fields.BelongsTo","type":"module"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#as_html/0","title":"ExTeal.Fields.BelongsTo.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#component/0","title":"ExTeal.Fields.BelongsTo.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#default_sortable/0","title":"ExTeal.Fields.BelongsTo.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#field_name/2","title":"ExTeal.Fields.BelongsTo.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#make/2","title":"ExTeal.Fields.BelongsTo.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#options/0","title":"ExTeal.Fields.BelongsTo.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#prefix_component/0","title":"ExTeal.Fields.BelongsTo.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#sanitize_as/0","title":"ExTeal.Fields.BelongsTo.sanitize_as/0","type":"function"},{"doc":"Mark a Belongs To Field as searchable, allowing the UX to\nsearch the related resource for matches in the create and update forms","ref":"ExTeal.Fields.BelongsTo.html#searchable/1","title":"ExTeal.Fields.BelongsTo.searchable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_detail/0","title":"ExTeal.Fields.BelongsTo.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_edit/0","title":"ExTeal.Fields.BelongsTo.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_index/0","title":"ExTeal.Fields.BelongsTo.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_new/0","title":"ExTeal.Fields.BelongsTo.show_on_new/0","type":"function"},{"doc":"A group of boolean inputs that represent a map, or embedded schema\nwhere each value is a boolean.  Useful for embedding features, permissions,\nor roles into a schema.\n\nIf the field represents and embedded schema as an `embeds_one`, the field\nwill set a default set of options based on the fields of the embedded schema.\nIt assumes that every field in the embed is a boolean:\n\n    defmodule Permissions do\n      use Ecto.Schema\n\n      embedded_schema do\n        field :read, :boolean, default: false\n        field :write, :boolean, default: false\n        field :delete, :boolean, default: false\n      end\n\n      def changeset(permissions, attrs) do\n        cast(permission, attrs, [:read, :write, :delete])\n      end\n    end\n\n    defmodule Post do\n      use Ecto.Schema\n\n      schema \"posts\" do\n        field :title, :string\n        embeds_one :permissions, Permissions\n      end\n    end\n\n\n    def PostResource do\n      use ExTeal.Resource\n      def model, do: Post\n\n      def fields, do: [\n        Text.make(:title),\n        BooleanGroup.make(:permissions)\n      ]\n    end\n\nYou can also define a boolean group over a plain map type and manually\ndefine the options as a map of keys and labels:\n\n    defmodule Post do\n      use Ecto.Schema\n\n      schema \"posts\" do\n        field :title, :string\n        field :permissions, :map\n      end\n    end\n\n    def PostResource do\n      use ExTeal.Resource\n      def model, do: Post\n\n      def fields, do: [\n        Text.make(:title),\n        BooleanGroup.make(:permissions)\n        |> BooleanGroup.options(%{\n          \"read\" => \"Read\",\n          \"write\" => \"Write\"\n        })\n      ]\n    end\n\nThe `options` function can also be used to override the default options\nwhen used with an embedded schema if the options need to be translated into\nhuman readable values.","ref":"ExTeal.Fields.BooleanGroup.html","title":"ExTeal.Fields.BooleanGroup","type":"module"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#as_html/0","title":"ExTeal.Fields.BooleanGroup.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#component/0","title":"ExTeal.Fields.BooleanGroup.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#field_name/2","title":"ExTeal.Fields.BooleanGroup.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#filterable_as/0","title":"ExTeal.Fields.BooleanGroup.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#make/2","title":"ExTeal.Fields.BooleanGroup.make/2","type":"function"},{"doc":"Customize the text displayed in the event that a field contains no values.","ref":"ExTeal.Fields.BooleanGroup.html#no_value_text/2","title":"ExTeal.Fields.BooleanGroup.no_value_text/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#options/0","title":"ExTeal.Fields.BooleanGroup.options/0","type":"function"},{"doc":"Add the available options to manage in the boolean group","ref":"ExTeal.Fields.BooleanGroup.html#options/2","title":"ExTeal.Fields.BooleanGroup.options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#prefix_component/0","title":"ExTeal.Fields.BooleanGroup.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_detail/0","title":"ExTeal.Fields.BooleanGroup.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_edit/0","title":"ExTeal.Fields.BooleanGroup.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_index/0","title":"ExTeal.Fields.BooleanGroup.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_new/0","title":"ExTeal.Fields.BooleanGroup.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#value_for/3","title":"ExTeal.Fields.BooleanGroup.value_for/3","type":"function"},{"doc":"The `Date` field may be used to generate a calendar date select.\n\nThe date format for display on the index and detail views may be defined using the `Select.with_options/2` function:\n\n    Date.make(:date)\n    |> Date.with_options(%{\"format\" => \"YYYY/MM/DD\"})","ref":"ExTeal.Fields.Date.html","title":"ExTeal.Fields.Date","type":"module"},{"doc":"","ref":"ExTeal.Fields.Date.html#apply_options_for/4","title":"ExTeal.Fields.Date.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#as_html/0","title":"ExTeal.Fields.Date.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#component/0","title":"ExTeal.Fields.Date.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#default_sortable/0","title":"ExTeal.Fields.Date.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#field_name/2","title":"ExTeal.Fields.Date.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#filterable_as/0","title":"ExTeal.Fields.Date.filterable_as/0","type":"function"},{"doc":"Set the format that the date is rendered with on the detail and index components.\n\nUses [luxon's toLocaleString](https://moment.github.io/luxon/docs/manual/formatting.html#tolocalestring--strings-for-humans-)\nto display the date in a localized format:\n\nExamples:\n\n:short\nen_US -> 10/14/1983\nfr    -> 14/10/1983\n\n:med\nen_US -> Oct 14, 1983\nfr    -> 14 oct. 1983\n\n:full \nen_US -> October 14, 1983\nfr    -> 14 octobre 1983\n\n:huge\nen_US -> Tuesday, October 14, 1983\nfr    -> vendredi 14 octobre 1983","ref":"ExTeal.Fields.Date.html#format/2","title":"ExTeal.Fields.Date.format/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#make/2","title":"ExTeal.Fields.Date.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#options/0","title":"ExTeal.Fields.Date.options/0","type":"function"},{"doc":"Set the format that flatpickr will render the date in on forms. \n\nFormat should be a string of [flatpickr tokens](https://flatpickr.js.org/formatting/)","ref":"ExTeal.Fields.Date.html#picker_format/2","title":"ExTeal.Fields.Date.picker_format/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#prefix_component/0","title":"ExTeal.Fields.Date.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#sanitize_as/0","title":"ExTeal.Fields.Date.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_detail/0","title":"ExTeal.Fields.Date.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_edit/0","title":"ExTeal.Fields.Date.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_index/0","title":"ExTeal.Fields.Date.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_new/0","title":"ExTeal.Fields.Date.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#value_for/3","title":"ExTeal.Fields.Date.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#with_options/2","title":"ExTeal.Fields.Date.with_options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#t:valid_format/0","title":"ExTeal.Fields.Date.valid_format/0","type":"type"},{"doc":"Generates a panel that contains a list of cards that represent the embedded\nassociations of the given schema.","ref":"ExTeal.Fields.EmbedsMany.html","title":"ExTeal.Fields.EmbedsMany","type":"module"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#as_html/0","title":"ExTeal.Fields.EmbedsMany.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#component/0","title":"ExTeal.Fields.EmbedsMany.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#default_sortable/0","title":"ExTeal.Fields.EmbedsMany.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#field_name/2","title":"ExTeal.Fields.EmbedsMany.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#fields/2","title":"ExTeal.Fields.EmbedsMany.fields/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#filterable_as/0","title":"ExTeal.Fields.EmbedsMany.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#make/2","title":"ExTeal.Fields.EmbedsMany.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#options/0","title":"ExTeal.Fields.EmbedsMany.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#prefix_component/0","title":"ExTeal.Fields.EmbedsMany.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#show_on_detail/0","title":"ExTeal.Fields.EmbedsMany.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#show_on_edit/0","title":"ExTeal.Fields.EmbedsMany.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#show_on_index/0","title":"ExTeal.Fields.EmbedsMany.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.EmbedsMany.html#show_on_new/0","title":"ExTeal.Fields.EmbedsMany.show_on_new/0","type":"function"},{"doc":"The `HasMany` field corresponds to a `has_many` ecto relationship.  For example,\nlet's assume a `User` schema has many `Post` schema.  We may add the relationship\nto our `User` ExTeal resource like so:\n\n    alias ExTeal.Fields.HasMany\n\n    HasMany.make(:posts)","ref":"ExTeal.Fields.HasMany.html","title":"ExTeal.Fields.HasMany","type":"module"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#apply_options_for/4","title":"ExTeal.Fields.HasMany.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#as_html/0","title":"ExTeal.Fields.HasMany.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#component/0","title":"ExTeal.Fields.HasMany.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#default_sortable/0","title":"ExTeal.Fields.HasMany.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#field_name/2","title":"ExTeal.Fields.HasMany.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#filterable_as/0","title":"ExTeal.Fields.HasMany.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#make/2","title":"ExTeal.Fields.HasMany.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#options/0","title":"ExTeal.Fields.HasMany.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#prefix_component/0","title":"ExTeal.Fields.HasMany.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#sanitize_as/0","title":"ExTeal.Fields.HasMany.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_detail/0","title":"ExTeal.Fields.HasMany.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_edit/0","title":"ExTeal.Fields.HasMany.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_index/0","title":"ExTeal.Fields.HasMany.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_new/0","title":"ExTeal.Fields.HasMany.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#value_for/3","title":"ExTeal.Fields.HasMany.value_for/3","type":"function"},{"doc":"Define a list of custom index fields to use when displaying the has many\nrelationship.\n\n    HasMany.make(:posts)\n    |> HasMany.with_index_fields([\n      Text.make(:title)\n    ])\n\nThis list of fields will override the fields used when displaying, sorting,\nand filtering the related table.","ref":"ExTeal.Fields.HasMany.html#with_index_fields/2","title":"ExTeal.Fields.HasMany.with_index_fields/2","type":"function"},{"doc":"The `HasOne` field corresponds to a `has_one` ecto relationship.  For example,\nlet's assume a `Post` schema `has_one` `PermaLink` schema.  We may add the relationship\nto our `Post` ExTeal resource like so:\n\n    alias ExTeal.Fields.HasOne\n\n    HasOne.make(:permalink)\n\n# Title Attributes\n\nWhen a `HasOne` field is shown on an associated `BelongsTo` resources index/detail screen, the associated\nrow will have a link to the `HasOne` and will display the \"title\" of the resource.  For example, a\n`permalink` resource may display the `address` attribute as it's title.  Then, when the resource\nis shown as an association on the belongs_to index or detail views, that attribute will be displayed, supported attributes are `name`, `title`, or `address`.","ref":"ExTeal.Fields.HasOne.html","title":"ExTeal.Fields.HasOne","type":"module"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#as_html/0","title":"ExTeal.Fields.HasOne.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#component/0","title":"ExTeal.Fields.HasOne.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#default_sortable/0","title":"ExTeal.Fields.HasOne.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#field_name/2","title":"ExTeal.Fields.HasOne.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#filterable_as/0","title":"ExTeal.Fields.HasOne.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#make/2","title":"ExTeal.Fields.HasOne.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#options/0","title":"ExTeal.Fields.HasOne.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#prefix_component/0","title":"ExTeal.Fields.HasOne.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#sanitize_as/0","title":"ExTeal.Fields.HasOne.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_detail/0","title":"ExTeal.Fields.HasOne.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_edit/0","title":"ExTeal.Fields.HasOne.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_index/0","title":"ExTeal.Fields.HasOne.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_new/0","title":"ExTeal.Fields.HasOne.show_on_new/0","type":"function"},{"doc":"A hidden field is a field that is not shown on the index or detail pages, but is still\nrendered on forms for use with embedded fields that have ids.","ref":"ExTeal.Fields.Hidden.html","title":"ExTeal.Fields.Hidden","type":"module"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#apply_options_for/4","title":"ExTeal.Fields.Hidden.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#as_html/0","title":"ExTeal.Fields.Hidden.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#component/0","title":"ExTeal.Fields.Hidden.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#default_sortable/0","title":"ExTeal.Fields.Hidden.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#field_name/2","title":"ExTeal.Fields.Hidden.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#make/2","title":"ExTeal.Fields.Hidden.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#options/0","title":"ExTeal.Fields.Hidden.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#prefix_component/0","title":"ExTeal.Fields.Hidden.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#sanitize_as/0","title":"ExTeal.Fields.Hidden.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_detail/0","title":"ExTeal.Fields.Hidden.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_edit/0","title":"ExTeal.Fields.Hidden.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_index/0","title":"ExTeal.Fields.Hidden.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_new/0","title":"ExTeal.Fields.Hidden.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#value_for/3","title":"ExTeal.Fields.Hidden.value_for/3","type":"function"},{"doc":"The `ManyToMany` field corresponds to a `many_to_many` ecto relationship.  For example,\nlet's assume a `User` schema has a `many_to_many` relationship with a `Role` schema.\nWe can add the relationship to our `User` resource like so:\n\n    alias ExTeal.Fields.ManyToMany\n\n    ManyToMany.make(:roles)","ref":"ExTeal.Fields.ManyToMany.html","title":"ExTeal.Fields.ManyToMany","type":"module"},{"doc":"Let's assume we have a `User` schema with a `many_to_many` relationship with a `Role` schema.  The pivot\nschema has a :primary boolean field.  We want to display the `Role`'s name and the `User`'s email and\nthe primary boolean field on the index table of 'Roles' for a 'User'. We can do this by defining:\n\n    ManyToMany.make(:roles, Role)\n    |> ManyToMany.with_pivot_fields([ExTeal.Fields.Boolean.make(:primary)])\n\nThe relationship table, attach and edit-attached interfaces now all a user to manage the 'primary' field\nwhich only exists on the pivot table.","ref":"ExTeal.Fields.ManyToMany.html#module-customizing-index-tables","title":"Customizing Index Tables - ExTeal.Fields.ManyToMany","type":"module"},{"doc":"By default, the ManyToMany field produces a `ManyToManyBelongsTo` field on the index table.  This field\nappears as a BelongsTo field, providing the title for the linked resource and a link to the detail page\nof the linked asset, in the previous example 'Role'.  There are times where you might need to customize\nthe index table, overriding the `ManyToManyBelongsTo` and providing a unique list of fields to display.\n\nEnter `with_index_fields/2` and `with_index_query/2`.  By default, Teal queries for both the related resource\nand the join to the current resource via some of the meta data associated with the underlying `Ecto.Assoc`\nstruct.  The results are then loaded in a custom resource lookup select query.  When extending the default\nmany-to-many functionality, the query must return a `ExTeal.Resource.pivot_resource()` type.\n\n#","ref":"ExTeal.Fields.ManyToMany.html#module-customizing-index-tables","title":"Customizing Index Tables - ExTeal.Fields.ManyToMany","type":"module"},{"doc":"Assume a `User` has many to many with `Org` through a `Membership` schema.  `Membership` has a role field and we want to display some\nextra information in the `Org` many-to-many table for a user.  We could define that as:\n\n    ManyToMany.make(:orgs, Org)\n    |> ManyToMany.with_index_fields([\n      ExTeal.Fields.Text.make(:name)\n      ExTeal.Fields.Boolean.make(:active),\n      ExTeal.Fields.Select.make(:org_type),\n      ExTeal.Fields.Number.make(:member_count) |> ExTeal.Field.virtual()\n    ])\n    |> ManyToMany.with_index_query(fn query, _assoc, _resource_id ->\n      query\n      |> Ecto.Query.join(:left, [o], m in assoc(o, :memberships))\n      |> Ecto.Query.select(query, [o, x, m], %{\n        _row: %{\n          name: o.name,\n          active: o.active,\n          org_type: o.org_type,\n          member_count: selected_as(count(m.id), :member_count)\n        },\n        _pivot: x,\n        pivot: true\n      })\n      |> Ecto.Query.group_by([o, x], [o.id, x.org_id])\n    end)\n    |> ManyToMany.with_pivot_fields([ExTeal.Fields.Select.make(:role)])\n\nWhat a query, what a pipe. There are some conditions here.  This functionality is only available when\na `many_to_many` assocation is defined with a join_through schema.  If the many to many is joined\nonly through the table name, you may be able to customize the index fields by defining a `with_index_fields/2`\nand ignoring the `with_index_query/2` function.  If you need to customize the query, you can do so by\nsimply returning a full schema and avoiding the `ExTeal.Resource.pivot_resource()` type.","ref":"ExTeal.Fields.ManyToMany.html#module-example","title":"Example - ExTeal.Fields.ManyToMany","type":"module"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#apply_options_for/4","title":"ExTeal.Fields.ManyToMany.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#as_html/0","title":"ExTeal.Fields.ManyToMany.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#component/0","title":"ExTeal.Fields.ManyToMany.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#default_sortable/0","title":"ExTeal.Fields.ManyToMany.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#field_name/2","title":"ExTeal.Fields.ManyToMany.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#filterable_as/0","title":"ExTeal.Fields.ManyToMany.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#index_fields/3","title":"ExTeal.Fields.ManyToMany.index_fields/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#make/2","title":"ExTeal.Fields.ManyToMany.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#make/3","title":"ExTeal.Fields.ManyToMany.make/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#options/0","title":"ExTeal.Fields.ManyToMany.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#prefix_component/0","title":"ExTeal.Fields.ManyToMany.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#sanitize_as/0","title":"ExTeal.Fields.ManyToMany.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_detail/0","title":"ExTeal.Fields.ManyToMany.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_edit/0","title":"ExTeal.Fields.ManyToMany.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_index/0","title":"ExTeal.Fields.ManyToMany.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_new/0","title":"ExTeal.Fields.ManyToMany.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#sortable_by/2","title":"ExTeal.Fields.ManyToMany.sortable_by/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#value_for/3","title":"ExTeal.Fields.ManyToMany.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_index_fields/2","title":"ExTeal.Fields.ManyToMany.with_index_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_index_query/2","title":"ExTeal.Fields.ManyToMany.with_index_query/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_pivot_fields/2","title":"ExTeal.Fields.ManyToMany.with_pivot_fields/2","type":"function"},{"doc":"Internal Field that replicates a belongs to field for display during an\nindex query of a many to many relationship.","ref":"ExTeal.Fields.ManyToManyBelongsTo.html","title":"ExTeal.Fields.ManyToManyBelongsTo","type":"module"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#apply_options_for/4","title":"ExTeal.Fields.ManyToManyBelongsTo.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#as_html/0","title":"ExTeal.Fields.ManyToManyBelongsTo.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#component/0","title":"ExTeal.Fields.ManyToManyBelongsTo.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#default_sortable/0","title":"ExTeal.Fields.ManyToManyBelongsTo.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#field_name/2","title":"ExTeal.Fields.ManyToManyBelongsTo.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#filterable_as/0","title":"ExTeal.Fields.ManyToManyBelongsTo.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#make/2","title":"ExTeal.Fields.ManyToManyBelongsTo.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#make/3","title":"ExTeal.Fields.ManyToManyBelongsTo.make/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#options/0","title":"ExTeal.Fields.ManyToManyBelongsTo.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#prefix_component/0","title":"ExTeal.Fields.ManyToManyBelongsTo.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#sanitize_as/0","title":"ExTeal.Fields.ManyToManyBelongsTo.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_detail/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_edit/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_index/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_new/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#value_for/3","title":"ExTeal.Fields.ManyToManyBelongsTo.value_for/3","type":"function"},{"doc":"The `MultiSelect` field may be used to generate a drop-down menu with multiple fields.\n\nThe select menu's options may be defined using the `MultiSelect/with_options/2` function:\n\n    MultiSelect.make(:regions)\n    |> MultiSelect.with_options([%{value: 1, label: \"USA\"}, %{value: 2, label: \"EU\"}])\n\nYou can also return a list of maps with `value`, `title`, `subtitle` and `thumbnail` keys\nto use 'card' style taggables, useful when the multiselect represents a relationship.","ref":"ExTeal.Fields.MultiSelect.html","title":"ExTeal.Fields.MultiSelect","type":"module"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#apply_options_for/4","title":"ExTeal.Fields.MultiSelect.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#as_html/0","title":"ExTeal.Fields.MultiSelect.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#component/0","title":"ExTeal.Fields.MultiSelect.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#default_sortable/0","title":"ExTeal.Fields.MultiSelect.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#field_name/2","title":"ExTeal.Fields.MultiSelect.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#filterable_as/0","title":"ExTeal.Fields.MultiSelect.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#get/2","title":"ExTeal.Fields.MultiSelect.get/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#make/2","title":"ExTeal.Fields.MultiSelect.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#options/0","title":"ExTeal.Fields.MultiSelect.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#prefix_component/0","title":"ExTeal.Fields.MultiSelect.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#sanitize_as/0","title":"ExTeal.Fields.MultiSelect.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_detail/0","title":"ExTeal.Fields.MultiSelect.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_edit/0","title":"ExTeal.Fields.MultiSelect.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_index/0","title":"ExTeal.Fields.MultiSelect.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_new/0","title":"ExTeal.Fields.MultiSelect.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#value_for/3","title":"ExTeal.Fields.MultiSelect.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#with_options/2","title":"ExTeal.Fields.MultiSelect.with_options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:card_option/0","title":"ExTeal.Fields.MultiSelect.card_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:simple_option/0","title":"ExTeal.Fields.MultiSelect.simple_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:valid_option/0","title":"ExTeal.Fields.MultiSelect.valid_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:valid_options/0","title":"ExTeal.Fields.MultiSelect.valid_options/0","type":"type"},{"doc":"The `Select` field may be used to generate a drop-down select menu.\n\nThe select menu's options may be defined using the `Select.options/2` function:\n\n    Select.make(:size)\n    |> Select.options([\"Small\", \"Medium\"])","ref":"ExTeal.Fields.Select.html","title":"ExTeal.Fields.Select","type":"module"},{"doc":"","ref":"ExTeal.Fields.Select.html#all_options_for/1","title":"ExTeal.Fields.Select.all_options_for/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#as_html/0","title":"ExTeal.Fields.Select.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#component/0","title":"ExTeal.Fields.Select.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#default_sortable/0","title":"ExTeal.Fields.Select.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#display_using_labels/1","title":"ExTeal.Fields.Select.display_using_labels/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#field_name/2","title":"ExTeal.Fields.Select.field_name/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#make/2","title":"ExTeal.Fields.Select.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#options/0","title":"ExTeal.Fields.Select.options/0","type":"function"},{"doc":"Define the options for the select field.  The function accepts a list of\noptions that are either strings or maps with of `value` and `label` keys.  If\nthe list members are strings, the value will be used for both the value and label\nof the ` ` element it represents.\n\n`options` are expected to be an enumerable which will be used to generate\neach respective `option`.  The enumerable may have:\n\n  * keyword lists - each keyword list is expected to have the keys `:key` and\n    `:value`.  Additional keys such as `:disabled` may be given to customize\n    the option\n\n  * two-item tuples - where the first element is an atom, string or integer to\n    be used as the option label and the second element is an atom, string or\n    integer to be used as the option value\n\n  * atom, string or integer - which will be used as both label and value for\n    the generated select","ref":"ExTeal.Fields.Select.html#options/2","title":"ExTeal.Fields.Select.options/2","type":"function"},{"doc":"If `options` is a map or keyword list where the firs element is a string, atom,\nor integer and the second element is a list or a map, it is assumed the key\nwill be wrapped in an ` ` and teh value will be used to generate\n` ` nested under the group.\n\nThis functionality is equivalent to `Phoenix.HTML.Form.select/3`","ref":"ExTeal.Fields.Select.html#options/2-optgroups","title":"Optgroups - ExTeal.Fields.Select.options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#prefix_component/0","title":"ExTeal.Fields.Select.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#sanitize_as/0","title":"ExTeal.Fields.Select.sanitize_as/0","type":"function"},{"doc":"At times it's convenient to be able to search or filter the list of options in a\nselect field.  You can enable this by calling `Select.searchable` on the field:\n\n    Select.make(:type) |> Select.options(~w(foo bar)) |> Select.searchable()\n\nWhen using this field, Teal will display an input field which allows you to filter\nthe list based on it's key.","ref":"ExTeal.Fields.Select.html#searchable/1","title":"ExTeal.Fields.Select.searchable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_detail/0","title":"ExTeal.Fields.Select.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_edit/0","title":"ExTeal.Fields.Select.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_index/0","title":"ExTeal.Fields.Select.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_new/0","title":"ExTeal.Fields.Select.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#with_options/2","title":"ExTeal.Fields.Select.with_options/2","type":"function"},{"doc":"Functionality for searching across a collection of resources using a single search term.","ref":"ExTeal.GlobalSearch.html","title":"ExTeal.GlobalSearch","type":"module"},{"doc":"","ref":"ExTeal.GlobalSearch.html#new/2","title":"ExTeal.GlobalSearch.new/2","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#render/1","title":"ExTeal.GlobalSearch.render/1","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#run/1","title":"ExTeal.GlobalSearch.run/1","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#t:t/0","title":"ExTeal.GlobalSearch.t/0","type":"type"},{"doc":"The default auth provider that allows all access to ExTeal.  Should not be\nused in production!","ref":"ExTeal.GuestAuthProvider.html","title":"ExTeal.GuestAuthProvider","type":"module"},{"doc":"","ref":"ExTeal.GuestAuthProvider.html#current_user_for/1","title":"ExTeal.GuestAuthProvider.current_user_for/1","type":"function"},{"doc":"","ref":"ExTeal.GuestAuthProvider.html#dropdown_content/1","title":"ExTeal.GuestAuthProvider.dropdown_content/1","type":"function"},{"doc":"Card that sits on the main, default dashboard","ref":"ExTeal.HelpCard.html","title":"ExTeal.HelpCard","type":"module"},{"doc":"","ref":"ExTeal.HelpCard.html#only_on_detail/1","title":"ExTeal.HelpCard.only_on_detail/1","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#only_on_index/1","title":"ExTeal.HelpCard.only_on_index/1","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#options/1","title":"ExTeal.HelpCard.options/1","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#title/0","title":"ExTeal.HelpCard.title/0","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#uri/0","title":"ExTeal.HelpCard.uri/0","type":"function"},{"doc":"Behavior for configuring and defining ExTeal","ref":"ExTeal.Manifest.html","title":"ExTeal.Manifest","type":"module"},{"doc":"Describes the behaviour of a metric with specific callbacks for\nbuilding a base result, calculating the values, applying then and returning\nthe result","ref":"ExTeal.Metric.html","title":"ExTeal.Metric","type":"behaviour"},{"doc":"Define the options that are passed as a metrics options map as it's\nreturned as part of a metric result.","ref":"ExTeal.Metric.html#c:chart_options/0","title":"ExTeal.Metric.chart_options/0","type":"callback"},{"doc":"The name of the component to mount in the ux responsible for rendering\nthe content","ref":"ExTeal.Metric.html#c:component/0","title":"ExTeal.Metric.component/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:date_field/0","title":"ExTeal.Metric.date_field/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:date_field_type/0","title":"ExTeal.Metric.date_field_type/0","type":"callback"},{"doc":"Define the range to render by default for a metric.","ref":"ExTeal.Metric.html#c:default_range/0","title":"ExTeal.Metric.default_range/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#default_ranges/0","title":"ExTeal.Metric.default_ranges/0","type":"function"},{"doc":"A string representing how a value is formatted before being displayed by the\n[numbro](https://numbrojs.com/) library.  Defaults to `0,0`","ref":"ExTeal.Metric.html#c:format/0","title":"ExTeal.Metric.format/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:multiple_results/0","title":"ExTeal.Metric.multiple_results/0","type":"callback"},{"doc":"Only display the metric on the detail page of a specific resource.","ref":"ExTeal.Metric.html#c:only_on_detail/1","title":"ExTeal.Metric.only_on_detail/1","type":"callback"},{"doc":"Only display the metric on the index page of a specific resource.","ref":"ExTeal.Metric.html#c:only_on_index/1","title":"ExTeal.Metric.only_on_index/1","type":"callback"},{"doc":"Options that are serialized into the configuration of a metric card.\n\nUsed as part of a dashboard or card list on a resource index or detail page.","ref":"ExTeal.Metric.html#c:options/1","title":"ExTeal.Metric.options/1","type":"callback"},{"doc":"A string to prepend to any displayed value on the metric card. For example: `$`","ref":"ExTeal.Metric.html#c:prefix/0","title":"ExTeal.Metric.prefix/0","type":"callback"},{"doc":"Define which ranges are available for a metric.\n\nDefaults to `Metric.default_ranges/0` but can be overriden per metric.","ref":"ExTeal.Metric.html#c:ranges/0","title":"ExTeal.Metric.ranges/0","type":"callback"},{"doc":"A string to appended to any displayed value on the metric card.  For example: `°`","ref":"ExTeal.Metric.html#c:suffix/0","title":"ExTeal.Metric.suffix/0","type":"callback"},{"doc":"Set the title displayed at the top of the card, defaults\nto a humanized title of the module","ref":"ExTeal.Metric.html#c:title/0","title":"ExTeal.Metric.title/0","type":"callback"},{"doc":"Explicitly set the uri used to fetch the details of a card.","ref":"ExTeal.Metric.html#c:uri/0","title":"ExTeal.Metric.uri/0","type":"callback"},{"doc":"Set the width of card that displays the metric.  Defaults to 1/3.\n1/3 and full are the only allowed values","ref":"ExTeal.Metric.html#c:width/0","title":"ExTeal.Metric.width/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#t:range/0","title":"ExTeal.Metric.range/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.html#t:unit/0","title":"ExTeal.Metric.unit/0","type":"type"},{"doc":"Partition metrics displays a pie chart of values.","ref":"ExTeal.Metric.Partition.html","title":"ExTeal.Metric.Partition","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Partition.html#aggregate/5","title":"ExTeal.Metric.Partition.aggregate/5","type":"function"},{"doc":"","ref":"ExTeal.Metric.Partition.html#c:calculate/1","title":"ExTeal.Metric.Partition.calculate/1","type":"callback"},{"doc":"By default sort the partition results by the group field","ref":"ExTeal.Metric.Partition.html#default_order_by/2","title":"ExTeal.Metric.Partition.default_order_by/2","type":"function"},{"doc":"Often, the column values that divide your partition metrics into\ngroups will be simple keys, and not something that is human readable.\nOr, if you are displaying a partition metric grouped by a column that is a\nboolean, Teal will display labels as \"false\" and \"true\".  For this reason, Teal\nprovides the `label_for/1` callback that can be overriden on a partition metric\nto provide a custom label for each value.\n\n    @impl true\n    def label_for(false), do: \"User\"\n    def label_for(true), do: \"Admin\"\n\nIt's also useful for handling null values:\n\n    @impl true\n    def label_for(null), do: \"None\"\n    def label_for(key), do: String.capitalize(key)","ref":"ExTeal.Metric.Partition.html#c:label_for/1","title":"ExTeal.Metric.Partition.label_for/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Partition.html#t:result/0","title":"ExTeal.Metric.Partition.result/0","type":"type"},{"doc":"Trend Expressions for Postgresql databases","ref":"ExTeal.Metric.PostgresTrendExpression.html","title":"ExTeal.Metric.PostgresTrendExpression","type":"module"},{"doc":"Composeable Queries Helpers for Building Metrics","ref":"ExTeal.Metric.QueryHelpers.html","title":"ExTeal.Metric.QueryHelpers","type":"module"},{"doc":"","ref":"ExTeal.Metric.QueryHelpers.html#parse/1","title":"ExTeal.Metric.QueryHelpers.parse/1","type":"function"},{"doc":"Helper functions for building time intervals and\nqueries based on the params of a request.","ref":"ExTeal.Metric.Ranges.html","title":"ExTeal.Metric.Ranges","type":"module"},{"doc":"Set the boundaries of an aggregate queries","ref":"ExTeal.Metric.Ranges.html#between/2","title":"ExTeal.Metric.Ranges.between/2","type":"function"},{"doc":"Parse the start and end params","ref":"ExTeal.Metric.Ranges.html#get_aggregate_datetimes/1","title":"ExTeal.Metric.Ranges.get_aggregate_datetimes/1","type":"function"},{"doc":"","ref":"ExTeal.Metric.Ranges.html#parse_dt/3","title":"ExTeal.Metric.Ranges.parse_dt/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Ranges.html#t:between_options/0","title":"ExTeal.Metric.Ranges.between_options/0","type":"type"},{"doc":"Data Structure for building a Query for a Metric\n\nUsed by the Metric modules to build a data result\nthat is turned into a Metric Result","ref":"ExTeal.Metric.Request.html","title":"ExTeal.Metric.Request","type":"module"},{"doc":"","ref":"ExTeal.Metric.Request.html#from_conn/2","title":"ExTeal.Metric.Request.from_conn/2","type":"function"},{"doc":"","ref":"ExTeal.Metric.Request.html#t:t/0","title":"ExTeal.Metric.Request.t/0","type":"type"},{"doc":"A Data Structure returned and serialized by a successful\nValue Metric Query","ref":"ExTeal.Metric.Result.html","title":"ExTeal.Metric.Result","type":"module"},{"doc":"","ref":"ExTeal.Metric.Result.html#build/2","title":"ExTeal.Metric.Result.build/2","type":"function"},{"doc":"","ref":"ExTeal.Metric.Result.html#t:t/0","title":"ExTeal.Metric.Result.t/0","type":"type"},{"doc":"Trend metrics display the trend of a computed aggregate over a range\nof time.  For example, a trend metric might display the count of new users\ncreated every day for the last thirty days.\n\nA Trend metric offers the ability to chose both the range of time that is\nbeing displayed and the granularity of results.  The granularity is stored as\nas the `unit` singluar while the `ranges` includes all available units.\n\nThe available units are:\n- year\n- month\n- week\n- day\n- hour\n- minute\n\nSome of these data sets will be rather large, so we should provide some safe\ndefaults for the maximum number of results returned.","ref":"ExTeal.Metric.Trend.html","title":"ExTeal.Metric.Trend","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Trend.html#aggregate/6","title":"ExTeal.Metric.Trend.aggregate/6","type":"function"},{"doc":"Build a select for the field and aggregate type","ref":"ExTeal.Metric.Trend.html#aggregate_as/3","title":"ExTeal.Metric.Trend.aggregate_as/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:calculate/1","title":"ExTeal.Metric.Trend.calculate/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:cast/1","title":"ExTeal.Metric.Trend.cast/1","type":"callback"},{"doc":"Takes a database record transforms it into a two-tuple of the date_result\nparsed into an appropriate format","ref":"ExTeal.Metric.Trend.html#format_result_data/3","title":"ExTeal.Metric.Trend.format_result_data/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#get_possible_results/4","title":"ExTeal.Metric.Trend.get_possible_results/4","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:precision/0","title":"ExTeal.Metric.Trend.precision/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#to_local_dt/3","title":"ExTeal.Metric.Trend.to_local_dt/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#to_result_date/1","title":"ExTeal.Metric.Trend.to_result_date/1","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:twelve_hour_time/0","title":"ExTeal.Metric.Trend.twelve_hour_time/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:multi_result/0","title":"ExTeal.Metric.Trend.multi_result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:result/0","title":"ExTeal.Metric.Trend.result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:valid_result/0","title":"ExTeal.Metric.Trend.valid_result/0","type":"type"},{"doc":"Behaviour for trend expression builders","ref":"ExTeal.Metric.TrendExpression.html","title":"ExTeal.Metric.TrendExpression","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.TrendExpression.html#fetch_offset/2","title":"ExTeal.Metric.TrendExpression.fetch_offset/2","type":"function"},{"doc":"Use database specifc syntax to build an expression for both selecting\nand grouping by a given unit of time.  The function uses `select_merge` to\nbuild a date_result value assuming that a previous select has been used to\ngenerate a query for the aggregate.","ref":"ExTeal.Metric.TrendExpression.html#c:generate/5","title":"ExTeal.Metric.TrendExpression.generate/5","type":"callback"},{"doc":"","ref":"ExTeal.Metric.TrendExpression.html#t:valid_timezone/0","title":"ExTeal.Metric.TrendExpression.valid_timezone/0","type":"type"},{"doc":"Factory for selecting the implementation to generate a date factory\nbased on the specific database adapter (and database).","ref":"ExTeal.Metric.TrendExpressionFactory.html","title":"ExTeal.Metric.TrendExpressionFactory","type":"module"},{"doc":"Based on the adapter, select a trend factory and build\na date expression to be used in a Ecto Query fragment for the query","ref":"ExTeal.Metric.TrendExpressionFactory.html#make/5","title":"ExTeal.Metric.TrendExpressionFactory.make/5","type":"function"},{"doc":"Value Metrics display a single value and it's change compared to a previous\ninterval of time.  For example, a value metric might display the total number\nof blog posts created in the last thirty days, versus the previous thirty days.\n\nOnce generated, a value metric module has two functions that can be customized,\na `calculate/1` and a `ranges/0` function.\n\nAdditionally there are modifier functions that change the behavior and display\nof the metric.","ref":"ExTeal.Metric.Value.html","title":"ExTeal.Metric.Value","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Value.html#aggregate/5","title":"ExTeal.Metric.Value.aggregate/5","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#between_current/3","title":"ExTeal.Metric.Value.between_current/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#c:calculate/1","title":"ExTeal.Metric.Value.calculate/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Value.html#query_for/6","title":"ExTeal.Metric.Value.query_for/6","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:multi_result/0","title":"ExTeal.Metric.Value.multi_result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:result/0","title":"ExTeal.Metric.Value.result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:valid_result/0","title":"ExTeal.Metric.Value.valid_result/0","type":"type"},{"doc":"Conveniences for inflecting and working with names in ExTeal.","ref":"ExTeal.Naming.html","title":"ExTeal.Naming","type":"module"},{"doc":"Converts String to camel case.\n\nTakes an optional `:lower` option to return lowerCamelCase.","ref":"ExTeal.Naming.html#camelize/1","title":"ExTeal.Naming.camelize/1","type":"function"},{"doc":"iex> ExTeal.Naming.camelize(\"my_app\")\n    \"MyApp\"\n\n    iex> ExTeal.Naming.camelize(\"my_app\", :lower)\n    \"myApp\"\n\nIn general, `camelize` can be thought of as the reverse of\n`underscore`, however, in some cases formatting may be lost:\n\n    ExTeal.Naming.underscore \"SAPExample\"  #=> \"sap_example\"\n    ExTeal.Naming.camelize   \"sap_example\" #=> \"SapExample\"","ref":"ExTeal.Naming.html#camelize/1-examples","title":"Examples - ExTeal.Naming.camelize/1","type":"function"},{"doc":"","ref":"ExTeal.Naming.html#camelize/2","title":"ExTeal.Naming.camelize/2","type":"function"},{"doc":"Converts an attribute/form field into its humanize version.\n\n    iex> ExTeal.Naming.humanize(:username)\n    \"Username\"\n    iex> ExTeal.Naming.humanize(:created_at)\n    \"Created at\"\n    iex> ExTeal.Naming.humanize(\"user_id\")\n    \"User\"","ref":"ExTeal.Naming.html#humanize/1","title":"ExTeal.Naming.humanize/1","type":"function"},{"doc":"Extracts the resource name from an alias.","ref":"ExTeal.Naming.html#resource_name/2","title":"ExTeal.Naming.resource_name/2","type":"function"},{"doc":"iex> ExTeal.Naming.resource_name(MyApp.User)\n    \"user\"\n\n    iex> ExTeal.Naming.resource_name(MyApp.UserView, \"View\")\n    \"user\"","ref":"ExTeal.Naming.html#resource_name/2-examples","title":"Examples - ExTeal.Naming.resource_name/2","type":"function"},{"doc":"Converts String to underscore case.","ref":"ExTeal.Naming.html#underscore/1","title":"ExTeal.Naming.underscore/1","type":"function"},{"doc":"iex> ExTeal.Naming.underscore(\"MyApp\")\n    \"my_app\"\n\nIn general, `underscore` can be thought of as the reverse of\n`camelize`, however, in some cases formatting may be lost:\n\n    ExTeal.Naming.underscore \"SAPExample\"  #=> \"sap_example\"\n    ExTeal.Naming.camelize   \"sap_example\" #=> \"SapExample\"","ref":"ExTeal.Naming.html#underscore/1-examples","title":"Examples - ExTeal.Naming.underscore/1","type":"function"},{"doc":"Removes the given suffix from the name if it exists.","ref":"ExTeal.Naming.html#unsuffix/2","title":"ExTeal.Naming.unsuffix/2","type":"function"},{"doc":"iex> ExTeal.Naming.unsuffix(\"MyApp.User\", \"View\")\n    \"MyApp.User\"\n\n    iex> ExTeal.Naming.unsuffix(\"MyApp.UserView\", \"View\")\n    \"MyApp.User\"","ref":"ExTeal.Naming.html#unsuffix/2-examples","title":"Examples - ExTeal.Naming.unsuffix/2","type":"function"},{"doc":"The default policy that allows authenticated users access to CRUD.\nAll callbacks default to always being true. Should not be used in production!","ref":"ExTeal.OpenEverywherePolicy.html","title":"ExTeal.OpenEverywherePolicy","type":"module"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#create_any?/1","title":"ExTeal.OpenEverywherePolicy.create_any?/1","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#delete?/2","title":"ExTeal.OpenEverywherePolicy.delete?/2","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#delete_any?/1","title":"ExTeal.OpenEverywherePolicy.delete_any?/1","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#update?/2","title":"ExTeal.OpenEverywherePolicy.update?/2","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#update_any?/1","title":"ExTeal.OpenEverywherePolicy.update_any?/1","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#view?/2","title":"ExTeal.OpenEverywherePolicy.view?/2","type":"function"},{"doc":"","ref":"ExTeal.OpenEverywherePolicy.html#view_any?/1","title":"ExTeal.OpenEverywherePolicy.view_any?/1","type":"function"},{"doc":"Separates fields on the detail page into panels","ref":"ExTeal.Panel.html","title":"ExTeal.Panel","type":"module"},{"doc":"","ref":"ExTeal.Panel.html#default_panel_name/1","title":"ExTeal.Panel.default_panel_name/1","type":"function"},{"doc":"Given a resource, uses the fields definition to find the panels","ref":"ExTeal.Panel.html#gather_panels/1","title":"ExTeal.Panel.gather_panels/1","type":"function"},{"doc":"Given a list of fields and a list of panels, assigns the panel to each field","ref":"ExTeal.Panel.html#give_panel_to_fields/2","title":"ExTeal.Panel.give_panel_to_fields/2","type":"function"},{"doc":"Add helper text for the panel","ref":"ExTeal.Panel.html#helper_text/2","title":"ExTeal.Panel.helper_text/2","type":"function"},{"doc":"Limit the amount of fields that show by default on the detail page\nOther fields are hidden behind a \"Show more\" button","ref":"ExTeal.Panel.html#limit/2","title":"ExTeal.Panel.limit/2","type":"function"},{"doc":"Creates a new panel","ref":"ExTeal.Panel.html#new/3","title":"ExTeal.Panel.new/3","type":"function"},{"doc":"","ref":"ExTeal.Panel.html#t:options/0","title":"ExTeal.Panel.options/0","type":"type"},{"doc":"","ref":"ExTeal.Panel.html#t:t/0","title":"ExTeal.Panel.t/0","type":"type"},{"doc":"The core struct that represents and validates an address","ref":"ExTeal.Place.html","title":"ExTeal.Place","type":"module"},{"doc":"","ref":"ExTeal.Place.html#changeset/2","title":"ExTeal.Place.changeset/2","type":"function"},{"doc":"","ref":"ExTeal.Place.html#t:t/0","title":"ExTeal.Place.t/0","type":"type"},{"doc":"The base module that describes the functionality of a plugin","ref":"ExTeal.Plugin.html","title":"ExTeal.Plugin","type":"behaviour"},{"doc":"","ref":"ExTeal.Plugin.html#available_scripts/1","title":"ExTeal.Plugin.available_scripts/1","type":"function"},{"doc":"","ref":"ExTeal.Plugin.html#available_styles/0","title":"ExTeal.Plugin.available_styles/0","type":"function"},{"doc":"","ref":"ExTeal.Plugin.html#available_styles/1","title":"ExTeal.Plugin.available_styles/1","type":"function"},{"doc":"","ref":"ExTeal.Plugin.html#c:js_config/0","title":"ExTeal.Plugin.js_config/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:navigation_component/0","title":"ExTeal.Plugin.navigation_component/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:router/0","title":"ExTeal.Plugin.router/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:scripts/0","title":"ExTeal.Plugin.scripts/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:styles/0","title":"ExTeal.Plugin.styles/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:title/0","title":"ExTeal.Plugin.title/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#c:uri/0","title":"ExTeal.Plugin.uri/0","type":"callback"},{"doc":"","ref":"ExTeal.Plugin.html#t:t/0","title":"ExTeal.Plugin.t/0","type":"type"},{"doc":"A Policy authorizes CRUD use of a resource based on the Plug.Conn","ref":"ExTeal.Policy.html","title":"ExTeal.Policy","type":"behaviour"},{"doc":"Can a user create a resource?\nReturning false will disable the '+' button on a resource and return a 403 on api requests","ref":"ExTeal.Policy.html#c:create_any?/1","title":"ExTeal.Policy.create_any?/1","type":"callback"},{"doc":"Can a user delete any resource?\nReturning false will disable the 'delete' buttons on all resource records\nand return a 403 on api requests","ref":"ExTeal.Policy.html#c:delete?/2","title":"ExTeal.Policy.delete?/2","type":"callback"},{"doc":"Can a user delete any resource?\nReturning false will disable the 'delete' buttons on all resource records\nand return a 403 on api requests","ref":"ExTeal.Policy.html#c:delete_any?/1","title":"ExTeal.Policy.delete_any?/1","type":"callback"},{"doc":"Can a user update any records?\nReturning false will disable the 'edit' button on a record and return a 403 on api requests","ref":"ExTeal.Policy.html#c:update?/2","title":"ExTeal.Policy.update?/2","type":"callback"},{"doc":"Can a user update any records?\nReturning false will disable the 'edit' button on a record and return a 403 on api requests","ref":"ExTeal.Policy.html#c:update_any?/1","title":"ExTeal.Policy.update_any?/1","type":"callback"},{"doc":"Can the resource be viewed at all?\nReturning false will hide the resource in the sidebar and in relationships\nand return a 403 on api requests","ref":"ExTeal.Policy.html#c:view?/2","title":"ExTeal.Policy.view?/2","type":"callback"},{"doc":"Can the resource be viewed at all?\nReturning false will hide the resource in the sidebar and in relationships\nand return a 403 on api requests","ref":"ExTeal.Policy.html#c:view_any?/1","title":"ExTeal.Policy.view_any?/1","type":"callback"},{"doc":"When used, includes all aspects of the functionality required to\nmanage the resource.\n\nExample usage in a ExTeal Resource:\n\n    defmodule ExampleWeb.ExTeal.BlogResource do\n      use ExTeal.Resource\n\n      alias Example.Content.Blog\n\n      def resource, do: Blog\n\n      def title, do: \"blog\"\n    end","ref":"ExTeal.Resource.html","title":"ExTeal.Resource","type":"behaviour"},{"doc":"Provide a list of action cards to render them above the resource index","ref":"ExTeal.Resource.html#c:cards/1","title":"ExTeal.Resource.cards/1","type":"callback"},{"doc":"Override the default ordering of the index.","ref":"ExTeal.Resource.html#c:default_order/0","title":"ExTeal.Resource.default_order/0","type":"callback"},{"doc":"Hide the Resource from the sidenav in the user interface, defaults to false.","ref":"ExTeal.Resource.html#c:hide_from_nav/0","title":"ExTeal.Resource.hide_from_nav/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.html#map_to_json/2","title":"ExTeal.Resource.map_to_json/2","type":"function"},{"doc":"If you would like to separate resources into different sidebar groups, you can\noverride the `nav_group/1` function on the resource.","ref":"ExTeal.Resource.html#c:nav_group/1","title":"ExTeal.Resource.nav_group/1","type":"callback"},{"doc":"Override the detail or edit link for a resource on the resource index.\n\nWhen defining this callback, be aware that resources referenced by a many to many relationship\nwill also call this function when rendering the index of that many to many.","ref":"ExTeal.Resource.html#c:navigate_to/3","title":"ExTeal.Resource.navigate_to/3","type":"callback"},{"doc":"Allows skipping sanitize for all fields on a resource","ref":"ExTeal.Resource.html#c:skip_sanitize/0","title":"ExTeal.Resource.skip_sanitize/0","type":"callback"},{"doc":"Specifies the field to use as the basis for a drag and drop interface for the collection.","ref":"ExTeal.Resource.html#c:sortable_by/0","title":"ExTeal.Resource.sortable_by/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.html#to_json/2","title":"ExTeal.Resource.to_json/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.html#t:attributes/0","title":"ExTeal.Resource.attributes/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:id/0","title":"ExTeal.Resource.id/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:indexed_resource/0","title":"ExTeal.Resource.indexed_resource/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:orderable_key/0","title":"ExTeal.Resource.orderable_key/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:orderable_option/0","title":"ExTeal.Resource.orderable_option/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:params/0","title":"ExTeal.Resource.params/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:pivot_resource/0","title":"ExTeal.Resource.pivot_resource/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:record/0","title":"ExTeal.Resource.record/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:records/0","title":"ExTeal.Resource.records/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:t/0","title":"ExTeal.Resource.t/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:validation_errors/0","title":"ExTeal.Resource.validation_errors/0","type":"type"},{"doc":"Provides the `permitted_attributes/3` callback used for filtering attributes.\n\nThis behaviour is used by the following ExTeal.Resource actions:\n\n  * ExTeal.Resource.Delete\n  * ExTeal.Resource.Create","ref":"ExTeal.Resource.Attributes.html","title":"ExTeal.Resource.Attributes","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#clean_and_nest_params/1","title":"ExTeal.Resource.Attributes.clean_and_nest_params/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#combine_and_key_by_field_attr/1","title":"ExTeal.Resource.Attributes.combine_and_key_by_field_attr/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#maybe_sanitize/3","title":"ExTeal.Resource.Attributes.maybe_sanitize/3","type":"function"},{"doc":"Used to determine which attributes are permitted during create and update.\n\nThe attributes map (the second argument) is a \"flattened\" version including\nthe values at `data/attributes`, `data/type` and any relationship values in\n`data/relationships/[name]/data/id` as `name_id`.\n\nThe third argument is the atom of the action being called.\n\nExample:\n\n    defmodule MyApp.V1.PostResource do\n      use ExTeal.Resource\n\n      def permitted_attributes(conn, attrs, :create) do\n        attrs\n        |> Map.take(~w(title body type category_id))\n        |> Map.merge(\"author_id\", conn.assigns[:current_user])\n      end\n\n      def permitted_attributes(_conn, attrs, :update) do\n        Map.take(attrs, ~w(title body type category_id))\n      end\n    end","ref":"ExTeal.Resource.Attributes.html#c:permitted_attributes/3","title":"ExTeal.Resource.Attributes.permitted_attributes/3","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#raw_html/1","title":"ExTeal.Resource.Attributes.raw_html/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize/2","title":"ExTeal.Resource.Attributes.sanitize/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize_as/2","title":"ExTeal.Resource.Attributes.sanitize_as/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize_param/2","title":"ExTeal.Resource.Attributes.sanitize_param/2","type":"function"},{"doc":"Defines a behaviour for creating a resource and the function to execute it.\n\nIt relies on (and uses):\n\n  * ExTeal.Resource.Repo\n  * ExTeal.Resource.Model\n  * ExTeal.Resource.Attributes\n\nWhen used ExTeal.Resource.Create defines the following overrideable callbacks:\n\n  * handle_create/2\n  * handle_invalid_create/2\n  * render_create/2\n  * ExTeal.Resource.Attributes.permitted_attributes/3\n  * ExTeal.Resource.Repo.repo/1","ref":"ExTeal.Resource.Create.html","title":"ExTeal.Resource.Create","type":"behaviour"},{"doc":"Creates a resource given a module using Create and a connection.\n\n    Create.call(ArticleResource, conn)","ref":"ExTeal.Resource.Create.html#call/2","title":"ExTeal.Resource.Create.call/2","type":"function"},{"doc":"Returns an unpersisted changeset or persisted model of the newly created object.\n\nDefault implementation returns the results of calling\n`Model.changeset(%Model{}, attrs)` where Model is the model defined by the\n`c:ExTeal.Resource.Model.model/0` callback.\n\nThe attributes argument is the result of the `permitted_attributes` function.\n\n`handle_create/2` can return an %Ecto.Changeset, an Ecto.Schema struct,\na list of errors (`{:error, [email: \"is not valid\"]}` or a conn with\nany response/body.\nou\nExample custom implementation:\n\n    def handle_create(_conn, attributes) do\n      Post.changeset(%Post{}, attributes, :create_and_publish)\n    end","ref":"ExTeal.Resource.Create.html#c:handle_create/2","title":"ExTeal.Resource.Create.handle_create/2","type":"callback"},{"doc":"Returns a `Plug.Conn` in response to errors during create.\n\nDefault implementation sets the status to `:unprocessable_entity` and renders\nthe error messages provided.","ref":"ExTeal.Resource.Create.html#c:handle_invalid_create/2","title":"ExTeal.Resource.Create.handle_invalid_create/2","type":"callback"},{"doc":"Returns a `Plug.Conn` in response to successful create.\n\nDefault implementation sets the status to `:created` and renders the view.","ref":"ExTeal.Resource.Create.html#c:render_create/2","title":"ExTeal.Resource.Create.render_create/2","type":"callback"},{"doc":"Defines a behaviour for deleting a resource and the function to execute it.\n\nIt relies on (and uses):\n\n  * ExTeal.Repo\n  * ExTeal.Record\n\nWhen used ExTeal.Resource.Delete defines the `delete/2` action suitable for\nhandling teal delete requests.\n\nTo customize the behaviour of the update action the following callbacks can\nbe implemented:\n\n  * handle_delete/2\n  * ExTeal.Record.record/2\n  * ExTeal.Repo.repo/0","ref":"ExTeal.Resource.Delete.html","title":"ExTeal.Resource.Delete","type":"behaviour"},{"doc":"Execute the delete action on a given module implementing Delete behaviour and conn.","ref":"ExTeal.Resource.Delete.html#call/2","title":"ExTeal.Resource.Delete.call/2","type":"function"},{"doc":"Returns an unpersisted changeset or persisted model representing the newly updated model.\n\nReceives the conn and the record as found by `record/2`.\n\nDefault implementation returns the results of calling `Repo.delete(record)`.\n\nExample custom implementation:\n\n    def handle_delete(conn, record) do\n      case conn.assigns[:user] do\n        %{is_admin: true} -> super(conn, record)\n        _                 -> send_resp(conn, 401, \"nope\")\n      end\n    end","ref":"ExTeal.Resource.Delete.html#c:handle_delete/2","title":"ExTeal.Resource.Delete.handle_delete/2","type":"callback"},{"doc":"Adds functionality for exporting a stream of records\nas a csv file.","ref":"ExTeal.Resource.Export.html","title":"ExTeal.Resource.Export","type":"behaviour"},{"doc":"Returns a list of all fields on the schema\nfor export","ref":"ExTeal.Resource.Export.html#default_export_fields/1","title":"ExTeal.Resource.Export.default_export_fields/1","type":"function"},{"doc":"Returns the query with a select that parses all the\nfields into a map instead of the struct","ref":"ExTeal.Resource.Export.html#default_export_query/2","title":"ExTeal.Resource.Export.default_export_query/2","type":"function"},{"doc":"Turns a record represented as a map and a list of atoms representing\nthe ordered fields in the CSV into a list of values in the same order\nas the list of fields","ref":"ExTeal.Resource.Export.html#default_parse/2","title":"ExTeal.Resource.Export.default_parse/2","type":"function"},{"doc":"The fields to export from the resource","ref":"ExTeal.Resource.Export.html#c:export_fields/0","title":"ExTeal.Resource.Export.export_fields/0","type":"callback"},{"doc":"Define an override to the default parser, as defined in the `ex_teal` config\n\nExpects the parser to have a dump_to_stream/1 function that accepts a stream\nof rows and returns a stream of rows.","ref":"ExTeal.Resource.Export.html#c:export_module/0","title":"ExTeal.Resource.Export.export_module/0","type":"callback"},{"doc":"Modify the query for a csv result","ref":"ExTeal.Resource.Export.html#c:handle_export_query/2","title":"ExTeal.Resource.Export.handle_export_query/2","type":"callback"},{"doc":"Parse a row into a CSV Encodeable list of fields\n\nUseful for modifying database columns into serializeable strings\nbefore the row is passed to CSV.encode/2","ref":"ExTeal.Resource.Export.html#c:parse_export_row/2","title":"ExTeal.Resource.Export.parse_export_row/2","type":"callback"},{"doc":"Build a streamed csv and chunk the results as a response.\n\nUses the resource's querying functionality (filtering, searching, sorting)\nto return only the resources the user has selected.","ref":"ExTeal.Resource.Export.html#stream/2","title":"ExTeal.Resource.Export.stream/2","type":"function"},{"doc":"Convert map atom keys to strings","ref":"ExTeal.Resource.Export.html#stringify_keys/1","title":"ExTeal.Resource.Export.stringify_keys/1","type":"function"},{"doc":"Provides the `fields/0` callback used by the following ExTeal actions:\n\n  * ExTeal.Resource.Index","ref":"ExTeal.Resource.Fields.html","title":"ExTeal.Resource.Fields","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Fields.html#add_panel_key/2","title":"ExTeal.Resource.Fields.add_panel_key/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#all_fields/1","title":"ExTeal.Resource.Fields.all_fields/1","type":"function"},{"doc":"Apply the can_see function attached to a field to filter\nout the field from serialized responses.","ref":"ExTeal.Resource.Fields.html#apply_can_see/2","title":"ExTeal.Resource.Fields.apply_can_see/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#apply_values/6","title":"ExTeal.Resource.Fields.apply_values/6","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#field_for/2","title":"ExTeal.Resource.Fields.field_for/2","type":"function"},{"doc":"Used to get the fields available to the current action.\n\nAll resources will override this:\n\n    def fields(), do: [\n      Id.make() |> sortable(),\n      Text.make('Name') |> sortable(),\n      DateTime.make(:updated_at, 'Last Updated At') |> hide_from_index()\n    ]","ref":"ExTeal.Resource.Fields.html#c:fields/0","title":"ExTeal.Resource.Fields.fields/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_for/2","title":"ExTeal.Resource.Fields.fields_for/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_for_has_many/2","title":"ExTeal.Resource.Fields.fields_for_has_many/2","type":"function"},{"doc":"Instead of returning the fields for an index table of a resource,\nthis function is called to render a simple belongs to field via a\n`ManyToManyBelongsTo` field.\n\nGiven a many to many relationship between posts and tags, an index query\nfor the tags associated with a post should return a single many to many belongs to\nfield that represents a tag associated with the post.  The field will then have options\nbuilt up to make it behave like a belongs_to on the client side.","ref":"ExTeal.Resource.Fields.html#fields_for_many_to_many/2","title":"ExTeal.Resource.Fields.fields_for_many_to_many/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_from_model/1","title":"ExTeal.Resource.Fields.fields_from_model/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#index_fields/2","title":"ExTeal.Resource.Fields.index_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#index_fields_for_many/2","title":"ExTeal.Resource.Fields.index_fields_for_many/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#meta_for/6","title":"ExTeal.Resource.Fields.meta_for/6","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#pivot_fields_for/3","title":"ExTeal.Resource.Fields.pivot_fields_for/3","type":"function"},{"doc":"Find the field on the resource that includes context for the relationship that\nis being queried.","ref":"ExTeal.Resource.Fields.html#relationship_field/2","title":"ExTeal.Resource.Fields.relationship_field/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#serialize_response/4","title":"ExTeal.Resource.Fields.serialize_response/4","type":"function"},{"doc":"Behavior for handling index requests for a given resource","ref":"ExTeal.Resource.Index.html","title":"ExTeal.Resource.Index","type":"behaviour"},{"doc":"Returns the actions available for a resource\n\nDefault implementation is an empty array.","ref":"ExTeal.Resource.Index.html#c:actions/1","title":"ExTeal.Resource.Index.actions/1","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#call/2","title":"ExTeal.Resource.Index.call/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#field_filters/3","title":"ExTeal.Resource.Index.field_filters/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#filter_via_relationships/2","title":"ExTeal.Resource.Index.filter_via_relationships/2","type":"function"},{"doc":"Returns the models to be represented by this resource.\n\nDefault implementation is the result of the ExTeal.Resource.Records.records/2\ncallback. Usually a module or an `%Ecto.Query{}`.\n\nThe results of this callback are passed to the filter and sort callbacks before the query is executed.\n\n`handle_index/2` can alternatively return a conn with any response/body.\n\nExample custom implementation:\n\n    def handle_index(conn, _params) do\n      case conn.assigns[:current_user] do\n        nil  -> App.Post\n        user -> User.own_posts(user)\n      end\n    end\n\nIn most cases ExTeal.Resource.Records.records/1, filter/4, and sort/4 are the\nbetter customization hooks.","ref":"ExTeal.Resource.Index.html#c:handle_index/2","title":"ExTeal.Resource.Index.handle_index/2","type":"callback"},{"doc":"Returns the models to be represented by this resource via a relationship.\n\nDefault implementation is the result of the ExTeal.Resource.Records.records/2\ncallback returning an ecto query with the fields necessary to display the title.\n\n`handle_related/2` can alternatively return a conn with any response/body.\n\nExample custom implementation:\n\n    def handle_related(conn, _params) do\n      case conn.assigns[:current_user] do\n        nil  -> App.Post\n        user -> User.own_posts(user)\n      end\n    end","ref":"ExTeal.Resource.Index.html#c:handle_related/2","title":"ExTeal.Resource.Index.handle_related/2","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#query_by_related/3","title":"ExTeal.Resource.Index.query_by_related/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#query_for_related/2","title":"ExTeal.Resource.Index.query_for_related/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#repo/0","title":"ExTeal.Resource.Index.repo/0","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#reversed_query/4","title":"ExTeal.Resource.Index.reversed_query/4","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#search/3","title":"ExTeal.Resource.Index.search/3","type":"function"},{"doc":"Defines the search adapter to use while building a search query:\n\nDefaults to the `ExTeal.Search.SimpleSearch` module","ref":"ExTeal.Resource.Index.html#c:search_adapter/3","title":"ExTeal.Resource.Index.search_adapter/3","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#sort/3","title":"ExTeal.Resource.Index.sort/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#with_pivot_fields/3","title":"ExTeal.Resource.Index.with_pivot_fields/3","type":"function"},{"doc":"Provides the `model/0` callback used to customize the resource served.\n\nThis behaviour is used by all ExTeal actions.","ref":"ExTeal.Resource.Model.html","title":"ExTeal.Resource.Model","type":"behaviour"},{"doc":"Array of default field filters to be used\nwhen there are no filters present","ref":"ExTeal.Resource.Model.html#c:default_filters/0","title":"ExTeal.Resource.Model.default_filters/0","type":"callback"},{"doc":"Must return the module implementing `Ecto.Schema` to be represented.\n\nExample:\n\n    def model, do: MyApp.Models.Post\n\nDefaults to the name of the resource, for example the resource\n`MyApp.V1.PostResource` would serve the `MyApp.Post` model.\n\nUsed by the default implementations for `handle_create/2`, `handle_update/3`,\nand `records/1`.","ref":"ExTeal.Resource.Model.html#c:model/0","title":"ExTeal.Resource.Model.model/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#model_from_resource/1","title":"ExTeal.Resource.Model.model_from_resource/1","type":"function"},{"doc":"The fields that should be searched","ref":"ExTeal.Resource.Model.html#c:search/0","title":"ExTeal.Resource.Model.search/0","type":"callback"},{"doc":"Returns the singularized version of the title to display on forms.","ref":"ExTeal.Resource.Model.html#c:singular_title/0","title":"ExTeal.Resource.Model.singular_title/0","type":"callback"},{"doc":"Returns the subtitle to display in relationships.\n\nDefaults to looking for name or title fields,\nfalls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:subtitle_for_schema/1","title":"ExTeal.Resource.Model.subtitle_for_schema/1","type":"callback"},{"doc":"Returns the thumbnail to display in search.\n\nDefaults to looking for name or title fields,\nfalls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:thumbnail_for_schema/1","title":"ExTeal.Resource.Model.thumbnail_for_schema/1","type":"callback"},{"doc":"Returns the title to display in the side bar.\n\nDefaults to finding the title from the resource modules name","ref":"ExTeal.Resource.Model.html#c:title/0","title":"ExTeal.Resource.Model.title/0","type":"callback"},{"doc":"Returns the title to display in relationships.\n\nDefaults to looking for name or title fields,\nfalls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:title_for_schema/1","title":"ExTeal.Resource.Model.title_for_schema/1","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#title_for_schema_from_struct/1","title":"ExTeal.Resource.Model.title_for_schema_from_struct/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Model.html#title_from_resource/1","title":"ExTeal.Resource.Model.title_from_resource/1","type":"function"},{"doc":"Returns the uri to display in the side bar.\n\nDefaults to finding the uri from the resource modules name","ref":"ExTeal.Resource.Model.html#c:uri/0","title":"ExTeal.Resource.Model.uri/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#uri_from_resource/1","title":"ExTeal.Resource.Model.uri_from_resource/1","type":"function"},{"doc":"Used to build paginated views of resources","ref":"ExTeal.Resource.Pagination.html","title":"ExTeal.Resource.Pagination","type":"module"},{"doc":"","ref":"ExTeal.Resource.Pagination.html#paginate_query/3","title":"ExTeal.Resource.Pagination.paginate_query/3","type":"function"},{"doc":"Defines a behaviour for authorizing use CRUD","ref":"ExTeal.Resource.Policy.html","title":"ExTeal.Resource.Policy","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Policy.html#c:policy/0","title":"ExTeal.Resource.Policy.policy/0","type":"callback"},{"doc":"This behaviour is used by the following ExTeal.Resource actions:\n\n  * ExTeal.Resource.Show\n  * ExTeal.Resource.Update\n  * ExTeal.Resource.Delete\n\nIt relies on (and uses):\n\n  * ExTeal.Resource.Records","ref":"ExTeal.Resource.Record.html","title":"ExTeal.Resource.Record","type":"behaviour"},{"doc":"Used to get the subject of the current action\n\nMany/most controllers will override this:\n\n    def record(%Plug.Conn{assigns: %{user_id: user_id}}, id) do\n      model()\n      |> where([p], p.author_id == ^user_id)\n      |> Repo.get(id)\n    end","ref":"ExTeal.Resource.Record.html#c:record/2","title":"ExTeal.Resource.Record.record/2","type":"callback"},{"doc":"Provides the `records/1` callback used for querying records to be served.\n\nThis is typically the base query that you expose, often scoped to the\ncurrent user.\n\nThis behaviour is used by the following ExTeal.Resource actions:\n\n  * ExTeal.Resource.Index\n  * ExTeal.Resource.Show\n  * ExTeal.Resource.Update\n  * ExTeal.Resource.Delete\n\nIt relies on (and uses):\n\n  * ExTeal.Resource.Model","ref":"ExTeal.Resource.Records.html","title":"ExTeal.Resource.Records","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Records.html#preload/2","title":"ExTeal.Resource.Records.preload/2","type":"function"},{"doc":"Used to get the base query of records.\n\nMany/most resources will override this:\n\n    def records(%Plug.Conn{assigns: %{user_id: user_id}}) do\n      model()\n      |> where([p], p.author_id == ^user_id)\n    end\n\nReturn value should be %Plug.Conn{} or an %Ecto.Queryable{}.","ref":"ExTeal.Resource.Records.html#c:records/2","title":"ExTeal.Resource.Records.records/2","type":"callback"},{"doc":"Used to specify which relationships to always\npreload with all requests.","ref":"ExTeal.Resource.Records.html#c:with/0","title":"ExTeal.Resource.Records.with/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Repo.html","title":"ExTeal.Resource.Repo","type":"behaviour"},{"doc":"Defines the module `use`-ing `Ecto.Repo` to be used by the resource.\n\nDefaults to the value set in config if present:\n\n    config :ex_teal,\n       repo: MyApp.Repo\n\nDefault can be overridden per resource:\n\n    def repo, do: MyApp.SecondaryRepo","ref":"ExTeal.Resource.Repo.html#c:repo/0","title":"ExTeal.Resource.Repo.repo/0","type":"callback"},{"doc":"Serializes a resource response into json","ref":"ExTeal.Resource.Serializer.html","title":"ExTeal.Resource.Serializer","type":"module"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#as_json/3","title":"ExTeal.Resource.Serializer.as_json/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#error/2","title":"ExTeal.Resource.Serializer.error/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_create/3","title":"ExTeal.Resource.Serializer.render_create/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_errors/2","title":"ExTeal.Resource.Serializer.render_errors/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_index/3","title":"ExTeal.Resource.Serializer.render_index/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_related/3","title":"ExTeal.Resource.Serializer.render_related/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_show/3","title":"ExTeal.Resource.Serializer.render_show/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_update/3","title":"ExTeal.Resource.Serializer.render_update/3","type":"function"},{"doc":"Generates a map that summarizes the specified schema\nfor global and relational searches.","ref":"ExTeal.Resource.Serializer.html#schema_summary/2","title":"ExTeal.Resource.Serializer.schema_summary/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#send/3","title":"ExTeal.Resource.Serializer.send/3","type":"function"},{"doc":"Defines a behaviour for displaying a resource and the function to execute it.\n\nIt relies on (and uses):\n\n  * ExTeal.Resource.Record\n  * ExTeal.Resource.Serializable\n\nWhen used ExTeal.Resource.Show defines the `show/2` action suitable for handling\napi requests.\n\nTo customize the behaviour of the show action the following callbacks can be implemented:\n\n  * handle_show/2\n  * render_show/2\n  * ExTeal.Resource.Record.record/2\n  * ExTeal.Resource.Record.records/1","ref":"ExTeal.Resource.Show.html","title":"ExTeal.Resource.Show","type":"behaviour"},{"doc":"Execute the show action on a given module implementing Show behaviour and conn.","ref":"ExTeal.Resource.Show.html#call/3","title":"ExTeal.Resource.Show.call/3","type":"function"},{"doc":"Returns the model to be represented by this resource.\n\nDefault implementation is the result of the ExTeal.Resource.Record.record/2\ncallback.\n\n`handle_show/2` can return nil to send a 404, a conn with any response/body,\nor a record to be serialized.\n\nExample custom implementation:\n\n    def handle_show(conn, id) do\n      Repo.get_by(Post, slug: id)\n    end\n\nIn most cases ExTeal.Resource.Record.record/2 and ExTeal.Resource.Records.records/1 are\nthe better customization hooks.","ref":"ExTeal.Resource.Show.html#c:handle_show/2","title":"ExTeal.Resource.Show.handle_show/2","type":"callback"},{"doc":"Returns a `Plug.Conn` in response to successful show.\n\nDefault implementation renders the view.","ref":"ExTeal.Resource.Show.html#c:render_show/3","title":"ExTeal.Resource.Show.render_show/3","type":"callback"},{"doc":"Defines a behaviour for updating a resource and the function to execute it.\n\nIt relies on (and uses):\n\n  * ExTeal.Resource.Record\n  * ExTeal.Resource.Attributes\n\nWhen used ExTeal.Resource.Update defines the `update/2` action suitable for\nhandling json-api requests.\n\nTo customize the behaviour of the update action the following callbacks can\nbe implemented:\n\n  * ExTeal.Resource.Record.record/2\n  * ExTeal.Resource.Records.records/1\n  * handle_update/3\n  * handle_invalid_update/2\n  * render_update/2\n  * ExTeal.Resource.Attributes.permitted_attributes/3","ref":"ExTeal.Resource.Update.html","title":"ExTeal.Resource.Update","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Update.html#batch_update/2","title":"ExTeal.Resource.Update.batch_update/2","type":"function"},{"doc":"Execute the update action on a given module implementing Update behaviour and conn.","ref":"ExTeal.Resource.Update.html#call/3","title":"ExTeal.Resource.Update.call/3","type":"function"},{"doc":"Returns a `Plug.Conn` in response to errors during update.\n\nDefault implementation sets the status to `:unprocessable_entity` and renders\nthe error messages provided.","ref":"ExTeal.Resource.Update.html#c:handle_invalid_update/2","title":"ExTeal.Resource.Update.handle_invalid_update/2","type":"callback"},{"doc":"Returns an unpersisted changeset or persisted model representing the newly updated model.\n\nReceives the conn, the model as found by `record/2`, and the attributes\nargument from the `permitted_attributes` function.\n\nDefault implementation returns the results of calling\n`Model.changeset(model, attrs)`.\n\n`handle_update/3` can return an %Ecto.Changeset, an Ecto.Schema struct,\na list of errors (`{:error, [email: \"is not valid\"]}` or a conn with\nany response/body.\n\nExample custom implementation:\n\n    def handle_update(conn, post, attributes) do\n      current_user_id = conn.assigns[:current_user].id\n      case post.author_id do\n        ^current_user_id -> {:error, author_id: \"you can only edit your own posts\"}\n        _                -> Post.changeset(post, attributes, :update)\n      end\n    end","ref":"ExTeal.Resource.Update.html#c:handle_update/3","title":"ExTeal.Resource.Update.handle_update/3","type":"callback"},{"doc":"Returns a `Plug.Conn` in response to successful update.\n\nDefault implementation renders the view.","ref":"ExTeal.Resource.Update.html#c:render_update/2","title":"ExTeal.Resource.Update.render_update/2","type":"callback"},{"doc":"A `Plug.Router`.  This module is meant to be plugged into host applications.\n\nSee the readme for more details.","ref":"ExTeal.Router.html","title":"ExTeal.Router","type":"module"},{"doc":"","ref":"ExTeal.Router.html#init/1","title":"ExTeal.Router.init/1","type":"function"},{"doc":"The default search adapter.  Uses dynamic ecto queries to build a simple\nILIKE comparison across the field specified by the `search/2` function on\nthe resource.","ref":"ExTeal.Search.SimpleSearch.html","title":"ExTeal.Search.SimpleSearch","type":"module"},{"doc":"Build a dynamic ecto where statement by reducing over the resource's\nsearchable fields and creating an ilike where expression","ref":"ExTeal.Search.SimpleSearch.html#build/3","title":"ExTeal.Search.SimpleSearch.build/3","type":"function"},{"doc":"The Theme module provides functionality for engineers to customize the appearance of Teal by\nchanging the colors used in the user interface.  The struct provides the default values,\nand can be overriden by providing a custom struct in the `ExTeal.Manifest` module.","ref":"ExTeal.Theme.html","title":"ExTeal.Theme","type":"module"},{"doc":"","ref":"ExTeal.Theme.html#color_variables/1","title":"ExTeal.Theme.color_variables/1","type":"function"},{"doc":"","ref":"ExTeal.Theme.html#t:t/0","title":"ExTeal.Theme.t/0","type":"type"},{"doc":"Returns HTML to render as the main interface of Teal.","ref":"ExTeal.View.html","title":"ExTeal.View","type":"module"},{"doc":"","ref":"ExTeal.View.html#index/1","title":"ExTeal.View.index/1","type":"function"},{"doc":"","ref":"ExTeal.View.html#render/1","title":"ExTeal.View.render/1","type":"function"},{"doc":"The default dashboard that contains links to documentation\nfor new engineers.","ref":"ExTeal.WelcomeDashboard.html","title":"ExTeal.WelcomeDashboard","type":"module"},{"doc":"","ref":"ExTeal.WelcomeDashboard.html#cards/1","title":"ExTeal.WelcomeDashboard.cards/1","type":"function"},{"doc":"","ref":"ExTeal.WelcomeDashboard.html#display?/1","title":"ExTeal.WelcomeDashboard.display?/1","type":"function"},{"doc":"","ref":"ExTeal.WelcomeDashboard.html#title/0","title":"ExTeal.WelcomeDashboard.title/0","type":"function"},{"doc":"","ref":"ExTeal.WelcomeDashboard.html#uri/0","title":"ExTeal.WelcomeDashboard.uri/0","type":"function"},{"doc":"# Fields","ref":"fields.html","title":"Fields","type":"extras"},{"doc":"Each Teal resource contains a `fields/0` callback.  This function should return an array of fields, which\ngenerally are built upon the `ExTeal.Field` struct.  Teal ships with a variety of fields, including fields\nfor text inputs, booleans, dates, rich text, and more.\n\nTo add a field to a resource, simple add it to the resources `fields/0`\nfunction.  Typically, fields are created using their `make/2` function.  Teal\ngenerally expects that the first arugment is an atom representing the key on the\nschema that Teal is representing, and the second is a human readable string that\nis used as a label for the field:\n\n\n```elixir\nalias ExTeal.Fields.{Boolean, Text}\n\n@impl true\ndef fields, do: [\n  Boolean.make(:published),\n  Text.make(:full_name, \"User Name\")\n]\n```","ref":"fields.html#defining-fields","title":"Defining Fields - Fields","type":"extras"},{"doc":"Often, you will only want to display a field in certain situations.  For\nexample, there is typically no need to show a `Password` field on a resource\nindex listing.  Likewise, you may wish to only display a `Inserted At` timestamp\non the create / update forms.  Teal makes it a breeze to hide / show fields on\ncertain pages.\n\nThe following methods are imported to each module that uses `ExTeal.Resource`\nand are contained in `ExTeal.FieldVisibility`:\n\n* `show_on_index/1`\n* `hide_from_index/1`\n* `hide_from_detail/1`\n* `hide_when_updating/1`\n* `hide_when_creating/1`\n* `only_on_details/1`\n* `only_on_forms/1`\n* `only_on_index/1`\n* `except_on_forms/1`\n\nYou can pipe these functions onto any field `make` definition to instruct Teal\nwhere the field should be displayed:\n\n```elixir\nText.make(:full_name) |> hide_from_index()\n```","ref":"fields.html#showing-hiding-fields","title":"Showing / Hiding Fields - Fields","type":"extras"},{"doc":"Teal has support for managing data represented on your schemas as both\n`embeds_one` and `embeds_many` embedded schemas:\n\n```elixir\ndefmodule YourAppWeb.ExTeal.PostResource do\n  use ExTeal.Resource\n\n  alias ExTeal.Fields.{EmbedsMany, Select, Text}\n\n  @impl true\n  def fields do\n    [\n      Text.make(:first_name),\n      Text.make(:last_name),\n      EmbedsMany.make(:mailing_addresses)\n      |> EmbedsMany.fields([\n        Text.make(:address_line_1),\n        Text.make(:city),\n        Select.make(:state) |> Select.options(states()),\n        Text.make(:zip_code)\n      ])\n    ]\n  end\nend\n```\n\nTeal also supports nested `EmbedsMany` fields:\n\n```elixir\nalias ExTeal.Fields.{Boolean, EmbedsMany, Number, Text}\n\nEmbedsMany.make(:line_items)\n|> EmbedsMany.fields([\n  Number.make(:quantity),\n  Text.make(:item_name),\n  EmbedsMany.make(:customizations)\n  |> EmbedsMany.fields([\n    Boolean.make(:validated),\n    Number.make(:price)\n  ])\n])\n```","ref":"fields.html#embedded-fields","title":"Embedded Fields - Fields","type":"extras"},{"doc":"# Policies\n\nPolicies are a way of controlling access to resources within Teal.","ref":"policies.html","title":"Policies","type":"extras"},{"doc":"The default policy is `ExTeal.OpenEverywherePolicy`, which has the following implementations:\n\n```elixir\n# Resource level permissions\ndef create_any?(_conn), do: true\ndef view_any?(_conn), do: true\ndef update_any?(_conn), do: true\ndef delete_any?(_conn), do: true\n\n# Resource item level permissions\ndef view?(_conn, _item), do: true\ndef update?(_conn, _item), do: true\ndef delete?(_conn, _item), do: true\n```\n\nTo change the default policy, create a new policy module e.g:\n\n```elixir\n# lib/my_app_web/ex_teal/closed_everywhere_policy.ex\n\ndefmodule MyAppWeb.ExTeal.ClosedEverywherePolicy do\n  use ExTeal.Policy\n\n  def create_any?(_conn), do: false\n  def view_any?(_conn), do: false\n  def update_any?(_conn), do: false\n  def delete_any?(_conn), do: false\n\n  def view?(_conn, _item), do: false\n  def update?(_conn, _item), do: false\n  def delete?(_conn, _item), do: false\nend\n\n```\n\nThen set it in your manifest:\n\n```elixir\n# lib/my_app_web/ex_teal/manifest.ex\n\ndefmodule MyAppWeb.ExTeal.Manifest do\n  use ExTeal.Manifest\n  \n  # ...\n\n  def default_policy, do: MyAppWeb.ExTeal.ClosedEverywherePolicy\n  \n  # ...\nend\n\n```","ref":"policies.html#default-policy","title":"Default policy - Policies","type":"extras"},{"doc":"You can override the policy at the resource level by implementing the `policy/0` callback\n\n```elixir\n# lib/my_app_web/ex_teal/resources/thing_resource.ex\n\ndefmodule MyAppWeb.ExTeal.ThingResource do\n  use ExTeal.Resource\n  \n  alias ExTeal.Fields.{\n    ID,\n    Text\n  }\n\n  def policy, do: MyAppWeb.ExTeal.ThingPolicy\n\n  # ...\n\n  def fields,\n    do: [\n      ID.make(:id),\n      Text.make(:title),\n    ]\nend\n```\n\nLets create that resource policy:\n\n```elixir\n# lib/my_app_web/ex_teal/thing_policy.ex\n\ndefmodule MyAppWeb.ExTeal.ThingPolicy do\n  use ExTeal.Policy\n\n  # Only allow the super_admin role to interact with \"Thing\"s\n\n  def create_any?(conn) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def view_any?(conn) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def update_any?(conn) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def delete_any?(conn) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def view?(conn, _thing) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def update?(conn, _thing) do\n    conn.assigns.current_user.role == :super_admin\n  end\n\n  def delete?(conn, _thing) do\n    conn.assigns.current_user.role == :super_admin\n  end\nend\n```","ref":"policies.html#resource-policies","title":"Resource Policies - Policies","type":"extras"},{"doc":"# ExTeal","ref":"readme.html","title":"ExTeal","type":"extras"},{"doc":"Add ExTeal as a dependency in your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:ex_teal, \"~> 0.25\"}\n  ]\nend\n```\n\nand configure Teal in `config/config.exs`:\n\n```\n# config/config.exs\n\nconfig :ex_teal,\n  repo: YourApp.Repo,\n  manifest: YourAppWeb.ExTeal.Manifest\n```\n\nTeal scales as your business logic scales so we recommend adding a `ex_teal`\ndirectory in the web directory of your phoenix app to store teal resources,\ncards, dashboards and other files.  Start your app with an empty manifest:\n\n\n```elixir\ndefmodule YourAppWeb.ExTeal.Manifest do\n  use ExTeal.Manifest\n  alias YourAppWeb.Endpoint\n\n  def application_name, do: \"Your cool app name\"\n\n  def logo_image_path, do: \"#{Endpoint.url()}/images/favicon.png\"\n\n  def resources, do: []\n\n  def plugins, do: []\n\n  # defaults to /teal\n  def path, do: \"/admin\"\nend\n```\n\nand use your router to expose Teal to the web (guarding with appropriate\npipelines for authentication and authorization.\n\n```elixir\n  # lib/your_app_web/router.ex\n  scope path: \"/admin\" do\n    pipe_through [:browser, :authenticated]\n    forward(\"/\", ExTeal.Router, namespace: \"admin\")\n  end\n```\n\nVisit `/admin` as an authenticated user and see all the cool :rocket:","ref":"readme.html#installation","title":"Installation - ExTeal","type":"extras"},{"doc":"Update a project that uses Teal to point to your local repo:\n\n```elixir\n\n\n  defp deps do\n    [\n      {:ex_teal, path: \"../ex_teal\"}\n    ]\n```\n\nIn the same project's `dev` config, configure Teal to use `vue-cli` generated\nassets rather than the compiled assets.\n\n```elixir\nconfig :ex_teal, compiled_assets: false\n```\n\n\nIn your local teal `assets/` folder, host the assets by running `yarn && yarn dev`","ref":"readme.html#developing-teal","title":"Developing Teal - ExTeal","type":"extras"},{"doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.27.2](https://github.com/township-agency/ex_teal/compare/v0.27.1...v0.27.2) (2023-11-16)\n\n\n#","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* BelongsTo Form disabled when it should be editable on new forms ([#242](https://github.com/township-agency/ex_teal/issues/242)) ([1122441](https://github.com/township-agency/ex_teal/commit/1122441012c07063b0e26b7f8121998b08441bf3))\n\n## [0.27.1](https://github.com/township-agency/ex_teal/compare/v0.27.0...v0.27.1) (2023-11-15)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* BelongsTo Form fields should only be prefilled on create ([#239](https://github.com/township-agency/ex_teal/issues/239)) ([fe895af](https://github.com/township-agency/ex_teal/commit/fe895af01b56cec8502cd6b572a59ce0849513ab))\n\n## [0.27.0](https://github.com/township-agency/ex_teal/compare/v0.26.0...v0.27.0) (2023-10-06)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Rich Text File Uploads ([#218](https://github.com/township-agency/ex_teal/issues/218)) ([8e37355](https://github.com/township-agency/ex_teal/commit/8e37355a759767df64f984db31098832dba94ce0))\n\n## [0.26.0](https://github.com/township-agency/ex_teal/compare/v0.25.1...v0.26.0) (2023-09-27)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Support embedded many schemas ([#215](https://github.com/township-agency/ex_teal/issues/215)) ([55bdc65](https://github.com/township-agency/ex_teal/commit/55bdc65919b6632a5dcf33da4576fe35b3ec308b))\n\n## [0.25.1](https://github.com/township-agency/ex_teal/compare/v0.25.0...v0.25.1) (2023-08-11)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Add permissions to Delete Menu on Resource Index ([40faef1](https://github.com/township-agency/ex_teal/commit/40faef19f31f4f52c7df3523515a3099debe8866))\n\n## [0.25.0](https://github.com/township-agency/ex_teal/compare/v0.24.0...v0.25.0) (2023-07-20)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* More Many-To-Many customization ([35039ab](https://github.com/township-agency/ex_teal/commit/35039ab518068135a1444806aac8391c32840c49))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* index queries filtered by a relationship should still use virtual fields for sorting ([3ad1ea7](https://github.com/township-agency/ex_teal/commit/3ad1ea754f5b74fc8bdd62de38d6862c56e60417))\n\n## [0.24.0](https://github.com/township-agency/ex_teal/compare/v0.23.1...v0.24.0) (2023-07-14)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Support Has Many Through Relationships ([26d4187](https://github.com/township-agency/ex_teal/commit/26d4187361a43c9145db4f6472ab2681568d61fd))\n\n## [0.23.1](https://github.com/township-agency/ex_teal/compare/v0.23.0...v0.23.1) (2023-07-10)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Serializer should consider errors where the key is an array ([#205](https://github.com/township-agency/ex_teal/issues/205)) ([59953fc](https://github.com/township-agency/ex_teal/commit/59953fc6927a2f9bfce1e23f1207c6c87a5b5a37))\n\n## [0.23.0](https://github.com/township-agency/ex_teal/compare/v0.22.2...v0.23.0) (2023-07-07)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Customize the index fields on a has many field ([#197](https://github.com/township-agency/ex_teal/issues/197)) ([4a2dde1](https://github.com/township-agency/ex_teal/commit/4a2dde1d7600a55dc14c9d427016df1de18f6749))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* except on forms should only touch forms ([#202](https://github.com/township-agency/ex_teal/issues/202)) ([fbd489b](https://github.com/township-agency/ex_teal/commit/fbd489b4f2d2f5e99964fa3ba23818a70be6d62b))\n* Surface BelongsTo Errors in form validation errors, move ex-teal-js code ([#201](https://github.com/township-agency/ex_teal/issues/201)) ([6542f67](https://github.com/township-agency/ex_teal/commit/6542f676209d160bd4aaa5f5455bc79bb6269427))\n* virtual fields should just mark themselves virtual, do not force field visibility ([#204](https://github.com/township-agency/ex_teal/issues/204)) ([479cc35](https://github.com/township-agency/ex_teal/commit/479cc357fa418602578f326e95938275c7850912))\n\n## [0.22.2](https://github.com/township-agency/ex_teal/compare/v0.22.1...v0.22.2) (2023-06-30)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* BelongsTo fields should not assume an non-nil value ([#198](https://github.com/township-agency/ex_teal/issues/198)) ([90f9bbf](https://github.com/township-agency/ex_teal/commit/90f9bbff38dab6cd274d39506835f6887671f109))\n* Default Field filters should always apply on initialization, not just initially ([#200](https://github.com/township-agency/ex_teal/issues/200)) ([9707662](https://github.com/township-agency/ex_teal/commit/9707662c729984f0331150f869463128a61e851b))\n\n## [0.22.1](https://github.com/township-agency/ex_teal/compare/v0.22.0...v0.22.1) (2023-06-16)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* BelongsTo polish ([#193](https://github.com/township-agency/ex_teal/issues/193)) ([99d1c55](https://github.com/township-agency/ex_teal/commit/99d1c551ef3f92d6e69cdf8d22f661484c67aaea))\n\n## [0.22.0](https://github.com/township-agency/ex_teal/compare/v0.21.0...v0.22.0) (2023-06-15)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Dashboard Resource Table, Virtual Aggregates ([#189](https://github.com/township-agency/ex_teal/issues/189)) ([03273a2](https://github.com/township-agency/ex_teal/commit/03273a2ba591b0a53eca6eed08744641a378a224))\n\n## [0.21.0](https://github.com/township-agency/ex_teal/compare/v0.20.1...v0.21.0) (2023-05-25)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Add a Greeting Card, enabled by adding a conn argument to options on Card ([#186](https://github.com/township-agency/ex_teal/issues/186)) ([48180d8](https://github.com/township-agency/ex_teal/commit/48180d83ed6807641301b902253e10b40f139be8))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* reset the detail page when resources change so that cards are not persisted ([#183](https://github.com/township-agency/ex_teal/issues/183)) ([b04d582](https://github.com/township-agency/ex_teal/commit/b04d582d536abb18c2235abf48125627d378d6f2))\n\n## [0.20.1](https://github.com/township-agency/ex_teal/compare/v0.20.0...v0.20.1) (2023-04-19)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Allow Distinct in `handle_index/2` callbacks ([#181](https://github.com/township-agency/ex_teal/issues/181)) ([f7e8ada](https://github.com/township-agency/ex_teal/commit/f7e8adacbe55a7ca38111f956c2ce075be32fffb))\n\n## [0.20.0](https://github.com/township-agency/ex_teal/compare/v0.19.4...v0.20.0) (2023-04-11)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Introduce can_see?/2 to add field specific authorization ([1d52b6b](https://github.com/township-agency/ex_teal/commit/1d52b6bc7399d2242f794333fae470d56f66656f))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Panels were lost in the see_more/2 release ([d28fa73](https://github.com/township-agency/ex_teal/commit/d28fa737e5786bcc46765e0045ce7b03f87c01c9))\n* Separate Query Preloads from records/2 call ([a6026f9](https://github.com/township-agency/ex_teal/commit/a6026f9896ab8de3ab8f2ca6891f83c78d40e5e3))\n\n## [0.19.4](https://github.com/township-agency/ex_teal/compare/v0.19.3...v0.19.4) (2023-04-04)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* compare, display and use select values in field filters ([ffb7d87](https://github.com/township-agency/ex_teal/commit/ffb7d8796da37a6a1f2bc971f1dc9ad2d0695812))\n* **deps:** upgrade nimble csv ([#174](https://github.com/township-agency/ex_teal/issues/174)) ([21a3dd4](https://github.com/township-agency/ex_teal/commit/21a3dd4d621d274bc06135930113395edbd8163c))\n* embedded schema filtering may not be possible with postgres due to json magic ([8e28eeb](https://github.com/township-agency/ex_teal/commit/8e28eebb27d08c66482fcad990f9acb050f9212b))\n\n## [0.19.3](https://github.com/township-agency/ex_teal/compare/v0.19.2...v0.19.3) (2023-03-31)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* default panel title and flatten panels while sorting ([#172](https://github.com/township-agency/ex_teal/issues/172)) ([66db8c0](https://github.com/township-agency/ex_teal/commit/66db8c00294e677bce94835da55c74bee56fa265))\n\n## [0.19.2](https://github.com/township-agency/ex_teal/compare/v0.19.1...v0.19.2) (2023-03-31)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Allow users to customize the singular name of a resource for when naming is hard ([#169](https://github.com/township-agency/ex_teal/issues/169)) ([d1075bb](https://github.com/township-agency/ex_teal/commit/d1075bb52dc98e0455b5e96ee5fb7ee6c26f75c3))\n\n## [0.19.1](https://github.com/township-agency/ex_teal/compare/v0.19.0...v0.19.1) (2023-03-29)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* add some styles for direct upload ([#167](https://github.com/township-agency/ex_teal/issues/167)) ([9809763](https://github.com/township-agency/ex_teal/commit/9809763e3c4c9328e6b81cee1ce1885a1156d8b6))\n\n## [0.19.0](https://github.com/township-agency/ex_teal/compare/v0.18.0...v0.19.0) (2023-03-28)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Embedded Resources and Panel Upgrades ([#164](https://github.com/township-agency/ex_teal/issues/164)) ([b5d75e0](https://github.com/township-agency/ex_teal/commit/b5d75e0c1788e4e58137a9c32482b6679f690e63))\n\n## [0.18.0](https://github.com/township-agency/ex_teal/compare/v0.17.1...v0.18.0) (2023-03-22)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Elixir Version Bump and add default field filters ([#155](https://github.com/township-agency/ex_teal/issues/155)) ([ae3408a](https://github.com/township-agency/ex_teal/commit/ae3408a4103c00748fbb6e11f65b12fa3a1c8cb9))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* table row should acknowledge resource permissions ([#154](https://github.com/township-agency/ex_teal/issues/154)) ([71e5e4c](https://github.com/township-agency/ex_teal/commit/71e5e4ccd6a8074c857c110b98749c28f223ace4))\n\n### [0.17.1](https://www.github.com/township-agency/ex_teal/compare/v0.17.0...v0.17.1) (2022-06-17)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* array field wouldn't save empty value ([#145](https://www.github.com/township-agency/ex_teal/issues/145)) ([ef09ca2](https://www.github.com/township-agency/ex_teal/commit/ef09ca2f794aeced061ccb65d6bda0d1552852b3))\n\n## [0.17.0](https://www.github.com/township-agency/ex_teal/compare/v0.16.4...v0.17.0) (2022-01-20)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Add Rich MultiSelect functionality ([7c39bf7](https://www.github.com/township-agency/ex_teal/commit/7c39bf7d9346aa49c5897b503a449b237ede52f3))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* show empty status ([09297df](https://www.github.com/township-agency/ex_teal/commit/09297df8cbdbaaad3d2f91e938656c2c9dc29568))\n\n### [0.16.4](https://www.github.com/township-agency/ex_teal/compare/v0.16.3...v0.16.4) (2021-11-11)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* All fields should include subfields nested in a field ([75de0fc](https://www.github.com/township-agency/ex_teal/commit/75de0fc0109fe33ec9eafd82a5b844d97cfc148c))\n* ManyToManys with Pivot Fields should use the child key when the model is the pivot schema, not the child schema ([6dc6aec](https://www.github.com/township-agency/ex_teal/commit/6dc6aec1a7b771d8fb26fcc09fb334e0d2562fc2))\n\n### [0.16.3](https://www.github.com/township-agency/ex_teal/compare/v0.16.2...v0.16.3) (2021-10-19)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* BooleanGroup options changed ([189027e](https://www.github.com/township-agency/ex_teal/commit/189027eb9a362f3d0e1f7c6f80beb9798f40674a))\n\n### [0.16.2](https://www.github.com/township-agency/ex_teal/compare/v0.16.1...v0.16.2) (2021-10-06)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Resource responder was using the incorrect function signature for Fields.apply_values/5 ([1780a67](https://www.github.com/township-agency/ex_teal/commit/1780a672eaad433a0f79c65a5db5771dc7e72373))\n\n### [0.16.1](https://www.github.com/township-agency/ex_teal/compare/v0.16.0...v0.16.1) (2021-10-01)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* BelongsTo and SearchInput need valid props and disabled mode ([#123](https://www.github.com/township-agency/ex_teal/issues/123)) ([cc5dd8b](https://www.github.com/township-agency/ex_teal/commit/cc5dd8b0fca05e5ef427b4412b76844a600cc1f5))\n\n## [0.16.0](https://www.github.com/township-agency/ex_teal/compare/v0.15.1...v0.16.0) (2021-09-13)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* add individual resource policies ([#114](https://www.github.com/township-agency/ex_teal/issues/114)) ([b660f73](https://www.github.com/township-agency/ex_teal/commit/b660f7349905dc1842132d97cf9c3b0e3233644a))\n\n### [0.15.1](https://www.github.com/township-agency/ex_teal/compare/v0.15.0...v0.15.1) (2021-08-12)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* show errors on array form ([0d4e9d6](https://www.github.com/township-agency/ex_teal/commit/0d4e9d6bf9191419ab4b3efda2517f2092be65b8))\n\n## [0.15.0](https://www.github.com/township-agency/ex_teal/compare/v0.14.1...v0.15.0) (2021-06-08)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* New Boolean Group Options functionality ([f79e867](https://www.github.com/township-agency/ex_teal/commit/f79e86780c6f13a062597743ea07c3e1f403b442))\n\n### [0.14.1](https://www.github.com/township-agency/ex_teal/compare/v0.14.0...v0.14.1) (2021-05-21)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Clean up compiler warnings in 1.11 versions of Elixir ([836de32](https://www.github.com/township-agency/ex_teal/commit/836de3290f89050abb51bdb86121eb6b7da53b7f))\n* Invalid Typespecs from default functions on Trend Metrics ([0eb02fd](https://www.github.com/township-agency/ex_teal/commit/0eb02fd95c89107b13747f8baa66d9169087f4da))\n\n## [0.14.0](https://www.github.com/township-agency/ex_teal/compare/v0.13.2...v0.14.0) (2021-05-18)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Select fields can represent Ecto.Enums ([5823c9f](https://www.github.com/township-agency/ex_teal/commit/5823c9f125e103db7c498050021b99e86d9fa157))\n\n### [0.13.2](https://www.github.com/township-agency/ex_teal/compare/v0.13.1...v0.13.2) (2021-05-12)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Number fields are now represented as string fields, parse them to integers before reordering ([4a91569](https://www.github.com/township-agency/ex_teal/commit/4a91569edfa11d3d58bf7d98e4da5068d0639053))\n\n### [0.13.1](https://www.github.com/township-agency/ex_teal/compare/v0.13.0...v0.13.1) (2021-05-11)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* cast fields to string for simple search ([2e6637d](https://www.github.com/township-agency/ex_teal/commit/2e6637dc917066b6ac94704a6e0262d302f4014c))\n\n## [0.13.0](https://www.github.com/township-agency/ex_teal/compare/v0.12.5...v0.13.0) (2021-05-07)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* As a user, I should be able to search a resource by the primary id ([c129c97](https://www.github.com/township-agency/ex_teal/commit/c129c97f0fe010ae0c7f04630bc76459935f06ad))\n* BelongsTo should always be searchable ([defbda6](https://www.github.com/township-agency/ex_teal/commit/defbda6a44a7b78f41311c12dcb2a5ba7953a6a8))\n* Upgrade Number Field ([3a61e4d](https://www.github.com/township-agency/ex_teal/commit/3a61e4d8e920a7b499203e885cfacfe7634c1e23))\n\n### [0.12.5](https://www.github.com/township-agency/ex_teal/compare/v0.12.4...v0.12.5) (2021-04-23)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Broken tests due to timezone offsets ([e7e0b47](https://www.github.com/township-agency/ex_teal/commit/e7e0b476aea228e28c467a6f40980e6e0169394b))\n* Broken Type Specs ([e3673a9](https://www.github.com/township-agency/ex_teal/commit/e3673a995198787b601f68d7fd34cf59fd0ba215))\n\n### [0.12.4](https://www.github.com/township-agency/ex_teal/compare/v0.12.3...v0.12.4) (2021-02-03)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Cannot return multi in handle create ([#51](https://www.github.com/township-agency/ex_teal/issues/51)) ([7aaabf1](https://www.github.com/township-agency/ex_teal/commit/7aaabf11315095a28807f0627a29a8fff3579133))\n\n### [0.12.3](https://www.github.com/township-agency/ex_teal/compare/v0.12.2...v0.12.3) (2020-12-14)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Delete requests should use the correct params ([331b996](https://www.github.com/township-agency/ex_teal/commit/331b99661aa99cd180a20e8abb4f4a897bbb42b4))\n\n### [0.12.2](https://www.github.com/township-agency/ex_teal/compare/v0.12.1...v0.12.2) (2020-12-14)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Deleting with 'select all' was not including relationships ([8945a1b](https://www.github.com/township-agency/ex_teal/commit/8945a1bd4e9c5d9fcdffafd86083fb15a9c9e7de))\n\n### [0.12.1](https://www.github.com/township-agency/ex_teal/compare/v0.12.0...v0.12.1) (2020-12-03)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* The Naive DateTime Picker was using the incorrect month token ([780146b](https://www.github.com/township-agency/ex_teal/commit/780146bbab1b81bc7fea7083b549f53ee28837ac))\n\n## [0.12.0](https://www.github.com/township-agency/ex_teal/compare/v0.11.2...v0.12.0) (2020-11-18)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Select refactor ([#43](https://www.github.com/township-agency/ex_teal/issues/43)) ([667dbd9](https://www.github.com/township-agency/ex_teal/commit/667dbd9b7d7e27ad1ae848c657d6d2988b8c8fef))\n\n### [0.11.2](https://www.github.com/township-agency/ex_teal/compare/v0.11.1...v0.11.2) (2020-11-17)\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Action Relationship Params are non-empty ([#41](https://www.github.com/township-agency/ex_teal/issues/41)) ([592c220](https://www.github.com/township-agency/ex_teal/commit/592c220b8f4a2d59405dc915169cf450e6265848))\n\n### [0.11.1](https://www.github.com/township-agency/ex_teal/compare/v0.11.0...v0.11.1) (2020-11-13)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Fix Naive DateTime Selector ([#39](https://www.github.com/township-agency/ex_teal/issues/39)) ([226b8c4](https://www.github.com/township-agency/ex_teal/commit/226b8c4b35ab007bc35545b504e6e772745c87cc))\n\n## [0.11.0](https://www.github.com/township-agency/ex_teal/compare/v0.10.4...v0.11.0) (2020-11-04)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Enable Naive DateTime Fields ([4b96d70](https://www.github.com/township-agency/ex_teal/commit/4b96d70b68871f4d6141b456b2e906605b459a1f)), closes [#36](https://www.github.com/township-agency/ex_teal/issues/36)\n* Update BooleanGroup for ecto 3.5 ([#35](https://www.github.com/township-agency/ex_teal/issues/35)) ([49228f0](https://www.github.com/township-agency/ex_teal/commit/49228f08e15f5a8b473079b8d02b7023b0e491be))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Day Light Savings brittle tests ([a5f7261](https://www.github.com/township-agency/ex_teal/commit/a5f7261c281418ffe65603a723e7440f03c15254))\n\n### [0.10.4](https://www.github.com/township-agency/ex_teal/compare/v0.10.3...v0.10.4) (2020-10-27)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Enable ex_teal_dependency_container to include it's params. ([#33](https://www.github.com/township-agency/ex_teal/issues/33)) ([f96edc2](https://www.github.com/township-agency/ex_teal/commit/f96edc2a309ce6a1c3825a1f8e0cefc3f20a774e))\n\n### [0.10.3](https://www.github.com/township-agency/ex_teal/compare/v0.10.2...v0.10.3) (2020-10-14)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Use the correct select props and events for the non-searchable attach view ([#30](https://www.github.com/township-agency/ex_teal/issues/30)) ([d17e02d](https://www.github.com/township-agency/ex_teal/commit/d17e02d6e17eb4eff7c17faf1b738a87ac77eb1e))\n* Value Format should be a string, not charlist ([#31](https://www.github.com/township-agency/ex_teal/issues/31)) ([e2d8137](https://www.github.com/township-agency/ex_teal/commit/e2d8137db56ebade99d3a813799f56fb9bff193c))\n\n### [0.10.2](https://www.github.com/township-agency/ex_teal/compare/v0.10.1...v0.10.2) (2020-10-09)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Query Params need to be snake cased ([#28](https://www.github.com/township-agency/ex_teal/issues/28)) ([e48a952](https://www.github.com/township-agency/ex_teal/commit/e48a9529c0c584e5297917365622377b6f133460))\n\n### [0.10.1](https://www.github.com/township-agency/ex_teal/compare/v0.10.0...v0.10.1) (2020-10-09)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Actions should use all index filtering tools when building a query ([9c55bcf](https://www.github.com/township-agency/ex_teal/commit/9c55bcfcb00fe6ea5e6bd6450176d8d5caa20f71))\n* Include the version.txt in the release ([6ecf7d7](https://www.github.com/township-agency/ex_teal/commit/6ecf7d7ffaad5f2d55708e63f59aed45703b5ecd))\n\n## [0.10.0](https://www.github.com/township-agency/ex_teal/compare/0.9.3...v0.10.0) (2020-09-16)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Trend and Value metrics should use formatting ([89797bd](https://www.github.com/township-agency/ex_teal/commit/89797bd3231637722290ccda82431072e75a3750))\n\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Adjust partition metric size ([0bffd66](https://www.github.com/township-agency/ex_teal/commit/0bffd66db9cf79840b7aca79cdf428f1ffd5197c))\n* Card Wrapper xl window size was being purged ([#21](https://www.github.com/township-agency/ex_teal/issues/21)) ([7c3f977](https://www.github.com/township-agency/ex_teal/commit/7c3f977d831cadabd1e7979a71bcfa355b2af943))\n* Fix compile warning ([9299be5](https://www.github.com/township-agency/ex_teal/commit/9299be5510575288df0fb6f213c15eb5c9a05b88))\n\n### [0.9.3](https://github.com/township-agency/ex_teal/compare/0.9.2...0.9.3) (2020-08-26)\n\n##","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Partition Metrics\n* Teal Themes\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Darken h3 side-nav headers\n* Card Wrapper was losing it's xl break points\n\n### [0.9.2](https://github.com/township-agency/ex_teal/compare/0.9.1...0.9.2) (2020-08-26)\n\n##","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Metric Style Improvements\n* Metrics have their own time controls again\n* Time controls are configurable per metric.\n\n### [0.9.1](https://github.com/township-agency/ex_teal/compare/0.9.0...0.9.1) (2020-08-24)\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* New Boolean Group Field\n\n### [0.9.0](https://github.com/township-agency/ex_teal/compare/0.8.8...0.9.0) (2020-07-28)\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* A complete rewrite of Metrics to introduce `Trend` metrics.\n\n\n### [0.8.8](https://github.com/township-agency/ex_teal/compare/0.8.7...0.8.8) (2020-06-22)\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Empty `HasOne` fields threw an error.\n\n### [0.8.7](https://github.com/township-agency/ex_teal/compare/v0.8.6...v0.8.7) (2020-06-20)\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* Invalid 204 Status\n\n### [0.8.6](https://github.com/township-agency/ex_teal/compare/v0.8.5...v0.8.6) (2020-06-19)\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"* HasOne Index Field had a bad url ([af5c411](https://github.com/township-agency/ex_teal/commit/af5c411ec5483b57571e34b49cedf104919437c3))\n* UpdateAttached does not function. ([#8](https://github.com/township-agency/ex_teal/issues/8)) ([d4aee01](https://github.com/township-agency/ex_teal/commit/d4aee01e871299f149b7fad7760352f39ffa8159)), closes [#9](https://github.com/township-agency/ex_teal/issues/9)\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-8-5-2020-06-15","title":"0.8.5 (2020-06-15) - Changelog","type":"extras"},{"doc":"* **export:** Configurable export ([#4](https://github.com/township-agency/ex_teal/issues/4)) ([4fccd4d](https://github.com/township-agency/ex_teal/commit/4fccd4df3abf63ec29db5ea765b7667bc59400a7))\n\n#","ref":"changelog.html#features","title":"Features - Changelog","type":"extras"},{"doc":"* Resources with panels were broken ([aaaa485](https://github.com/township-agency/ex_teal/commit/aaaa48521d9c36f0f75b7bbbe91491af0b6b3bc3))\n* Use Dialyxir in Test ([#5](https://github.com/township-agency/ex_teal/issues/5)) ([ef28bc9](https://github.com/township-agency/ex_teal/commit/ef28bc90116186b163ba7e353cf2647d28e2a1ad))\n\n## [0.8.4] - 2020-05-26\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes - Changelog","type":"extras"},{"doc":"- Forgot to compile assets\n\n## [0.8.3] - 2020-05-26\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Changed the function arguments for search.\n\n## [0.8.2] - 2020-05-11\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- The Many To Many Attach view can now use searchable relationships.\n- Unified UX and engineering ergonomics for searchable results.\n\n## [0.8.1] - 2020-05-07\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Updated Download Icon\n- Export file name now uses the resources uri rather then it's title\n\n## [0.8.0] - 2020-05-06\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"Teal has removed the concept of static, per-field filters for automatically\nbuild `field_filters`.  These filters can now be combined, extended and can use\nfar more advanced and useful customizable operators.\n\n- New dynamic filters.  See below for required changes.\n- New Table UX\n- Export as a CSV\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"To update to 0.8.0:\n\n1. Remove the `filters/0` functions from your resources\n2. Remove old filters\n3. If you need to extend the logic of the included field filters, use the\n   `ExTeal.Field.filter_as/2` function to modify the appropriate field and\n   define a custom module that implements the behaviour of\n   `ExTeal.FieldFilter`\n\n## [0.7.9] - 2020-04-13\n\n#","ref":"changelog.html#depreciated","title":"Depreciated - Changelog","type":"extras"},{"doc":"- An Empty MultiSelect Form\n\n## [0.7.8] - 2020-04-02\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Help Text\n\n## [0.7.7] - 2020-03-25\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Ability to override the default search tool.\n\n## [0.7.6] - 2020-02-11\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Ability to skip the sanitizers on a per resource basis.\n\n## [0.7.5] - 2020-02-03\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Action queries now use the `Index` functionality for preloads.\n\n## [0.7.4] - 2020-01-23\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Adds the `ActionResponse` struct that allows completed actions to change the\n    user interface.\n\n## [0.7.3] - 2020-01-09\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"- Fixes a regression in the update to `apply_options_for` for `update`\n\n## [0.7.2] - 2020-01-09\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Fixes a regression in the update to `apply_options_for` for the create-fields\n\n## [0.7.1] - 2020-01-09\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Fixes a regression in the update to `apply_options_for`\n\n## [0.7.0] - 2020-01-09\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- [breaking] Changes `ExTeal.Field.apply_options_for` to accept a third\n    argument.  See [!77](https://gitlab.motel-lab.com/Teal/ex_teal/merge_requests/77)\n\n## [0.6.1] - 2020-01-09\n\n#","ref":"changelog.html#breaking-changes","title":"Breaking Changes - Changelog","type":"extras"},{"doc":"- Adds a `default_order` callback to the resource to allow engineers to define\n    the default order of a resource.\n\n## [0.6.0] - 2020-01-06\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- Adds a `dropdown_content` function to the `AuthProvider`.\n- Adds an `Array` field\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- [breaking] Changes `gravatar` to `avatar_url` for the current_user map\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"- Cleans up the spec for `current_user_for`\n\n## [0.5.0] - 2019-12-09\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- DateTime field\n- `luxon` datetime library\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- `date-fns` date parsing\n\n#","ref":"changelog.html#removes","title":"Removes - Changelog","type":"extras"},{"doc":"- Refactors `Date`, and `DateTimePicker` fields\n\n#","ref":"changelog.html#changes","title":"Changes - Changelog","type":"extras"},{"doc":"- `Date.with_options/2` was depreciated in favor of `Date.format/2` and\n    `Date.picker_format/2`.  Will be removed in `1.0.0`\n\n## [0.4.4] - 2019-10-22\n\n#","ref":"changelog.html#depreciates","title":"Depreciates - Changelog","type":"extras"},{"doc":"- Excerpts were ignoring line breaks\n- Rich Text field content was being sanitized\n- Flatpickr date time styles were missing\n\n## [0.4.3] - 2019-10-11\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Broken Form submission when panels are used\n- Broken Address Fields\n\n## [0.4.2] - 2019-09-19\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- `as_html` field modifier\n- Computed fields with a new `get` field modifier\n\n## [0.4.1] - 2019-09-12\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- Dashboard was missing cards\n\n## [0.4.0] - 2019-09-05\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Value Metrics\n- Dashboards\n- A default dashboard\n- Pagination Labels to Resource Index Tables\n- Resource Index Tables can be searched\n- BelongsTo fields can be searched\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- An empty string is now sanitized to nil\n\n## [0.3.6] - 2019-08-06\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Styles for a better nav layout\n- Global Search was broken\n- Field visibility for Pivot Fields\n\n## [0.3.5] - 2019-07-26\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Don't attempt to sanitize non-bitstring params\n\n## [0.3.4] - 2019-07-26\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Edge Cases in new Attribute Logic\n\n## [0.3.3] - 2019-07-25\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Broken Router and CSRF Plugin\n\n## [0.3.2] - 2019-07-25\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Broken Dependencies\n\n## [0.3.1] - 2019-07-24\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- XSS Protection\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- Cleaned up Router\n\n## [0.3.0] - 2019-07-15\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- CSRF Protection (Thanks @lkoller)\n- ManyToMany Fields and Relationships with pivot fields and sorting.\n\n## [0.2.4] - 2019-06-26\n\n#","ref":"changelog.html#adds","title":"Adds - Changelog","type":"extras"},{"doc":"- Changed the HasOne field to be represented by a simplified resource index table.\n\n## [0.2.3] - 2019-06-25\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- HasOne Field\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Detail Page not changing if the ids are identical after switching resources\n\n\n## [0.2.2] - 2019-06-11\n\n#","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"- Broken Default Logo\n- Attributes that have \"null\" values should be transformed to `nil`\n\n## [0.2.1] - 2019-06-07\n\n#","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"- Teal Page Components\n\n## [0.2.0] - 2019-06-04\n\n#","ref":"changelog.html#removed","title":"Removed - Changelog","type":"extras"},{"doc":"- Boot Process for Plugins\n- Script and Style definitions for a Plugin\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Major rework of the front end.  If this wasn't pre-release software, it would\n    be considered a breaking change.\n\n## [0.1.8] - 2019-05-09\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- Simplified Mount Point\n\n## [0.1.7] - 2019-05-06\n\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- Color Picker\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Subtitles not displayed while searching\n- Broken default Teal logo in sidenav\n\n## [0.1.6] - 2019-03-08\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Additional, dropdown options for viewing more resources without pagination\n\n\n## [0.1.5] - 2019-01-14\n\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Missing `window.teal` in axios error interceptor\n- Aggressive `id` requirement that broke pages.\n\n## [0.1.4] - 2018-12-17\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"- Actions\n- Multi-Select on Index Views\n- New tool for easier development of teal alongside a parent app.\n- LiveReload and HMR while developing the Vue App\n#","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"- Upgraded Vue-CLI Dependencies\n- Applied new Vue-CLI Linter Rules\n#","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"- Broken Delete Icon on the ResourceTable\n\n## [0.1.3] - 2018-11-29\n\nFixes:\n- Missing Static Index File in production environments\n\n## [0.1.2] - 2018-11-28\n\nFixes:\n\n- Sets the correct location for the static index file\n\n## [0.1.1] - 2018-11-28\n\nAdds:\n\n- Client assets compiled for production.\n\n## [0.1.0] - 2018-11-28\n\n#","ref":"changelog.html#fixes","title":"Fixes - Changelog","type":"extras"},{"doc":"","ref":"changelog.html#initial-release","title":"Initial Release - Changelog","type":"extras"}]}