searchNodes=[{"doc":"ExTeal Actions allow you to perform one off tasks on your ExTeal Index resources with custom conditions. For example you might want to batch update a group of articles to a published state. Each ExTeal action should contain a commit/3 function. Fields have not been implemented yet The commit function is responsible for modifying the state of the application to achieve the desired actions. Let's look at the PublishAction action: defmodule PortfolioWeb.ExTeal.PublishAction do use ExTeal.Action alias ExTeal.ActionResponse def title , do : &quot;Publish&quot; / / defaults to Publish Action def key , do : &quot;publish&quot; / / default to publish - action def commit ( conn , fields , query ) do resources = Repo . all ( query ) / / having the raw query gives you the option to batch large requests . with { :ok , _results } &lt;- Portfolio.Content . publish ( resources ) do / / ideally the updates here are part of a Repo . transaction . ActionResponse . success ( &quot;Successfully published&quot; ) _ -&gt; ActionResponse . error ( &quot;Error publishing&quot; ) end end end The commit should return an ActionResponse struct. The ActionResponse types that are available are 'success', 'error', 'redirect', 'download' and 'push'.","ref":"ExTeal.Action.html","title":"ExTeal.Action","type":"behaviour"},{"doc":"","ref":"ExTeal.Action.html#action_for_key/2","title":"ExTeal.Action.action_for_key/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#actionable_query/2","title":"ExTeal.Action.actionable_query/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#apply_action/2","title":"ExTeal.Action.apply_action/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#build_for/2","title":"ExTeal.Action.build_for/2","type":"function"},{"doc":"","ref":"ExTeal.Action.html#c:commit/3","title":"ExTeal.Action.commit/3","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#error/1","title":"ExTeal.Action.error/1","type":"function"},{"doc":"Override the default key for the action","ref":"ExTeal.Action.html#c:key/0","title":"ExTeal.Action.key/0","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#message/1","title":"ExTeal.Action.message/1","type":"function"},{"doc":"","ref":"ExTeal.Action.html#c:options/1","title":"ExTeal.Action.options/1","type":"callback"},{"doc":"Override the default title for the action","ref":"ExTeal.Action.html#c:title/0","title":"ExTeal.Action.title/0","type":"callback"},{"doc":"","ref":"ExTeal.Action.html#t:action_responses/0","title":"ExTeal.Action.action_responses/0","type":"type"},{"doc":"Used to return the result of an action and specifies how the ux should respond","ref":"ExTeal.ActionResponse.html","title":"ExTeal.ActionResponse","type":"module"},{"doc":"Download a file at a specific url","ref":"ExTeal.ActionResponse.html#download/1","title":"ExTeal.ActionResponse.download/1","type":"function"},{"doc":"Display a custom 'error' message.","ref":"ExTeal.ActionResponse.html#error/1","title":"ExTeal.ActionResponse.error/1","type":"function"},{"doc":"Push the user to a new location in the vue app.","ref":"ExTeal.ActionResponse.html#push/1","title":"ExTeal.ActionResponse.push/1","type":"function"},{"doc":"Redirect the user to a url","ref":"ExTeal.ActionResponse.html#redirect/1","title":"ExTeal.ActionResponse.redirect/1","type":"function"},{"doc":"Display a custom 'success' message.","ref":"ExTeal.ActionResponse.html#success/1","title":"ExTeal.ActionResponse.success/1","type":"function"},{"doc":"","ref":"ExTeal.ActionResponse.html#t:t/0","title":"ExTeal.ActionResponse.t/0","type":"type"},{"doc":"API Responder that manages cards GET /dashboard/:name - Return the dashboard and it's cards GET /resource/:resource_name/cards - Return the cards for a resource","ref":"ExTeal.Api.CardResponder.html","title":"ExTeal.Api.CardResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.CardResponder.html#dashboard/2","title":"ExTeal.Api.CardResponder.dashboard/2","type":"function"},{"doc":"","ref":"ExTeal.Api.CardResponder.html#resource/2","title":"ExTeal.Api.CardResponder.resource/2","type":"function"},{"doc":"Translates a changeset into an error","ref":"ExTeal.Api.ErrorSerializer.html","title":"ExTeal.Api.ErrorSerializer","type":"module"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#flatten/1","title":"ExTeal.Api.ErrorSerializer.flatten/1","type":"function"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#handle_error/2","title":"ExTeal.Api.ErrorSerializer.handle_error/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ErrorSerializer.html#render/1","title":"ExTeal.Api.ErrorSerializer.render/1","type":"function"},{"doc":"Traverses and translates changeset errors. See Ecto.Changeset.traverse_errors/2","ref":"ExTeal.Api.ErrorSerializer.html#translate_errors/1","title":"ExTeal.Api.ErrorSerializer.translate_errors/1","type":"function"},{"doc":"API Responder that manages the many to many relationships via: GET attachable - Querying the potentially related POST attach - Adding a related resource DELETE detach - Removing a related resource GET creation-pivot-fields - Fetch the pivot fields associated with a relationship","ref":"ExTeal.Api.ManyToMany.html","title":"ExTeal.Api.ManyToMany","type":"module"},{"doc":"Given a request of POST /api/posts/1/attach/tags that contains a set of params like: %{ &quot;viaRelationship&quot; =&gt; &quot;tags&quot; , &quot;tags&quot; =&gt; &quot;2&quot; } This function attaches the tag with id 2 to the posts tags relationship.","ref":"ExTeal.Api.ManyToMany.html#attach/4","title":"ExTeal.Api.ManyToMany.attach/4","type":"function"},{"doc":"Given a request of GET /api/resource_uri/resource_id/attachable/field_name This function returns a response that contains the attachable schemas associated with the many to many relationship at field_name","ref":"ExTeal.Api.ManyToMany.html#attachable/4","title":"ExTeal.Api.ManyToMany.attachable/4","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many relationship. Fields are only for attaching to a many to many","ref":"ExTeal.Api.ManyToMany.html#creation_pivot_fields/3","title":"ExTeal.Api.ManyToMany.creation_pivot_fields/3","type":"function"},{"doc":"Given a request of DELETE /api/posts/1/attach/tags/2 that contains a set of params like: This function detaches the tag with id 2 from the posts tags relationship.","ref":"ExTeal.Api.ManyToMany.html#detach/4","title":"ExTeal.Api.ManyToMany.detach/4","type":"function"},{"doc":"Batch Updates a pivot schema's fields for reordering a relationship","ref":"ExTeal.Api.ManyToMany.html#reorder/4","title":"ExTeal.Api.ManyToMany.reorder/4","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many relationship for an existing relationship.","ref":"ExTeal.Api.ManyToMany.html#update_pivot/5","title":"ExTeal.Api.ManyToMany.update_pivot/5","type":"function"},{"doc":"Returns a list of fields associated with the pivot table of a many to many relationship for an existing relationship.","ref":"ExTeal.Api.ManyToMany.html#update_pivot_fields/5","title":"ExTeal.Api.ManyToMany.update_pivot_fields/5","type":"function"},{"doc":"API Responder for Metrics","ref":"ExTeal.Api.MetricResponder.html","title":"ExTeal.Api.MetricResponder","type":"module"},{"doc":"Return the metric based on it's uri for a dashboard","ref":"ExTeal.Api.MetricResponder.html#get/2","title":"ExTeal.Api.MetricResponder.get/2","type":"function"},{"doc":"Return a metric based on it's uri, resource and resource id","ref":"ExTeal.Api.MetricResponder.html#resource_detail/4","title":"ExTeal.Api.MetricResponder.resource_detail/4","type":"function"},{"doc":"Return a metric based on it's uri and the resource it's displayed on","ref":"ExTeal.Api.MetricResponder.html#resource_index/3","title":"ExTeal.Api.MetricResponder.resource_index/3","type":"function"},{"doc":"Simple Plug that routes a request to the appropriate plugin","ref":"ExTeal.Api.PluginResponder.html","title":"ExTeal.Api.PluginResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.PluginResponder.html#call/2","title":"ExTeal.Api.PluginResponder.call/2","type":"function"},{"doc":"","ref":"ExTeal.Api.PluginResponder.html#init/1","title":"ExTeal.Api.PluginResponder.init/1","type":"function"},{"doc":"Hands requests of a certain type to the appropriate resource, and returns the resources response as serialized json","ref":"ExTeal.Api.ResourceResponder.html","title":"ExTeal.Api.ResourceResponder","type":"module"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#actions_for/2","title":"ExTeal.Api.ResourceResponder.actions_for/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#commit_action/2","title":"ExTeal.Api.ResourceResponder.commit_action/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#create/2","title":"ExTeal.Api.ResourceResponder.create/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#creation_fields/2","title":"ExTeal.Api.ResourceResponder.creation_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#delete/2","title":"ExTeal.Api.ResourceResponder.delete/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#export/2","title":"ExTeal.Api.ResourceResponder.export/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#field/3","title":"ExTeal.Api.ResourceResponder.field/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#field_filters/2","title":"ExTeal.Api.ResourceResponder.field_filters/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#filters_for/2","title":"ExTeal.Api.ResourceResponder.filters_for/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#index/2","title":"ExTeal.Api.ResourceResponder.index/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#relatable/3","title":"ExTeal.Api.ResourceResponder.relatable/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#reorder/2","title":"ExTeal.Api.ResourceResponder.reorder/2","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#show/3","title":"ExTeal.Api.ResourceResponder.show/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#update/3","title":"ExTeal.Api.ResourceResponder.update/3","type":"function"},{"doc":"","ref":"ExTeal.Api.ResourceResponder.html#update_fields/3","title":"ExTeal.Api.ResourceResponder.update_fields/3","type":"function"},{"doc":"Defines a behavior for configuring the main teal application. It relies on (and uses):","ref":"ExTeal.Application.Configuration.html","title":"ExTeal.Application.Configuration","type":"behaviour"},{"doc":"Returns the name of the teal application that is used in the html titles of all pages.","ref":"ExTeal.Application.Configuration.html#c:application_name/0","title":"ExTeal.Application.Configuration.application_name/0","type":"callback"},{"doc":"Returns an array of dashboards","ref":"ExTeal.Application.Configuration.html#c:dashboards/0","title":"ExTeal.Application.Configuration.dashboards/0","type":"callback"},{"doc":"Returns the json configuration required for the vue app.","ref":"ExTeal.Application.Configuration.html#c:json_configuration/1","title":"ExTeal.Application.Configuration.json_configuration/1","type":"callback"},{"doc":"Returns the path to the logo that is used in the admin panel.","ref":"ExTeal.Application.Configuration.html#c:logo_image_path/0","title":"ExTeal.Application.Configuration.logo_image_path/0","type":"callback"},{"doc":"Define the order in which groups are shown in the sidebar. By default only the general 'Resources' group is used, but by overriding the nav_groups/1 function in the manifest, you can define the order of the groups.","ref":"ExTeal.Application.Configuration.html#c:nav_groups/1","title":"ExTeal.Application.Configuration.nav_groups/1","type":"callback"},{"doc":"","ref":"ExTeal.Application.Configuration.html#parse_json/1","title":"ExTeal.Application.Configuration.parse_json/1","type":"function"},{"doc":"Returns the base path that the teal app is located.","ref":"ExTeal.Application.Configuration.html#c:path/0","title":"ExTeal.Application.Configuration.path/0","type":"callback"},{"doc":"Functionality for fetching Vue Assets","ref":"ExTeal.Asset.html","title":"ExTeal.Asset","type":"module"},{"doc":"","ref":"ExTeal.Asset.html#all_assets/0","title":"ExTeal.Asset.all_assets/0","type":"function"},{"doc":"Struct used to represent a JS Script that is served by Teal and required by a plugin on the front end side.","ref":"ExTeal.Asset.Script.html","title":"ExTeal.Asset.Script","type":"module"},{"doc":"","ref":"ExTeal.Asset.Script.html#t:t/0","title":"ExTeal.Asset.Script.t/0","type":"type"},{"doc":"Generic Provider that allows anyone to interact with ExTeal.","ref":"ExTeal.Auth.GuestProvider.html","title":"ExTeal.Auth.GuestProvider","type":"module"},{"doc":"Callback implementation for ExTeal.AuthProvider.dropdown_content/1 .","ref":"ExTeal.Auth.GuestProvider.html#dropdown_content/1","title":"ExTeal.Auth.GuestProvider.dropdown_content/1","type":"function"},{"doc":"Interface for providing authorization and authentication to ExTeal.","ref":"ExTeal.AuthProvider.html","title":"ExTeal.AuthProvider","type":"behaviour"},{"doc":"Used to display the current user on the nav bar. Should return a user_payload map. If your User struct does not have a user image associated with it, consider using the gravatar api.","ref":"ExTeal.AuthProvider.html#c:current_user_for/1","title":"ExTeal.AuthProvider.current_user_for/1","type":"callback"},{"doc":"Used to build the content of the dropdown menu for a user. The content of the user dropdown is dynamic and can be overriden to provide additional links and html. The function should return a list of strings that will be used to build list elements.","ref":"ExTeal.AuthProvider.html#c:dropdown_content/1","title":"ExTeal.AuthProvider.dropdown_content/1","type":"callback"},{"doc":"Data to be displayed on the front end","ref":"ExTeal.AuthProvider.html#t:user_payload/0","title":"ExTeal.AuthProvider.user_payload/0","type":"type"},{"doc":"Represents a Card that can be displayed on a dashboard or resource","ref":"ExTeal.Card.html","title":"ExTeal.Card","type":"behaviour"},{"doc":"","ref":"ExTeal.Card.html#c:component/0","title":"ExTeal.Card.component/0","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:only_on_detail/1","title":"ExTeal.Card.only_on_detail/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:only_on_index/1","title":"ExTeal.Card.only_on_index/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#c:options/1","title":"ExTeal.Card.options/1","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#to_struct/2","title":"ExTeal.Card.to_struct/2","type":"function"},{"doc":"","ref":"ExTeal.Card.html#c:width/0","title":"ExTeal.Card.width/0","type":"callback"},{"doc":"","ref":"ExTeal.Card.html#t:t/0","title":"ExTeal.Card.t/0","type":"type"},{"doc":"Not the thing you get the mail, but a card that appears on the dashboard.","ref":"ExTeal.Cards.Greeting.html","title":"ExTeal.Cards.Greeting","type":"behaviour"},{"doc":"64px x 64px image url to display next to the greeting","ref":"ExTeal.Cards.Greeting.html#c:avatar_url/1","title":"ExTeal.Cards.Greeting.avatar_url/1","type":"callback"},{"doc":"Greeting for a user viewing the card. Defaults to 'Welcome back,'","ref":"ExTeal.Cards.Greeting.html#c:greeting/0","title":"ExTeal.Cards.Greeting.greeting/0","type":"callback"},{"doc":"Potentially HTML Rich text to display below the users title. Beware any unescaped / unsanitary HTML.","ref":"ExTeal.Cards.Greeting.html#c:helper_text/1","title":"ExTeal.Cards.Greeting.helper_text/1","type":"callback"},{"doc":"A list of links to display on a greeting card.","ref":"ExTeal.Cards.Greeting.html#c:links/1","title":"ExTeal.Cards.Greeting.links/1","type":"callback"},{"doc":"The name to greet the user by, use the conn to pull the currently authorized user.","ref":"ExTeal.Cards.Greeting.html#c:user_name/1","title":"ExTeal.Cards.Greeting.user_name/1","type":"callback"},{"doc":"The users title, useful in applications with RBAC or permissions","ref":"ExTeal.Cards.Greeting.html#c:user_title/1","title":"ExTeal.Cards.Greeting.user_title/1","type":"callback"},{"doc":"Each link should be a map with the following keys: label (required) the text to display on the link url (required) the url to link to button_classes (optional) a string of classes to apply to the link Buttons default to a btn btn-default btn-secondary class definition if an override is not provided","ref":"ExTeal.Cards.Greeting.html#t:link/0","title":"ExTeal.Cards.Greeting.link/0","type":"type"},{"doc":"Sometimes you need a summary table that doesn't easily fit into a single resource. Sometimes you need a collection of summary tables on a dashboard. This is where the ResourceIndex comes in. It's a way to show a resource index table on a dashboard.","ref":"ExTeal.Cards.ResourceIndex.html","title":"ExTeal.Cards.ResourceIndex","type":"behaviour"},{"doc":"The teal resource used for the table","ref":"ExTeal.Cards.ResourceIndex.html#c:resource/0","title":"ExTeal.Cards.ResourceIndex.resource/0","type":"callback"},{"doc":"Module used to represent a dashboard which contains a grid of metrics, this will one day be extendable to include plugin or custom cards in the future.","ref":"ExTeal.Dashboard.html","title":"ExTeal.Dashboard","type":"behaviour"},{"doc":"Return the modules that represent cards on the dashboard.","ref":"ExTeal.Dashboard.html#c:cards/1","title":"ExTeal.Dashboard.cards/1","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#cards_to_json/2","title":"ExTeal.Dashboard.cards_to_json/2","type":"function"},{"doc":"Show or Hide a dashboard based on the current connection. Defaults to true","ref":"ExTeal.Dashboard.html#c:display?/1","title":"ExTeal.Dashboard.display?/1","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#map_to_json/1","title":"ExTeal.Dashboard.map_to_json/1","type":"function"},{"doc":"","ref":"ExTeal.Dashboard.html#c:title/0","title":"ExTeal.Dashboard.title/0","type":"callback"},{"doc":"Unique URI that allows the dashboard to look up cards. Should be url safe.","ref":"ExTeal.Dashboard.html#c:uri/0","title":"ExTeal.Dashboard.uri/0","type":"callback"},{"doc":"","ref":"ExTeal.Dashboard.html#t:range/0","title":"ExTeal.Dashboard.range/0","type":"type"},{"doc":"Generates a panel that contains the fields for a single embed, defined by its field name","ref":"ExTeal.Embedded.html","title":"ExTeal.Embedded","type":"module"},{"doc":"","ref":"ExTeal.Embedded.html#new/3","title":"ExTeal.Embedded.new/3","type":"function"},{"doc":"The core struct that represents a field on a resource served by ExTeal.","ref":"ExTeal.Field.html","title":"ExTeal.Field","type":"behaviour"},{"doc":"","ref":"ExTeal.Field.html#c:apply_options_for/4","title":"ExTeal.Field.apply_options_for/4","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#c:default_sortable/0","title":"ExTeal.Field.default_sortable/0","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#field_name/2","title":"ExTeal.Field.field_name/2","type":"function"},{"doc":"Override the default filter for the field.","ref":"ExTeal.Field.html#filter_as/2","title":"ExTeal.Field.filter_as/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:filterable_as/0","title":"ExTeal.Field.filterable_as/0","type":"callback"},{"doc":"Use a getter function to display a computed field on the resource. The getter function is given a schema and expects a string result","ref":"ExTeal.Field.html#get/2","title":"ExTeal.Field.get/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#help_text/2","title":"ExTeal.Field.help_text/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:make/2","title":"ExTeal.Field.make/2","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#nested_value_for/2","title":"ExTeal.Field.nested_value_for/2","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:sanitize_as/0","title":"ExTeal.Field.sanitize_as/0","type":"callback"},{"doc":"","ref":"ExTeal.Field.html#struct_from_field/3","title":"ExTeal.Field.struct_from_field/3","type":"function"},{"doc":"Define the options for the select field. The function accepts a list of options that are either strings or maps with of value and label keys. If the list members are strings, the value will be used for both the value and label of the &lt;option&gt; element it represents. options are expected to be an enumerable which will be used to generate each respective option . The enumerable may have: keyword lists - each keyword list is expected to have the keys :key and :value . Additional keys such as :disabled may be given to customize the option two-item tuples - where the first element is an atom, string or integer to be used as the option label and the second element is an atom, string or integer to be used as the option value atom, string or integer - which will be used as both label and value for the generated select Optgroups If options is a map or keyword list where the firs element is a string, atom, or integer and the second element is a list or a map, it is assumed the key will be wrapped in an &lt;optgroup&gt; and teh value will be used to generate &lt;options&gt; nested under the group. This functionality is only handled in the UI for select fields, boolean groups will not respond. This functionality is equivalent to Phoenix.HTML.Form.select/3","ref":"ExTeal.Field.html#transform_options/1","title":"ExTeal.Field.transform_options/1","type":"function"},{"doc":"","ref":"ExTeal.Field.html#value_for/3","title":"ExTeal.Field.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Field.html#c:value_for/3","title":"ExTeal.Field.value_for/3","type":"callback"},{"doc":"Mark a field as virtual, which will update how teal queries the database for the field. This is relevant for fields that are based on schemaless queries in resources that represent complex queries in read-only situations. For example, if a resource has a records definition like: from ( p in &quot;posts&quot; , select : %{ user_id : p . user_id , count : count ( p . id ) } , group_by : p . user_id ) Sorting by that resource would fail without marking the Number.make(:count) field as virtual. Virtual fields allow Teal to sort by computed fields that are not backed by a direct database reference, assuming the field is named with Ecto.Query.API.selected_as/2 : from ( p in &quot;posts&quot; , select : %{ user_id : p . user_id , count : p . id |&gt; count ( ) |&gt; selected_as ( :count ) } , group_by : p . user_id ) A resource can then use Number.make(:count) |&gt; Field.virtual() to mark the field as virtual.","ref":"ExTeal.Field.html#virtual/1","title":"ExTeal.Field.virtual/1","type":"function"},{"doc":"","ref":"ExTeal.Field.html#t:t/0","title":"ExTeal.Field.t/0","type":"type"},{"doc":"Functionality for gathering and parsing filters for a resource index based on the fields present on the resource.","ref":"ExTeal.FieldFilter.html","title":"ExTeal.FieldFilter","type":"behaviour"},{"doc":"Default serialization of a field filter","ref":"ExTeal.FieldFilter.html#default_serialization/3","title":"ExTeal.FieldFilter.default_serialization/3","type":"function"},{"doc":"Build a field filter by extending the incoming query with the following arguments: The query being built (Ecto.Queryable from the Index module) The configuration of the field filter as a string keyed map: &quot;operator&quot; a string representing the operation selected by the user that is being performed &quot;operand&quot; a string or map representing the value to apply against the operand and query The field struct being queried The resource module for the resource being queried","ref":"ExTeal.FieldFilter.html#c:filter/4","title":"ExTeal.FieldFilter.filter/4","type":"callback"},{"doc":"Iterates over a resources fields, and serializes them into a response that can be used by the vue app to build some logic","ref":"ExTeal.FieldFilter.html#for_resource/2","title":"ExTeal.FieldFilter.for_resource/2","type":"function"},{"doc":"Type of filter component to use in the user interface.","ref":"ExTeal.FieldFilter.html#c:interface_type/0","title":"ExTeal.FieldFilter.interface_type/0","type":"callback"},{"doc":"Define the available operators for the filter and the behaviour of each. Each available operator is defined by a map with the following keys: op (required) the operator being defined no_operand (optional) set to true for an operator that does not require an operand. component (optional) override the default operand component, which defaults to a string field.","ref":"ExTeal.FieldFilter.html#c:operators/1","title":"ExTeal.FieldFilter.operators/1","type":"callback"},{"doc":"Iterate over the fields from an index query, build the related field filter and apply their queries.","ref":"ExTeal.FieldFilter.html#query/4","title":"ExTeal.FieldFilter.query/4","type":"function"},{"doc":"Builds the map that allows the user interface to represent the field filter and all of it's configuration. Can be configured for customization on a per filter basis.","ref":"ExTeal.FieldFilter.html#c:serialize/2","title":"ExTeal.FieldFilter.serialize/2","type":"callback"},{"doc":"","ref":"ExTeal.FieldFilter.html#t:serialized_filter/0","title":"ExTeal.FieldFilter.serialized_filter/0","type":"type"},{"doc":"","ref":"ExTeal.FieldFilter.html#t:valid_type/0","title":"ExTeal.FieldFilter.valid_type/0","type":"type"},{"doc":"Field Filter for belongs to fields","ref":"ExTeal.FieldFilter.BelongsTo.html","title":"ExTeal.FieldFilter.BelongsTo","type":"module"},{"doc":"Field Filter for boolean fields Available operators are: true false","ref":"ExTeal.FieldFilter.Boolean.html","title":"ExTeal.FieldFilter.Boolean","type":"module"},{"doc":"Field Filter for date fields Available operators are: = != &gt; &gt;= &lt; &lt;= is empty not empty","ref":"ExTeal.FieldFilter.Date.html","title":"ExTeal.FieldFilter.Date","type":"module"},{"doc":"Field Filter for date time fields Available operators are: = != &gt; &gt;= &lt; &lt;= is empty not empty","ref":"ExTeal.FieldFilter.DateTime.html","title":"ExTeal.FieldFilter.DateTime","type":"module"},{"doc":"","ref":"ExTeal.FieldFilter.DateTime.html#value_cast_to_field_type/3","title":"ExTeal.FieldFilter.DateTime.value_cast_to_field_type/3","type":"function"},{"doc":"Field Filter for number fields Available operators are: = != &gt; &gt;= &lt; &lt;= is empty not empty","ref":"ExTeal.FieldFilter.Number.html","title":"ExTeal.FieldFilter.Number","type":"module"},{"doc":"Simple Field Filter that builds operators from the options stored on the field","ref":"ExTeal.FieldFilter.Select.html","title":"ExTeal.FieldFilter.Select","type":"module"},{"doc":"Field Filter for text fields Available operators are: = != contains does not contain is empty not empty","ref":"ExTeal.FieldFilter.Text.html","title":"ExTeal.FieldFilter.Text","type":"module"},{"doc":"Functions that allow a resource to configure which fields can be displayed on which parts of the resource.","ref":"ExTeal.FieldVisibility.html","title":"ExTeal.FieldVisibility","type":"module"},{"doc":"Marks the field as safe to render as html","ref":"ExTeal.FieldVisibility.html#as_html/1","title":"ExTeal.FieldVisibility.as_html/1","type":"function"},{"doc":"Conditionally render a field on a resource as a whole based on the current request. Helpful for filtering out fields based on the current users permissions.","ref":"ExTeal.FieldVisibility.html#can_see?/2","title":"ExTeal.FieldVisibility.can_see?/2","type":"function"},{"doc":"Field is only visible on Details and Index","ref":"ExTeal.FieldVisibility.html#except_on_forms/1","title":"ExTeal.FieldVisibility.except_on_forms/1","type":"function"},{"doc":"Hide field is hidden on the detail","ref":"ExTeal.FieldVisibility.html#hide_from_detail/1","title":"ExTeal.FieldVisibility.hide_from_detail/1","type":"function"},{"doc":"Hide field is hidden on the index","ref":"ExTeal.FieldVisibility.html#hide_from_index/1","title":"ExTeal.FieldVisibility.hide_from_index/1","type":"function"},{"doc":"Hide field is hidden when creating a resource","ref":"ExTeal.FieldVisibility.html#hide_when_creating/1","title":"ExTeal.FieldVisibility.hide_when_creating/1","type":"function"},{"doc":"Hide field is hidden when updating a resource","ref":"ExTeal.FieldVisibility.html#hide_when_updating/1","title":"ExTeal.FieldVisibility.hide_when_updating/1","type":"function"},{"doc":"Field is only visible on Details","ref":"ExTeal.FieldVisibility.html#only_on_details/1","title":"ExTeal.FieldVisibility.only_on_details/1","type":"function"},{"doc":"Field is only visible on Create and New","ref":"ExTeal.FieldVisibility.html#only_on_forms/1","title":"ExTeal.FieldVisibility.only_on_forms/1","type":"function"},{"doc":"Field is only visible on Index","ref":"ExTeal.FieldVisibility.html#only_on_index/1","title":"ExTeal.FieldVisibility.only_on_index/1","type":"function"},{"doc":"Marks a relational field as searchable Only applies to many to many relationships","ref":"ExTeal.FieldVisibility.html#searchable/1","title":"ExTeal.FieldVisibility.searchable/1","type":"function"},{"doc":"Show field on the index","ref":"ExTeal.FieldVisibility.html#show_on_index/1","title":"ExTeal.FieldVisibility.show_on_index/1","type":"function"},{"doc":"The Array field may be used to represent an Ecto array .","ref":"ExTeal.Fields.Array.html","title":"ExTeal.Fields.Array","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.Array.html#apply_options_for/4","title":"ExTeal.Fields.Array.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#as_html/0","title":"ExTeal.Fields.Array.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#component/0","title":"ExTeal.Fields.Array.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.Array.html#default_sortable/0","title":"ExTeal.Fields.Array.default_sortable/0","type":"function"},{"doc":"Enable a draggable ui for the field, allowing a user to reorder the items in the array","ref":"ExTeal.Fields.Array.html#draggable/1","title":"ExTeal.Fields.Array.draggable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#field_name/2","title":"ExTeal.Fields.Array.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.Array.html#filterable_as/0","title":"ExTeal.Fields.Array.filterable_as/0","type":"function"},{"doc":"Hide the 'create button' in the user interface","ref":"ExTeal.Fields.Array.html#hide_create_button/1","title":"ExTeal.Fields.Array.hide_create_button/1","type":"function"},{"doc":"Put the 'add item' at the bottom of the list instead of the tops","ref":"ExTeal.Fields.Array.html#list_above/1","title":"ExTeal.Fields.Array.list_above/1","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.Array.html#make/2","title":"ExTeal.Fields.Array.make/2","type":"function"},{"doc":"Set a maximum height of the list in pixels","ref":"ExTeal.Fields.Array.html#max_height/2","title":"ExTeal.Fields.Array.max_height/2","type":"function"},{"doc":"Set a maximum number of items in the list","ref":"ExTeal.Fields.Array.html#max_items/2","title":"ExTeal.Fields.Array.max_items/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#options/0","title":"ExTeal.Fields.Array.options/0","type":"function"},{"doc":"Set the placeholder for the 'add item' inputs","ref":"ExTeal.Fields.Array.html#placeholder/2","title":"ExTeal.Fields.Array.placeholder/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#prefix_component/0","title":"ExTeal.Fields.Array.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.Array.html#sanitize_as/0","title":"ExTeal.Fields.Array.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_detail/0","title":"ExTeal.Fields.Array.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_edit/0","title":"ExTeal.Fields.Array.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_index/0","title":"ExTeal.Fields.Array.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Array.html#show_on_new/0","title":"ExTeal.Fields.Array.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.Array.html#value_for/3","title":"ExTeal.Fields.Array.value_for/3","type":"function"},{"doc":"The BelongsTo field corresponds to a belongs_to ecto relationship. For example, let's assume a Post schema belongs_to a User schema. We may add the relationship to our Post ExTeal resource like so: alias ExTeal.Fields.BelongsTo BelongsTo . make ( :user )","ref":"ExTeal.Fields.BelongsTo.html","title":"ExTeal.Fields.BelongsTo","type":"module"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#as_html/0","title":"ExTeal.Fields.BelongsTo.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#component/0","title":"ExTeal.Fields.BelongsTo.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.BelongsTo.html#default_sortable/0","title":"ExTeal.Fields.BelongsTo.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#field_name/2","title":"ExTeal.Fields.BelongsTo.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.BelongsTo.html#make/2","title":"ExTeal.Fields.BelongsTo.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#options/0","title":"ExTeal.Fields.BelongsTo.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#prefix_component/0","title":"ExTeal.Fields.BelongsTo.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.BelongsTo.html#sanitize_as/0","title":"ExTeal.Fields.BelongsTo.sanitize_as/0","type":"function"},{"doc":"Mark a Belongs To Field as searchable, allowing the UX to search the related resource for matches in the create and update forms","ref":"ExTeal.Fields.BelongsTo.html#searchable/1","title":"ExTeal.Fields.BelongsTo.searchable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_detail/0","title":"ExTeal.Fields.BelongsTo.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_edit/0","title":"ExTeal.Fields.BelongsTo.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_index/0","title":"ExTeal.Fields.BelongsTo.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BelongsTo.html#show_on_new/0","title":"ExTeal.Fields.BelongsTo.show_on_new/0","type":"function"},{"doc":"A group of boolean inputs that represent a map, or embedded schema where each value is a boolean. Useful for embedding features, permissions, or roles into a schema. If the field represents and embedded schema as an embeds_one , the field will set a default set of options based on the fields of the embedded schema. It assumes that every field in the embed is a boolean: defmodule Permissions do use Ecto.Schema embedded_schema do field :read , :boolean , default : false field :write , :boolean , default : false field :delete , :boolean , default : false end def changeset ( permissions , attrs ) do cast ( permission , attrs , [ :read , :write , :delete ] ) end end defmodule Post do use Ecto.Schema schema &quot;posts&quot; do field :title , :string embeds_one :permissions , Permissions end end def PostResource do use ExTeal.Resource def model , do : Post def fields , do : [ Text . make ( :title ) , BooleanGroup . make ( :permissions ) ] end You can also define a boolean group over a plain map type and manually define the options as a map of keys and labels: defmodule Post do use Ecto.Schema schema &quot;posts&quot; do field :title , :string field :permissions , :map end end def PostResource do use ExTeal.Resource def model , do : Post def fields , do : [ Text . make ( :title ) , BooleanGroup . make ( :permissions ) |&gt; BooleanGroup . options ( %{ &quot;read&quot; =&gt; &quot;Read&quot; , &quot;write&quot; =&gt; &quot;Write&quot; } ) ] end The options function can also be used to override the default options when used with an embedded schema if the options need to be translated into human readable values.","ref":"ExTeal.Fields.BooleanGroup.html","title":"ExTeal.Fields.BooleanGroup","type":"module"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#as_html/0","title":"ExTeal.Fields.BooleanGroup.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#component/0","title":"ExTeal.Fields.BooleanGroup.component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#field_name/2","title":"ExTeal.Fields.BooleanGroup.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.BooleanGroup.html#filterable_as/0","title":"ExTeal.Fields.BooleanGroup.filterable_as/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.BooleanGroup.html#make/2","title":"ExTeal.Fields.BooleanGroup.make/2","type":"function"},{"doc":"Customize the text displayed in the event that a field contains no values.","ref":"ExTeal.Fields.BooleanGroup.html#no_value_text/2","title":"ExTeal.Fields.BooleanGroup.no_value_text/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#options/0","title":"ExTeal.Fields.BooleanGroup.options/0","type":"function"},{"doc":"Add the available options to manage in the boolean group","ref":"ExTeal.Fields.BooleanGroup.html#options/2","title":"ExTeal.Fields.BooleanGroup.options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#prefix_component/0","title":"ExTeal.Fields.BooleanGroup.prefix_component/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_detail/0","title":"ExTeal.Fields.BooleanGroup.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_edit/0","title":"ExTeal.Fields.BooleanGroup.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_index/0","title":"ExTeal.Fields.BooleanGroup.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.BooleanGroup.html#show_on_new/0","title":"ExTeal.Fields.BooleanGroup.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.BooleanGroup.html#value_for/3","title":"ExTeal.Fields.BooleanGroup.value_for/3","type":"function"},{"doc":"The Date field may be used to generate a calendar date select. The date format for display on the index and detail views may be defined using the Select.with_options/2 function: Date . make ( :date ) |&gt; Date . with_options ( %{ &quot;format&quot; =&gt; &quot;YYYY/MM/DD&quot; } )","ref":"ExTeal.Fields.Date.html","title":"ExTeal.Fields.Date","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.Date.html#apply_options_for/4","title":"ExTeal.Fields.Date.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#as_html/0","title":"ExTeal.Fields.Date.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#component/0","title":"ExTeal.Fields.Date.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.Date.html#default_sortable/0","title":"ExTeal.Fields.Date.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#field_name/2","title":"ExTeal.Fields.Date.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.Date.html#filterable_as/0","title":"ExTeal.Fields.Date.filterable_as/0","type":"function"},{"doc":"Set the format that the date is rendered with on the detail and index components. Uses luxon's toLocaleString to display the date in a localized format: Examples: :short en_US -&gt; 10/14/1983 fr -&gt; 14/10/1983 :med en_US -&gt; Oct 14, 1983 fr -&gt; 14 oct. 1983 :full en_US -&gt; October 14, 1983 fr -&gt; 14 octobre 1983 :huge en_US -&gt; Tuesday, October 14, 1983 fr -&gt; vendredi 14 octobre 1983","ref":"ExTeal.Fields.Date.html#format/2","title":"ExTeal.Fields.Date.format/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.Date.html#make/2","title":"ExTeal.Fields.Date.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#options/0","title":"ExTeal.Fields.Date.options/0","type":"function"},{"doc":"Set the format that flatpickr will render the date in on forms. Format should be a string of flatpickr tokens","ref":"ExTeal.Fields.Date.html#picker_format/2","title":"ExTeal.Fields.Date.picker_format/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#prefix_component/0","title":"ExTeal.Fields.Date.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.Date.html#sanitize_as/0","title":"ExTeal.Fields.Date.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_detail/0","title":"ExTeal.Fields.Date.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_edit/0","title":"ExTeal.Fields.Date.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_index/0","title":"ExTeal.Fields.Date.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#show_on_new/0","title":"ExTeal.Fields.Date.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.Date.html#value_for/3","title":"ExTeal.Fields.Date.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#with_options/2","title":"ExTeal.Fields.Date.with_options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Date.html#t:valid_format/0","title":"ExTeal.Fields.Date.valid_format/0","type":"type"},{"doc":"The HasMany field corresponds to a has_many ecto relationship. For example, let's assume a User schema has many Post schema. We may add the relationship to our User ExTeal resource like so: alias ExTeal.Fields.HasMany HasMany . make ( :posts )","ref":"ExTeal.Fields.HasMany.html","title":"ExTeal.Fields.HasMany","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.HasMany.html#apply_options_for/4","title":"ExTeal.Fields.HasMany.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#as_html/0","title":"ExTeal.Fields.HasMany.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#component/0","title":"ExTeal.Fields.HasMany.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.HasMany.html#default_sortable/0","title":"ExTeal.Fields.HasMany.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#field_name/2","title":"ExTeal.Fields.HasMany.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.HasMany.html#filterable_as/0","title":"ExTeal.Fields.HasMany.filterable_as/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.HasMany.html#make/2","title":"ExTeal.Fields.HasMany.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#options/0","title":"ExTeal.Fields.HasMany.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#prefix_component/0","title":"ExTeal.Fields.HasMany.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.HasMany.html#sanitize_as/0","title":"ExTeal.Fields.HasMany.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_detail/0","title":"ExTeal.Fields.HasMany.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_edit/0","title":"ExTeal.Fields.HasMany.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_index/0","title":"ExTeal.Fields.HasMany.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasMany.html#show_on_new/0","title":"ExTeal.Fields.HasMany.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.HasMany.html#value_for/3","title":"ExTeal.Fields.HasMany.value_for/3","type":"function"},{"doc":"Define a list of custom index fields to use when displaying the has many relationship. HasMany . make ( :posts ) |&gt; HasMany . with_index_fields ( [ Text . make ( :title ) ] ) This list of fields will override the fields used when displaying, sorting, and filtering the related table.","ref":"ExTeal.Fields.HasMany.html#with_index_fields/2","title":"ExTeal.Fields.HasMany.with_index_fields/2","type":"function"},{"doc":"The HasOne field corresponds to a has_one ecto relationship. For example, let's assume a Post schema has_one PermaLink schema. We may add the relationship to our Post ExTeal resource like so: alias ExTeal.Fields.HasOne HasOne . make ( :permalink ) Title Attributes When a HasOne field is shown on an associated BelongsTo resources index/detail screen, the associated row will have a link to the HasOne and will display the &quot;title&quot; of the resource. For example, a permalink resource may display the address attribute as it's title. Then, when the resource is shown as an association on the belongs_to index or detail views, that attribute will be displayed, supported attributes are name , title , or address .","ref":"ExTeal.Fields.HasOne.html","title":"ExTeal.Fields.HasOne","type":"module"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#as_html/0","title":"ExTeal.Fields.HasOne.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#component/0","title":"ExTeal.Fields.HasOne.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.HasOne.html#default_sortable/0","title":"ExTeal.Fields.HasOne.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#field_name/2","title":"ExTeal.Fields.HasOne.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.HasOne.html#filterable_as/0","title":"ExTeal.Fields.HasOne.filterable_as/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.HasOne.html#make/2","title":"ExTeal.Fields.HasOne.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#options/0","title":"ExTeal.Fields.HasOne.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#prefix_component/0","title":"ExTeal.Fields.HasOne.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.HasOne.html#sanitize_as/0","title":"ExTeal.Fields.HasOne.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_detail/0","title":"ExTeal.Fields.HasOne.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_edit/0","title":"ExTeal.Fields.HasOne.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_index/0","title":"ExTeal.Fields.HasOne.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.HasOne.html#show_on_new/0","title":"ExTeal.Fields.HasOne.show_on_new/0","type":"function"},{"doc":"A hidden field is a field that is not shown on the index or detail pages, but is still rendered on forms for use with embedded fields that have ids.","ref":"ExTeal.Fields.Hidden.html","title":"ExTeal.Fields.Hidden","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.Hidden.html#apply_options_for/4","title":"ExTeal.Fields.Hidden.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#as_html/0","title":"ExTeal.Fields.Hidden.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#component/0","title":"ExTeal.Fields.Hidden.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.Hidden.html#default_sortable/0","title":"ExTeal.Fields.Hidden.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#field_name/2","title":"ExTeal.Fields.Hidden.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.Hidden.html#make/2","title":"ExTeal.Fields.Hidden.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#options/0","title":"ExTeal.Fields.Hidden.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#prefix_component/0","title":"ExTeal.Fields.Hidden.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.Hidden.html#sanitize_as/0","title":"ExTeal.Fields.Hidden.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_detail/0","title":"ExTeal.Fields.Hidden.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_edit/0","title":"ExTeal.Fields.Hidden.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_index/0","title":"ExTeal.Fields.Hidden.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Hidden.html#show_on_new/0","title":"ExTeal.Fields.Hidden.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.Hidden.html#value_for/3","title":"ExTeal.Fields.Hidden.value_for/3","type":"function"},{"doc":"The ManyToMany field corresponds to a many_to_many ecto relationship. For example, let's assume a User schema has a many_to_many relationship with a Role schema. We can add the relationship to our User resource like so: alias ExTeal.Fields.ManyToMany ManyToMany . make ( :roles ) Customizing Index Tables Let's assume we have a User schema with a many_to_many relationship with a Role schema. The pivot schema has a :primary boolean field. We want to display the Role 's name and the User 's email and the primary boolean field on the index table of 'Roles' for a 'User'. We can do this by defining: ManyToMany . make ( :roles , Role ) |&gt; ManyToMany . with_pivot_fields ( [ ExTeal.Fields.Boolean . make ( :primary ) ] ) The relationship table, attach and edit-attached interfaces now all a user to manage the 'primary' field which only exists on the pivot table. Customizing Index Tables By default, the ManyToMany field produces a ManyToManyBelongsTo field on the index table. This field appears as a BelongsTo field, providing the title for the linked resource and a link to the detail page of the linked asset, in the previous example 'Role'. There are times where you might need to customize the index table, overriding the ManyToManyBelongsTo and providing a unique list of fields to display. Enter with_index_fields/2 and with_index_query/2 . By default, Teal queries for both the related resource and the join to the current resource via some of the meta data associated with the underlying Ecto.Assoc struct. The results are then loaded in a custom resource lookup select query. When extending the default many-to-many functionality, the query must return a ExTeal.Resource.pivot_resource() type. Example Assume a User has many to many with Org through a Membership schema. Membership has a role field and we want to display some extra information in the Org many-to-many table for a user. We could define that as: ManyToMany . make ( :orgs , Org ) |&gt; ManyToMany . with_index_fields ( [ ExTeal.Fields.Text . make ( :name ) ExTeal.Fields.Boolean . make ( :active ) , ExTeal.Fields.Select . make ( :org_type ) , ExTeal.Fields.Number . make ( :member_count ) |&gt; ExTeal.Field . virtual ( ) ] ) |&gt; ManyToMany . with_index_query ( fn query , _assoc , _resource_id -&gt; query |&gt; Ecto.Query . join ( :left , [ o ] , m in assoc ( o , :memberships ) ) |&gt; Ecto.Query . select ( query , [ o , x , m ] , %{ _row : %{ name : o . name , active : o . active , org_type : o . org_type , member_count : selected_as ( count ( m . id ) , :member_count ) } , _pivot : x , pivot : true } ) |&gt; Ecto.Query . group_by ( [ o , x ] , [ o . id , x . org_id ] ) end ) |&gt; ManyToMany . with_pivot_fields ( [ ExTeal.Fields.Select . make ( :role ) ] ) What a query, what a pipe. There are some conditions here. This functionality is only available when a many_to_many assocation is defined with a join_through schema. If the many to many is joined only through the table name, you may be able to customize the index fields by defining a with_index_fields/2 and ignoring the with_index_query/2 function. If you need to customize the query, you can do so by simply returning a full schema and avoiding the ExTeal.Resource.pivot_resource() type.","ref":"ExTeal.Fields.ManyToMany.html","title":"ExTeal.Fields.ManyToMany","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.ManyToMany.html#apply_options_for/4","title":"ExTeal.Fields.ManyToMany.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#as_html/0","title":"ExTeal.Fields.ManyToMany.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#component/0","title":"ExTeal.Fields.ManyToMany.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.ManyToMany.html#default_sortable/0","title":"ExTeal.Fields.ManyToMany.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#field_name/2","title":"ExTeal.Fields.ManyToMany.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.ManyToMany.html#filterable_as/0","title":"ExTeal.Fields.ManyToMany.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#index_fields/3","title":"ExTeal.Fields.ManyToMany.index_fields/3","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.ManyToMany.html#make/2","title":"ExTeal.Fields.ManyToMany.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#make/3","title":"ExTeal.Fields.ManyToMany.make/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#options/0","title":"ExTeal.Fields.ManyToMany.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#prefix_component/0","title":"ExTeal.Fields.ManyToMany.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.ManyToMany.html#sanitize_as/0","title":"ExTeal.Fields.ManyToMany.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_detail/0","title":"ExTeal.Fields.ManyToMany.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_edit/0","title":"ExTeal.Fields.ManyToMany.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_index/0","title":"ExTeal.Fields.ManyToMany.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#show_on_new/0","title":"ExTeal.Fields.ManyToMany.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#sortable_by/2","title":"ExTeal.Fields.ManyToMany.sortable_by/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.ManyToMany.html#value_for/3","title":"ExTeal.Fields.ManyToMany.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_index_fields/2","title":"ExTeal.Fields.ManyToMany.with_index_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_index_query/2","title":"ExTeal.Fields.ManyToMany.with_index_query/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToMany.html#with_pivot_fields/2","title":"ExTeal.Fields.ManyToMany.with_pivot_fields/2","type":"function"},{"doc":"Internal Field that replicates a belongs to field for display during an index query of a many to many relationship.","ref":"ExTeal.Fields.ManyToManyBelongsTo.html","title":"ExTeal.Fields.ManyToManyBelongsTo","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#apply_options_for/4","title":"ExTeal.Fields.ManyToManyBelongsTo.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#as_html/0","title":"ExTeal.Fields.ManyToManyBelongsTo.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#component/0","title":"ExTeal.Fields.ManyToManyBelongsTo.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#default_sortable/0","title":"ExTeal.Fields.ManyToManyBelongsTo.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#field_name/2","title":"ExTeal.Fields.ManyToManyBelongsTo.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#filterable_as/0","title":"ExTeal.Fields.ManyToManyBelongsTo.filterable_as/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#make/2","title":"ExTeal.Fields.ManyToManyBelongsTo.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#make/3","title":"ExTeal.Fields.ManyToManyBelongsTo.make/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#options/0","title":"ExTeal.Fields.ManyToManyBelongsTo.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#prefix_component/0","title":"ExTeal.Fields.ManyToManyBelongsTo.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#sanitize_as/0","title":"ExTeal.Fields.ManyToManyBelongsTo.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_detail/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_edit/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_index/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#show_on_new/0","title":"ExTeal.Fields.ManyToManyBelongsTo.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.ManyToManyBelongsTo.html#value_for/3","title":"ExTeal.Fields.ManyToManyBelongsTo.value_for/3","type":"function"},{"doc":"The MultiSelect field may be used to generate a drop-down menu with multiple fields. The select menu's options may be defined using the MultiSelect/with_options/2 function: MultiSelect . make ( :regions ) |&gt; MultiSelect . with_options ( [ %{ value : 1 , label : &quot;USA&quot; } , %{ value : 2 , label : &quot;EU&quot; } ] ) You can also return a list of maps with value , title , subtitle and thumbnail keys to use 'card' style taggables, useful when the multiselect represents a relationship.","ref":"ExTeal.Fields.MultiSelect.html","title":"ExTeal.Fields.MultiSelect","type":"module"},{"doc":"Callback implementation for ExTeal.Field.apply_options_for/4 .","ref":"ExTeal.Fields.MultiSelect.html#apply_options_for/4","title":"ExTeal.Fields.MultiSelect.apply_options_for/4","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#as_html/0","title":"ExTeal.Fields.MultiSelect.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#component/0","title":"ExTeal.Fields.MultiSelect.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.MultiSelect.html#default_sortable/0","title":"ExTeal.Fields.MultiSelect.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#field_name/2","title":"ExTeal.Fields.MultiSelect.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.filterable_as/0 .","ref":"ExTeal.Fields.MultiSelect.html#filterable_as/0","title":"ExTeal.Fields.MultiSelect.filterable_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#get/2","title":"ExTeal.Fields.MultiSelect.get/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.MultiSelect.html#make/2","title":"ExTeal.Fields.MultiSelect.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#options/0","title":"ExTeal.Fields.MultiSelect.options/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#prefix_component/0","title":"ExTeal.Fields.MultiSelect.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.MultiSelect.html#sanitize_as/0","title":"ExTeal.Fields.MultiSelect.sanitize_as/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_detail/0","title":"ExTeal.Fields.MultiSelect.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_edit/0","title":"ExTeal.Fields.MultiSelect.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_index/0","title":"ExTeal.Fields.MultiSelect.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#show_on_new/0","title":"ExTeal.Fields.MultiSelect.show_on_new/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.value_for/3 .","ref":"ExTeal.Fields.MultiSelect.html#value_for/3","title":"ExTeal.Fields.MultiSelect.value_for/3","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#with_options/2","title":"ExTeal.Fields.MultiSelect.with_options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:card_option/0","title":"ExTeal.Fields.MultiSelect.card_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:simple_option/0","title":"ExTeal.Fields.MultiSelect.simple_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:valid_option/0","title":"ExTeal.Fields.MultiSelect.valid_option/0","type":"type"},{"doc":"","ref":"ExTeal.Fields.MultiSelect.html#t:valid_options/0","title":"ExTeal.Fields.MultiSelect.valid_options/0","type":"type"},{"doc":"The Select field may be used to generate a drop-down select menu. The select menu's options may be defined using the Select.options/2 function: Select . make ( :size ) |&gt; Select . options ( [ &quot;Small&quot; , &quot;Medium&quot; ] )","ref":"ExTeal.Fields.Select.html","title":"ExTeal.Fields.Select","type":"module"},{"doc":"","ref":"ExTeal.Fields.Select.html#all_options_for/1","title":"ExTeal.Fields.Select.all_options_for/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#as_html/0","title":"ExTeal.Fields.Select.as_html/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#component/0","title":"ExTeal.Fields.Select.component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.default_sortable/0 .","ref":"ExTeal.Fields.Select.html#default_sortable/0","title":"ExTeal.Fields.Select.default_sortable/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#display_using_labels/1","title":"ExTeal.Fields.Select.display_using_labels/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#field_name/2","title":"ExTeal.Fields.Select.field_name/2","type":"function"},{"doc":"Callback implementation for ExTeal.Field.make/2 .","ref":"ExTeal.Fields.Select.html#make/2","title":"ExTeal.Fields.Select.make/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#options/0","title":"ExTeal.Fields.Select.options/0","type":"function"},{"doc":"Define the options for the select field. The function accepts a list of options that are either strings or maps with of value and label keys. If the list members are strings, the value will be used for both the value and label of the &lt;option&gt; element it represents. options are expected to be an enumerable which will be used to generate each respective option . The enumerable may have: keyword lists - each keyword list is expected to have the keys :key and :value . Additional keys such as :disabled may be given to customize the option two-item tuples - where the first element is an atom, string or integer to be used as the option label and the second element is an atom, string or integer to be used as the option value atom, string or integer - which will be used as both label and value for the generated select Optgroups If options is a map or keyword list where the firs element is a string, atom, or integer and the second element is a list or a map, it is assumed the key will be wrapped in an &lt;optgroup&gt; and teh value will be used to generate &lt;options&gt; nested under the group. This functionality is equivalent to Phoenix.HTML.Form.select/3","ref":"ExTeal.Fields.Select.html#options/2","title":"ExTeal.Fields.Select.options/2","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#prefix_component/0","title":"ExTeal.Fields.Select.prefix_component/0","type":"function"},{"doc":"Callback implementation for ExTeal.Field.sanitize_as/0 .","ref":"ExTeal.Fields.Select.html#sanitize_as/0","title":"ExTeal.Fields.Select.sanitize_as/0","type":"function"},{"doc":"At times it's convenient to be able to search or filter the list of options in a select field. You can enable this by calling Select.searchable on the field: Select . make ( :type ) |&gt; Select . options ( ~w(foo bar) ) |&gt; Select . searchable ( ) When using this field, Teal will display an input field which allows you to filter the list based on it's key.","ref":"ExTeal.Fields.Select.html#searchable/1","title":"ExTeal.Fields.Select.searchable/1","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_detail/0","title":"ExTeal.Fields.Select.show_on_detail/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_edit/0","title":"ExTeal.Fields.Select.show_on_edit/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_index/0","title":"ExTeal.Fields.Select.show_on_index/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#show_on_new/0","title":"ExTeal.Fields.Select.show_on_new/0","type":"function"},{"doc":"","ref":"ExTeal.Fields.Select.html#with_options/2","title":"ExTeal.Fields.Select.with_options/2","type":"function"},{"doc":"Functionality for searching across a collection of resources using a single search term.","ref":"ExTeal.GlobalSearch.html","title":"ExTeal.GlobalSearch","type":"module"},{"doc":"","ref":"ExTeal.GlobalSearch.html#new/2","title":"ExTeal.GlobalSearch.new/2","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#render/1","title":"ExTeal.GlobalSearch.render/1","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#run/1","title":"ExTeal.GlobalSearch.run/1","type":"function"},{"doc":"","ref":"ExTeal.GlobalSearch.html#t:t/0","title":"ExTeal.GlobalSearch.t/0","type":"type"},{"doc":"The default auth provider that allows all access to ExTeal. Should not be used in production!","ref":"ExTeal.GuestAuthProvider.html","title":"ExTeal.GuestAuthProvider","type":"module"},{"doc":"Callback implementation for ExTeal.AuthProvider.current_user_for/1 .","ref":"ExTeal.GuestAuthProvider.html#current_user_for/1","title":"ExTeal.GuestAuthProvider.current_user_for/1","type":"function"},{"doc":"Callback implementation for ExTeal.AuthProvider.dropdown_content/1 .","ref":"ExTeal.GuestAuthProvider.html#dropdown_content/1","title":"ExTeal.GuestAuthProvider.dropdown_content/1","type":"function"},{"doc":"Card that sits on the main, default dashboard","ref":"ExTeal.HelpCard.html","title":"ExTeal.HelpCard","type":"module"},{"doc":"Callback implementation for ExTeal.Card.only_on_detail/1 .","ref":"ExTeal.HelpCard.html#only_on_detail/1","title":"ExTeal.HelpCard.only_on_detail/1","type":"function"},{"doc":"Callback implementation for ExTeal.Card.only_on_index/1 .","ref":"ExTeal.HelpCard.html#only_on_index/1","title":"ExTeal.HelpCard.only_on_index/1","type":"function"},{"doc":"Callback implementation for ExTeal.Card.options/1 .","ref":"ExTeal.HelpCard.html#options/1","title":"ExTeal.HelpCard.options/1","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#title/0","title":"ExTeal.HelpCard.title/0","type":"function"},{"doc":"","ref":"ExTeal.HelpCard.html#uri/0","title":"ExTeal.HelpCard.uri/0","type":"function"},{"doc":"Behavior for configuring and defining ExTeal","ref":"ExTeal.Manifest.html","title":"ExTeal.Manifest","type":"module"},{"doc":"Describes the behaviour of a metric with specific callbacks for building a base result, calculating the values, applying then and returning the result","ref":"ExTeal.Metric.html","title":"ExTeal.Metric","type":"behaviour"},{"doc":"Define the options that are passed as a metrics options map as it's returned as part of a metric result.","ref":"ExTeal.Metric.html#c:chart_options/0","title":"ExTeal.Metric.chart_options/0","type":"callback"},{"doc":"The name of the component to mount in the ux responsible for rendering the content","ref":"ExTeal.Metric.html#c:component/0","title":"ExTeal.Metric.component/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:date_field/0","title":"ExTeal.Metric.date_field/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:date_field_type/0","title":"ExTeal.Metric.date_field_type/0","type":"callback"},{"doc":"Define the range to render by default for a metric.","ref":"ExTeal.Metric.html#c:default_range/0","title":"ExTeal.Metric.default_range/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#default_ranges/0","title":"ExTeal.Metric.default_ranges/0","type":"function"},{"doc":"A string representing how a value is formatted before being displayed by the numbro library. Defaults to 0,0","ref":"ExTeal.Metric.html#c:format/0","title":"ExTeal.Metric.format/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#c:multiple_results/0","title":"ExTeal.Metric.multiple_results/0","type":"callback"},{"doc":"Only display the metric on the detail page of a specific resource.","ref":"ExTeal.Metric.html#c:only_on_detail/1","title":"ExTeal.Metric.only_on_detail/1","type":"callback"},{"doc":"Only display the metric on the index page of a specific resource.","ref":"ExTeal.Metric.html#c:only_on_index/1","title":"ExTeal.Metric.only_on_index/1","type":"callback"},{"doc":"Options that are serialized into the configuration of a metric card. Used as part of a dashboard or card list on a resource index or detail page.","ref":"ExTeal.Metric.html#c:options/1","title":"ExTeal.Metric.options/1","type":"callback"},{"doc":"A string to prepend to any displayed value on the metric card. For example: $","ref":"ExTeal.Metric.html#c:prefix/0","title":"ExTeal.Metric.prefix/0","type":"callback"},{"doc":"Define which ranges are available for a metric. Defaults to Metric.default_ranges/0 but can be overriden per metric.","ref":"ExTeal.Metric.html#c:ranges/0","title":"ExTeal.Metric.ranges/0","type":"callback"},{"doc":"A string to appended to any displayed value on the metric card. For example: °","ref":"ExTeal.Metric.html#c:suffix/0","title":"ExTeal.Metric.suffix/0","type":"callback"},{"doc":"Set the title displayed at the top of the card, defaults to a humanized title of the module","ref":"ExTeal.Metric.html#c:title/0","title":"ExTeal.Metric.title/0","type":"callback"},{"doc":"Explicitly set the uri used to fetch the details of a card.","ref":"ExTeal.Metric.html#c:uri/0","title":"ExTeal.Metric.uri/0","type":"callback"},{"doc":"Set the width of card that displays the metric. Defaults to 1/3. 1/3 and full are the only allowed values","ref":"ExTeal.Metric.html#c:width/0","title":"ExTeal.Metric.width/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.html#t:range/0","title":"ExTeal.Metric.range/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.html#t:unit/0","title":"ExTeal.Metric.unit/0","type":"type"},{"doc":"Partition metrics displays a pie chart of values.","ref":"ExTeal.Metric.Partition.html","title":"ExTeal.Metric.Partition","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Partition.html#aggregate/5","title":"ExTeal.Metric.Partition.aggregate/5","type":"function"},{"doc":"","ref":"ExTeal.Metric.Partition.html#c:calculate/1","title":"ExTeal.Metric.Partition.calculate/1","type":"callback"},{"doc":"By default sort the partition results by the group field","ref":"ExTeal.Metric.Partition.html#default_order_by/2","title":"ExTeal.Metric.Partition.default_order_by/2","type":"function"},{"doc":"Often, the column values that divide your partition metrics into groups will be simple keys, and not something that is human readable. Or, if you are displaying a partition metric grouped by a column that is a boolean, Teal will display labels as &quot;false&quot; and &quot;true&quot;. For this reason, Teal provides the label_for/1 callback that can be overriden on a partition metric to provide a custom label for each value. @impl true def label_for ( false ) , do : &quot;User&quot; def label_for ( true ) , do : &quot;Admin&quot; It's also useful for handling null values: @impl true def label_for ( null ) , do : &quot;None&quot; def label_for ( key ) , do : String . capitalize ( key )","ref":"ExTeal.Metric.Partition.html#c:label_for/1","title":"ExTeal.Metric.Partition.label_for/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Partition.html#t:result/0","title":"ExTeal.Metric.Partition.result/0","type":"type"},{"doc":"Trend Expressions for Postgresql databases","ref":"ExTeal.Metric.PostgresTrendExpression.html","title":"ExTeal.Metric.PostgresTrendExpression","type":"module"},{"doc":"Composeable Queries Helpers for Building Metrics","ref":"ExTeal.Metric.QueryHelpers.html","title":"ExTeal.Metric.QueryHelpers","type":"module"},{"doc":"","ref":"ExTeal.Metric.QueryHelpers.html#parse/1","title":"ExTeal.Metric.QueryHelpers.parse/1","type":"function"},{"doc":"Helper functions for building time intervals and queries based on the params of a request.","ref":"ExTeal.Metric.Ranges.html","title":"ExTeal.Metric.Ranges","type":"module"},{"doc":"Set the boundaries of an aggregate queries","ref":"ExTeal.Metric.Ranges.html#between/2","title":"ExTeal.Metric.Ranges.between/2","type":"function"},{"doc":"Parse the start and end params","ref":"ExTeal.Metric.Ranges.html#get_aggregate_datetimes/1","title":"ExTeal.Metric.Ranges.get_aggregate_datetimes/1","type":"function"},{"doc":"","ref":"ExTeal.Metric.Ranges.html#parse_dt/3","title":"ExTeal.Metric.Ranges.parse_dt/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Ranges.html#t:between_options/0","title":"ExTeal.Metric.Ranges.between_options/0","type":"type"},{"doc":"Data Structure for building a Query for a Metric Used by the Metric modules to build a data result that is turned into a Metric Result","ref":"ExTeal.Metric.Request.html","title":"ExTeal.Metric.Request","type":"module"},{"doc":"","ref":"ExTeal.Metric.Request.html#from_conn/2","title":"ExTeal.Metric.Request.from_conn/2","type":"function"},{"doc":"","ref":"ExTeal.Metric.Request.html#t:t/0","title":"ExTeal.Metric.Request.t/0","type":"type"},{"doc":"A Data Structure returned and serialized by a successful Value Metric Query","ref":"ExTeal.Metric.Result.html","title":"ExTeal.Metric.Result","type":"module"},{"doc":"","ref":"ExTeal.Metric.Result.html#build/2","title":"ExTeal.Metric.Result.build/2","type":"function"},{"doc":"","ref":"ExTeal.Metric.Result.html#t:t/0","title":"ExTeal.Metric.Result.t/0","type":"type"},{"doc":"Trend metrics display the trend of a computed aggregate over a range of time. For example, a trend metric might display the count of new users created every day for the last thirty days. A Trend metric offers the ability to chose both the range of time that is being displayed and the granularity of results. The granularity is stored as as the unit singluar while the ranges includes all available units. The available units are: year month week day hour minute Some of these data sets will be rather large, so we should provide some safe defaults for the maximum number of results returned.","ref":"ExTeal.Metric.Trend.html","title":"ExTeal.Metric.Trend","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Trend.html#aggregate/6","title":"ExTeal.Metric.Trend.aggregate/6","type":"function"},{"doc":"Build a select for the field and aggregate type","ref":"ExTeal.Metric.Trend.html#aggregate_as/3","title":"ExTeal.Metric.Trend.aggregate_as/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:calculate/1","title":"ExTeal.Metric.Trend.calculate/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:cast/1","title":"ExTeal.Metric.Trend.cast/1","type":"callback"},{"doc":"Takes a database record transforms it into a two-tuple of the date_result parsed into an appropriate format","ref":"ExTeal.Metric.Trend.html#format_result_data/3","title":"ExTeal.Metric.Trend.format_result_data/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#get_possible_results/4","title":"ExTeal.Metric.Trend.get_possible_results/4","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:precision/0","title":"ExTeal.Metric.Trend.precision/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#to_local_dt/3","title":"ExTeal.Metric.Trend.to_local_dt/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#to_result_date/1","title":"ExTeal.Metric.Trend.to_result_date/1","type":"function"},{"doc":"","ref":"ExTeal.Metric.Trend.html#c:twelve_hour_time/0","title":"ExTeal.Metric.Trend.twelve_hour_time/0","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:multi_result/0","title":"ExTeal.Metric.Trend.multi_result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:result/0","title":"ExTeal.Metric.Trend.result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Trend.html#t:valid_result/0","title":"ExTeal.Metric.Trend.valid_result/0","type":"type"},{"doc":"Behaviour for trend expression builders","ref":"ExTeal.Metric.TrendExpression.html","title":"ExTeal.Metric.TrendExpression","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.TrendExpression.html#fetch_offset/2","title":"ExTeal.Metric.TrendExpression.fetch_offset/2","type":"function"},{"doc":"Use database specifc syntax to build an expression for both selecting and grouping by a given unit of time. The function uses select_merge to build a date_result value assuming that a previous select has been used to generate a query for the aggregate.","ref":"ExTeal.Metric.TrendExpression.html#c:generate/5","title":"ExTeal.Metric.TrendExpression.generate/5","type":"callback"},{"doc":"","ref":"ExTeal.Metric.TrendExpression.html#t:valid_timezone/0","title":"ExTeal.Metric.TrendExpression.valid_timezone/0","type":"type"},{"doc":"Factory for selecting the implementation to generate a date factory based on the specific database adapter (and database).","ref":"ExTeal.Metric.TrendExpressionFactory.html","title":"ExTeal.Metric.TrendExpressionFactory","type":"module"},{"doc":"Based on the adapter, select a trend factory and build a date expression to be used in a Ecto Query fragment for the query","ref":"ExTeal.Metric.TrendExpressionFactory.html#make/5","title":"ExTeal.Metric.TrendExpressionFactory.make/5","type":"function"},{"doc":"Value Metrics display a single value and it's change compared to a previous interval of time. For example, a value metric might display the total number of blog posts created in the last thirty days, versus the previous thirty days. Once generated, a value metric module has two functions that can be customized, a calculate/1 and a ranges/0 function. Additionally there are modifier functions that change the behavior and display of the metric.","ref":"ExTeal.Metric.Value.html","title":"ExTeal.Metric.Value","type":"behaviour"},{"doc":"","ref":"ExTeal.Metric.Value.html#aggregate/5","title":"ExTeal.Metric.Value.aggregate/5","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#between_current/3","title":"ExTeal.Metric.Value.between_current/3","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#c:calculate/1","title":"ExTeal.Metric.Value.calculate/1","type":"callback"},{"doc":"","ref":"ExTeal.Metric.Value.html#query_for/6","title":"ExTeal.Metric.Value.query_for/6","type":"function"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:multi_result/0","title":"ExTeal.Metric.Value.multi_result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:result/0","title":"ExTeal.Metric.Value.result/0","type":"type"},{"doc":"","ref":"ExTeal.Metric.Value.html#t:valid_result/0","title":"ExTeal.Metric.Value.valid_result/0","type":"type"},{"doc":"Conveniences for inflecting and working with names in ExTeal.","ref":"ExTeal.Naming.html","title":"ExTeal.Naming","type":"module"},{"doc":"Converts String to camel case. Takes an optional :lower option to return lowerCamelCase. Examples iex&gt; ExTeal.Naming . camelize ( &quot;my_app&quot; ) &quot;MyApp&quot; iex&gt; ExTeal.Naming . camelize ( &quot;my_app&quot; , :lower ) &quot;myApp&quot; In general, camelize can be thought of as the reverse of underscore , however, in some cases formatting may be lost: ExTeal.Naming . underscore &quot;SAPExample&quot; #=&gt; &quot;sap_example&quot; ExTeal.Naming . camelize &quot;sap_example&quot; #=&gt; &quot;SapExample&quot;","ref":"ExTeal.Naming.html#camelize/1","title":"ExTeal.Naming.camelize/1","type":"function"},{"doc":"","ref":"ExTeal.Naming.html#camelize/2","title":"ExTeal.Naming.camelize/2","type":"function"},{"doc":"Converts an attribute/form field into its humanize version. iex&gt; ExTeal.Naming . humanize ( :username ) &quot;Username&quot; iex&gt; ExTeal.Naming . humanize ( :created_at ) &quot;Created at&quot; iex&gt; ExTeal.Naming . humanize ( &quot;user_id&quot; ) &quot;User&quot;","ref":"ExTeal.Naming.html#humanize/1","title":"ExTeal.Naming.humanize/1","type":"function"},{"doc":"Extracts the resource name from an alias. Examples iex&gt; ExTeal.Naming . resource_name ( MyApp.User ) &quot;user&quot; iex&gt; ExTeal.Naming . resource_name ( MyApp.UserView , &quot;View&quot; ) &quot;user&quot;","ref":"ExTeal.Naming.html#resource_name/2","title":"ExTeal.Naming.resource_name/2","type":"function"},{"doc":"Converts String to underscore case. Examples iex&gt; ExTeal.Naming . underscore ( &quot;MyApp&quot; ) &quot;my_app&quot; In general, underscore can be thought of as the reverse of camelize , however, in some cases formatting may be lost: ExTeal.Naming . underscore &quot;SAPExample&quot; #=&gt; &quot;sap_example&quot; ExTeal.Naming . camelize &quot;sap_example&quot; #=&gt; &quot;SapExample&quot;","ref":"ExTeal.Naming.html#underscore/1","title":"ExTeal.Naming.underscore/1","type":"function"},{"doc":"Removes the given suffix from the name if it exists. Examples iex&gt; ExTeal.Naming . unsuffix ( &quot;MyApp.User&quot; , &quot;View&quot; ) &quot;MyApp.User&quot; iex&gt; ExTeal.Naming . unsuffix ( &quot;MyApp.UserView&quot; , &quot;View&quot; ) &quot;MyApp.User&quot;","ref":"ExTeal.Naming.html#unsuffix/2","title":"ExTeal.Naming.unsuffix/2","type":"function"},{"doc":"The default policy that allows authenticated users access to CRUD. All callbacks default to always being true. Should not be used in production!","ref":"ExTeal.OpenEverywherePolicy.html","title":"ExTeal.OpenEverywherePolicy","type":"module"},{"doc":"Callback implementation for ExTeal.Policy.create_any?/1 .","ref":"ExTeal.OpenEverywherePolicy.html#create_any?/1","title":"ExTeal.OpenEverywherePolicy.create_any?/1","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.delete?/2 .","ref":"ExTeal.OpenEverywherePolicy.html#delete?/2","title":"ExTeal.OpenEverywherePolicy.delete?/2","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.delete_any?/1 .","ref":"ExTeal.OpenEverywherePolicy.html#delete_any?/1","title":"ExTeal.OpenEverywherePolicy.delete_any?/1","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.update?/2 .","ref":"ExTeal.OpenEverywherePolicy.html#update?/2","title":"ExTeal.OpenEverywherePolicy.update?/2","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.update_any?/1 .","ref":"ExTeal.OpenEverywherePolicy.html#update_any?/1","title":"ExTeal.OpenEverywherePolicy.update_any?/1","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.view?/2 .","ref":"ExTeal.OpenEverywherePolicy.html#view?/2","title":"ExTeal.OpenEverywherePolicy.view?/2","type":"function"},{"doc":"Callback implementation for ExTeal.Policy.view_any?/1 .","ref":"ExTeal.OpenEverywherePolicy.html#view_any?/1","title":"ExTeal.OpenEverywherePolicy.view_any?/1","type":"function"},{"doc":"Separates fields on the detail page into panels","ref":"ExTeal.Panel.html","title":"ExTeal.Panel","type":"module"},{"doc":"","ref":"ExTeal.Panel.html#default_panel_name/1","title":"ExTeal.Panel.default_panel_name/1","type":"function"},{"doc":"Given a resource, uses the fields definition to find the panels","ref":"ExTeal.Panel.html#gather_panels/1","title":"ExTeal.Panel.gather_panels/1","type":"function"},{"doc":"Given a list of fields and a list of panels, assigns the panel to each field","ref":"ExTeal.Panel.html#give_panel_to_fields/2","title":"ExTeal.Panel.give_panel_to_fields/2","type":"function"},{"doc":"Add helper text for the panel","ref":"ExTeal.Panel.html#helper_text/2","title":"ExTeal.Panel.helper_text/2","type":"function"},{"doc":"Limit the amount of fields that show by default on the detail page Other fields are hidden behind a &quot;Show more&quot; button","ref":"ExTeal.Panel.html#limit/2","title":"ExTeal.Panel.limit/2","type":"function"},{"doc":"Creates a new panel","ref":"ExTeal.Panel.html#new/3","title":"ExTeal.Panel.new/3","type":"function"},{"doc":"","ref":"ExTeal.Panel.html#t:options/0","title":"ExTeal.Panel.options/0","type":"type"},{"doc":"","ref":"ExTeal.Panel.html#t:t/0","title":"ExTeal.Panel.t/0","type":"type"},{"doc":"The core struct that represents and validates an address","ref":"ExTeal.Place.html","title":"ExTeal.Place","type":"module"},{"doc":"","ref":"ExTeal.Place.html#changeset/2","title":"ExTeal.Place.changeset/2","type":"function"},{"doc":"","ref":"ExTeal.Place.html#t:t/0","title":"ExTeal.Place.t/0","type":"type"},{"doc":"The base module that describes the functionality of a plugin","ref":"ExTeal.Plugin.html","title":"ExTeal.Plugin","type":"module"},{"doc":"","ref":"ExTeal.Plugin.html#available_scripts/1","title":"ExTeal.Plugin.available_scripts/1","type":"function"},{"doc":"","ref":"ExTeal.Plugin.html#t:t/0","title":"ExTeal.Plugin.t/0","type":"type"},{"doc":"A Policy authorizes CRUD use of a resource based on the Plug.Conn","ref":"ExTeal.Policy.html","title":"ExTeal.Policy","type":"behaviour"},{"doc":"Can a user create a resource? Returning false will disable the '+' button on a resource and return a 403 on api requests","ref":"ExTeal.Policy.html#c:create_any?/1","title":"ExTeal.Policy.create_any?/1","type":"callback"},{"doc":"Can a user delete any resource? Returning false will disable the 'delete' buttons on all resource records and return a 403 on api requests","ref":"ExTeal.Policy.html#c:delete?/2","title":"ExTeal.Policy.delete?/2","type":"callback"},{"doc":"Can a user delete any resource? Returning false will disable the 'delete' buttons on all resource records and return a 403 on api requests","ref":"ExTeal.Policy.html#c:delete_any?/1","title":"ExTeal.Policy.delete_any?/1","type":"callback"},{"doc":"Can a user update any records? Returning false will disable the 'edit' button on a record and return a 403 on api requests","ref":"ExTeal.Policy.html#c:update?/2","title":"ExTeal.Policy.update?/2","type":"callback"},{"doc":"Can a user update any records? Returning false will disable the 'edit' button on a record and return a 403 on api requests","ref":"ExTeal.Policy.html#c:update_any?/1","title":"ExTeal.Policy.update_any?/1","type":"callback"},{"doc":"Can the resource be viewed at all? Returning false will hide the resource in the sidebar and in relationships and return a 403 on api requests","ref":"ExTeal.Policy.html#c:view?/2","title":"ExTeal.Policy.view?/2","type":"callback"},{"doc":"Can the resource be viewed at all? Returning false will hide the resource in the sidebar and in relationships and return a 403 on api requests","ref":"ExTeal.Policy.html#c:view_any?/1","title":"ExTeal.Policy.view_any?/1","type":"callback"},{"doc":"When used, includes all aspects of the functionality required to manage the resource. Example usage in a ExTeal Resource: defmodule ExampleWeb.ExTeal.BlogResource do use ExTeal.Resource alias Example.Content.Blog def resource , do : Blog def title , do : &quot;blog&quot; end","ref":"ExTeal.Resource.html","title":"ExTeal.Resource","type":"behaviour"},{"doc":"Provide a list of action cards to render them above the resource index","ref":"ExTeal.Resource.html#c:cards/1","title":"ExTeal.Resource.cards/1","type":"callback"},{"doc":"Override the default ordering of the index.","ref":"ExTeal.Resource.html#c:default_order/0","title":"ExTeal.Resource.default_order/0","type":"callback"},{"doc":"Hide the Resource from the sidenav in the user interface, defaults to false.","ref":"ExTeal.Resource.html#c:hide_from_nav/0","title":"ExTeal.Resource.hide_from_nav/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.html#map_to_json/2","title":"ExTeal.Resource.map_to_json/2","type":"function"},{"doc":"If you would like to separate resources into different sidebar groups, you can override the nav_group/1 function on the resource.","ref":"ExTeal.Resource.html#c:nav_group/1","title":"ExTeal.Resource.nav_group/1","type":"callback"},{"doc":"Override the detail or edit link for a resource on the resource index. When defining this callback, be aware that resources referenced by a many to many relationship will also call this function when rendering the index of that many to many.","ref":"ExTeal.Resource.html#c:navigate_to/3","title":"ExTeal.Resource.navigate_to/3","type":"callback"},{"doc":"Allows skipping sanitize for all fields on a resource","ref":"ExTeal.Resource.html#c:skip_sanitize/0","title":"ExTeal.Resource.skip_sanitize/0","type":"callback"},{"doc":"Specifies the field to use as the basis for a drag and drop interface for the collection.","ref":"ExTeal.Resource.html#c:sortable_by/0","title":"ExTeal.Resource.sortable_by/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.html#to_json/2","title":"ExTeal.Resource.to_json/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.html#t:attributes/0","title":"ExTeal.Resource.attributes/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:id/0","title":"ExTeal.Resource.id/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:indexed_resource/0","title":"ExTeal.Resource.indexed_resource/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:orderable_key/0","title":"ExTeal.Resource.orderable_key/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:orderable_option/0","title":"ExTeal.Resource.orderable_option/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:params/0","title":"ExTeal.Resource.params/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:pivot_resource/0","title":"ExTeal.Resource.pivot_resource/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:record/0","title":"ExTeal.Resource.record/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:records/0","title":"ExTeal.Resource.records/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:t/0","title":"ExTeal.Resource.t/0","type":"type"},{"doc":"","ref":"ExTeal.Resource.html#t:validation_errors/0","title":"ExTeal.Resource.validation_errors/0","type":"type"},{"doc":"Provides the permitted_attributes/3 callback used for filtering attributes. This behaviour is used by the following ExTeal.Resource actions: ExTeal.Resource.Delete ExTeal.Resource.Create","ref":"ExTeal.Resource.Attributes.html","title":"ExTeal.Resource.Attributes","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#clean_and_nest_params/1","title":"ExTeal.Resource.Attributes.clean_and_nest_params/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#combine_and_key_by_field_attr/1","title":"ExTeal.Resource.Attributes.combine_and_key_by_field_attr/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#maybe_sanitize/3","title":"ExTeal.Resource.Attributes.maybe_sanitize/3","type":"function"},{"doc":"Used to determine which attributes are permitted during create and update. The attributes map (the second argument) is a &quot;flattened&quot; version including the values at data/attributes , data/type and any relationship values in data/relationships/[name]/data/id as name_id . The third argument is the atom of the action being called. Example: defmodule MyApp.V1.PostResource do use ExTeal.Resource def permitted_attributes ( conn , attrs , :create ) do attrs |&gt; Map . take ( ~w(title body type category_id) ) |&gt; Map . merge ( &quot;author_id&quot; , conn . assigns [ :current_user ] ) end def permitted_attributes ( _conn , attrs , :update ) do Map . take ( attrs , ~w(title body type category_id) ) end end","ref":"ExTeal.Resource.Attributes.html#c:permitted_attributes/3","title":"ExTeal.Resource.Attributes.permitted_attributes/3","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#raw_html/1","title":"ExTeal.Resource.Attributes.raw_html/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize/2","title":"ExTeal.Resource.Attributes.sanitize/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize_as/2","title":"ExTeal.Resource.Attributes.sanitize_as/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Attributes.html#sanitize_param/2","title":"ExTeal.Resource.Attributes.sanitize_param/2","type":"function"},{"doc":"Defines a behaviour for creating a resource and the function to execute it. It relies on (and uses): ExTeal.Resource.Repo ExTeal.Resource.Model ExTeal.Resource.Attributes When used ExTeal.Resource.Create defines the following overrideable callbacks: handle_create/2 handle_invalid_create/2 render_create/2 ExTeal.Resource.Attributes.permitted_attributes/3 ExTeal.Resource.Repo.repo/1","ref":"ExTeal.Resource.Create.html","title":"ExTeal.Resource.Create","type":"behaviour"},{"doc":"Creates a resource given a module using Create and a connection. Create . call ( ArticleResource , conn )","ref":"ExTeal.Resource.Create.html#call/2","title":"ExTeal.Resource.Create.call/2","type":"function"},{"doc":"Returns an unpersisted changeset or persisted model of the newly created object. Default implementation returns the results of calling Model.changeset(%Model{}, attrs) where Model is the model defined by the ExTeal.Resource.Model.model/0 callback. The attributes argument is the result of the permitted_attributes function. handle_create/2 can return an %Ecto.Changeset, an Ecto.Schema struct, a list of errors ( {:error, [email: &quot;is not valid&quot;]} or a conn with any response/body. ou Example custom implementation: def handle_create ( _conn , attributes ) do Post . changeset ( % Post { } , attributes , :create_and_publish ) end","ref":"ExTeal.Resource.Create.html#c:handle_create/2","title":"ExTeal.Resource.Create.handle_create/2","type":"callback"},{"doc":"Returns a Plug.Conn in response to errors during create. Default implementation sets the status to :unprocessable_entity and renders the error messages provided.","ref":"ExTeal.Resource.Create.html#c:handle_invalid_create/2","title":"ExTeal.Resource.Create.handle_invalid_create/2","type":"callback"},{"doc":"Returns a Plug.Conn in response to successful create. Default implementation sets the status to :created and renders the view.","ref":"ExTeal.Resource.Create.html#c:render_create/2","title":"ExTeal.Resource.Create.render_create/2","type":"callback"},{"doc":"Defines a behaviour for deleting a resource and the function to execute it. It relies on (and uses): ExTeal.Repo ExTeal.Record When used ExTeal.Resource.Delete defines the delete/2 action suitable for handling teal delete requests. To customize the behaviour of the update action the following callbacks can be implemented: handle_delete/2 ExTeal.Record.record/2 ExTeal.Repo.repo/0","ref":"ExTeal.Resource.Delete.html","title":"ExTeal.Resource.Delete","type":"behaviour"},{"doc":"Execute the delete action on a given module implementing Delete behaviour and conn.","ref":"ExTeal.Resource.Delete.html#call/2","title":"ExTeal.Resource.Delete.call/2","type":"function"},{"doc":"Returns an unpersisted changeset or persisted model representing the newly updated model. Receives the conn and the record as found by record/2 . Default implementation returns the results of calling Repo.delete(record) . Example custom implementation: def handle_delete ( conn , record ) do case conn . assigns [ :user ] do %{ is_admin : true } -&gt; super ( conn , record ) _ -&gt; send_resp ( conn , 401 , &quot;nope&quot; ) end end","ref":"ExTeal.Resource.Delete.html#c:handle_delete/2","title":"ExTeal.Resource.Delete.handle_delete/2","type":"callback"},{"doc":"Adds functionality for exporting a stream of records as a csv file.","ref":"ExTeal.Resource.Export.html","title":"ExTeal.Resource.Export","type":"behaviour"},{"doc":"Returns a list of all fields on the schema for export","ref":"ExTeal.Resource.Export.html#default_export_fields/1","title":"ExTeal.Resource.Export.default_export_fields/1","type":"function"},{"doc":"Returns the query with a select that parses all the fields into a map instead of the struct","ref":"ExTeal.Resource.Export.html#default_export_query/2","title":"ExTeal.Resource.Export.default_export_query/2","type":"function"},{"doc":"Turns a record represented as a map and a list of atoms representing the ordered fields in the CSV into a list of values in the same order as the list of fields","ref":"ExTeal.Resource.Export.html#default_parse/2","title":"ExTeal.Resource.Export.default_parse/2","type":"function"},{"doc":"The fields to export from the resource","ref":"ExTeal.Resource.Export.html#c:export_fields/0","title":"ExTeal.Resource.Export.export_fields/0","type":"callback"},{"doc":"Define an override to the default parser, as defined in the ex_teal config Expects the parser to have a dump_to_stream/1 function that accepts a stream of rows and returns a stream of rows.","ref":"ExTeal.Resource.Export.html#c:export_module/0","title":"ExTeal.Resource.Export.export_module/0","type":"callback"},{"doc":"Modify the query for a csv result","ref":"ExTeal.Resource.Export.html#c:handle_export_query/2","title":"ExTeal.Resource.Export.handle_export_query/2","type":"callback"},{"doc":"Parse a row into a CSV Encodeable list of fields Useful for modifying database columns into serializeable strings before the row is passed to CSV.encode/2","ref":"ExTeal.Resource.Export.html#c:parse_export_row/2","title":"ExTeal.Resource.Export.parse_export_row/2","type":"callback"},{"doc":"Build a streamed csv and chunk the results as a response. Uses the resource's querying functionality (filtering, searching, sorting) to return only the resources the user has selected.","ref":"ExTeal.Resource.Export.html#stream/2","title":"ExTeal.Resource.Export.stream/2","type":"function"},{"doc":"Convert map atom keys to strings","ref":"ExTeal.Resource.Export.html#stringify_keys/1","title":"ExTeal.Resource.Export.stringify_keys/1","type":"function"},{"doc":"Provides the fields/0 callback used by the following ExTeal actions: ExTeal.Resource.Index","ref":"ExTeal.Resource.Fields.html","title":"ExTeal.Resource.Fields","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Fields.html#add_panel_key/2","title":"ExTeal.Resource.Fields.add_panel_key/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#all_fields/1","title":"ExTeal.Resource.Fields.all_fields/1","type":"function"},{"doc":"Apply the can_see function attached to a field to filter out the field from serialized responses.","ref":"ExTeal.Resource.Fields.html#apply_can_see/2","title":"ExTeal.Resource.Fields.apply_can_see/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#apply_values/6","title":"ExTeal.Resource.Fields.apply_values/6","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#field_for/2","title":"ExTeal.Resource.Fields.field_for/2","type":"function"},{"doc":"Used to get the fields available to the current action. All resources will override this: def fields ( ) , do : [ Id . make ( ) |&gt; sortable ( ) , Text . make ( &#39;Name&#39; ) |&gt; sortable ( ) , DateTime . make ( :updated_at , &#39;Last Updated At&#39; ) |&gt; hide_from_index ( ) ]","ref":"ExTeal.Resource.Fields.html#c:fields/0","title":"ExTeal.Resource.Fields.fields/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_for/2","title":"ExTeal.Resource.Fields.fields_for/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_for_has_many/2","title":"ExTeal.Resource.Fields.fields_for_has_many/2","type":"function"},{"doc":"Instead of returning the fields for an index table of a resource, this function is called to render a simple belongs to field via a ManyToManyBelongsTo field. Given a many to many relationship between posts and tags, an index query for the tags associated with a post should return a single many to many belongs to field that represents a tag associated with the post. The field will then have options built up to make it behave like a belongs_to on the client side.","ref":"ExTeal.Resource.Fields.html#fields_for_many_to_many/2","title":"ExTeal.Resource.Fields.fields_for_many_to_many/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#fields_from_model/1","title":"ExTeal.Resource.Fields.fields_from_model/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#index_fields/2","title":"ExTeal.Resource.Fields.index_fields/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#index_fields_for_many/2","title":"ExTeal.Resource.Fields.index_fields_for_many/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#meta_for/6","title":"ExTeal.Resource.Fields.meta_for/6","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#pivot_fields_for/3","title":"ExTeal.Resource.Fields.pivot_fields_for/3","type":"function"},{"doc":"Find the field on the resource that includes context for the relationship that is being queried.","ref":"ExTeal.Resource.Fields.html#relationship_field/2","title":"ExTeal.Resource.Fields.relationship_field/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Fields.html#serialize_response/4","title":"ExTeal.Resource.Fields.serialize_response/4","type":"function"},{"doc":"Behavior for handling index requests for a given resource","ref":"ExTeal.Resource.Index.html","title":"ExTeal.Resource.Index","type":"behaviour"},{"doc":"Returns the actions available for a resource Default implementation is an empty array.","ref":"ExTeal.Resource.Index.html#c:actions/1","title":"ExTeal.Resource.Index.actions/1","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#call/2","title":"ExTeal.Resource.Index.call/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#field_filters/3","title":"ExTeal.Resource.Index.field_filters/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#filter_via_relationships/2","title":"ExTeal.Resource.Index.filter_via_relationships/2","type":"function"},{"doc":"Returns the models to be represented by this resource. Default implementation is the result of the ExTeal.Resource.Records.records/2 callback. Usually a module or an %Ecto.Query{} . The results of this callback are passed to the filter and sort callbacks before the query is executed. handle_index/2 can alternatively return a conn with any response/body. Example custom implementation: def handle_index ( conn , _params ) do case conn . assigns [ :current_user ] do nil -&gt; App.Post user -&gt; User . own_posts ( user ) end end In most cases ExTeal.Resource.Records.records/1, filter/4, and sort/4 are the better customization hooks.","ref":"ExTeal.Resource.Index.html#c:handle_index/2","title":"ExTeal.Resource.Index.handle_index/2","type":"callback"},{"doc":"Returns the models to be represented by this resource via a relationship. Default implementation is the result of the ExTeal.Resource.Records.records/2 callback returning an ecto query with the fields necessary to display the title. handle_related/2 can alternatively return a conn with any response/body. Example custom implementation: def handle_related ( conn , _params ) do case conn . assigns [ :current_user ] do nil -&gt; App.Post user -&gt; User . own_posts ( user ) end end","ref":"ExTeal.Resource.Index.html#c:handle_related/2","title":"ExTeal.Resource.Index.handle_related/2","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#query_by_related/3","title":"ExTeal.Resource.Index.query_by_related/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#query_for_related/2","title":"ExTeal.Resource.Index.query_for_related/2","type":"function"},{"doc":"Callback implementation for ExTeal.Resource.Repo.repo/0 .","ref":"ExTeal.Resource.Index.html#repo/0","title":"ExTeal.Resource.Index.repo/0","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#reversed_query/4","title":"ExTeal.Resource.Index.reversed_query/4","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#search/3","title":"ExTeal.Resource.Index.search/3","type":"function"},{"doc":"Defines the search adapter to use while building a search query: Defaults to the ExTeal.Search.SimpleSearch module","ref":"ExTeal.Resource.Index.html#c:search_adapter/3","title":"ExTeal.Resource.Index.search_adapter/3","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Index.html#sort/3","title":"ExTeal.Resource.Index.sort/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Index.html#with_pivot_fields/3","title":"ExTeal.Resource.Index.with_pivot_fields/3","type":"function"},{"doc":"Provides the model/0 callback used to customize the resource served. This behaviour is used by all ExTeal actions.","ref":"ExTeal.Resource.Model.html","title":"ExTeal.Resource.Model","type":"behaviour"},{"doc":"Array of default field filters to be used when there are no filters present","ref":"ExTeal.Resource.Model.html#c:default_filters/0","title":"ExTeal.Resource.Model.default_filters/0","type":"callback"},{"doc":"Must return the module implementing Ecto.Schema to be represented. Example: def model , do : MyApp.Models.Post Defaults to the name of the resource, for example the resource MyApp.V1.PostResource would serve the MyApp.Post model. Used by the default implementations for handle_create/2 , handle_update/3 , and records/1 .","ref":"ExTeal.Resource.Model.html#c:model/0","title":"ExTeal.Resource.Model.model/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#model_from_resource/1","title":"ExTeal.Resource.Model.model_from_resource/1","type":"function"},{"doc":"The fields that should be searched","ref":"ExTeal.Resource.Model.html#c:search/0","title":"ExTeal.Resource.Model.search/0","type":"callback"},{"doc":"Returns the singularized version of the title to display on forms.","ref":"ExTeal.Resource.Model.html#c:singular_title/0","title":"ExTeal.Resource.Model.singular_title/0","type":"callback"},{"doc":"Returns the subtitle to display in relationships. Defaults to looking for name or title fields, falls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:subtitle_for_schema/1","title":"ExTeal.Resource.Model.subtitle_for_schema/1","type":"callback"},{"doc":"Returns the thumbnail to display in search. Defaults to looking for name or title fields, falls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:thumbnail_for_schema/1","title":"ExTeal.Resource.Model.thumbnail_for_schema/1","type":"callback"},{"doc":"Returns the title to display in the side bar. Defaults to finding the title from the resource modules name","ref":"ExTeal.Resource.Model.html#c:title/0","title":"ExTeal.Resource.Model.title/0","type":"callback"},{"doc":"Returns the title to display in relationships. Defaults to looking for name or title fields, falls back to the schemas name appended by it's id","ref":"ExTeal.Resource.Model.html#c:title_for_schema/1","title":"ExTeal.Resource.Model.title_for_schema/1","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#title_for_schema_from_struct/1","title":"ExTeal.Resource.Model.title_for_schema_from_struct/1","type":"function"},{"doc":"","ref":"ExTeal.Resource.Model.html#title_from_resource/1","title":"ExTeal.Resource.Model.title_from_resource/1","type":"function"},{"doc":"Returns the uri to display in the side bar. Defaults to finding the uri from the resource modules name","ref":"ExTeal.Resource.Model.html#c:uri/0","title":"ExTeal.Resource.Model.uri/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Model.html#uri_from_resource/1","title":"ExTeal.Resource.Model.uri_from_resource/1","type":"function"},{"doc":"Used to build paginated views of resources","ref":"ExTeal.Resource.Pagination.html","title":"ExTeal.Resource.Pagination","type":"module"},{"doc":"","ref":"ExTeal.Resource.Pagination.html#paginate_query/3","title":"ExTeal.Resource.Pagination.paginate_query/3","type":"function"},{"doc":"Defines a behaviour for authorizing use CRUD","ref":"ExTeal.Resource.Policy.html","title":"ExTeal.Resource.Policy","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Policy.html#c:policy/0","title":"ExTeal.Resource.Policy.policy/0","type":"callback"},{"doc":"This behaviour is used by the following ExTeal.Resource actions: ExTeal.Resource.Show ExTeal.Resource.Update ExTeal.Resource.Delete It relies on (and uses): ExTeal.Resource.Records","ref":"ExTeal.Resource.Record.html","title":"ExTeal.Resource.Record","type":"behaviour"},{"doc":"Used to get the subject of the current action Many/most controllers will override this: def record ( % Plug.Conn { assigns : %{ user_id : user_id } } , id ) do model ( ) |&gt; where ( [ p ] , p . author_id == ^ user_id ) |&gt; Repo . get ( id ) end","ref":"ExTeal.Resource.Record.html#c:record/2","title":"ExTeal.Resource.Record.record/2","type":"callback"},{"doc":"Provides the records/1 callback used for querying records to be served. This is typically the base query that you expose, often scoped to the current user. This behaviour is used by the following ExTeal.Resource actions: ExTeal.Resource.Index ExTeal.Resource.Show ExTeal.Resource.Update ExTeal.Resource.Delete It relies on (and uses): ExTeal.Resource.Model","ref":"ExTeal.Resource.Records.html","title":"ExTeal.Resource.Records","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Records.html#preload/2","title":"ExTeal.Resource.Records.preload/2","type":"function"},{"doc":"Used to get the base query of records. Many/most resources will override this: def records ( % Plug.Conn { assigns : %{ user_id : user_id } } ) do model ( ) |&gt; where ( [ p ] , p . author_id == ^ user_id ) end Return value should be %Plug.Conn{} or an %Ecto.Queryable{}.","ref":"ExTeal.Resource.Records.html#c:records/2","title":"ExTeal.Resource.Records.records/2","type":"callback"},{"doc":"Used to specify which relationships to always preload with all requests.","ref":"ExTeal.Resource.Records.html#c:with/0","title":"ExTeal.Resource.Records.with/0","type":"callback"},{"doc":"","ref":"ExTeal.Resource.Repo.html","title":"ExTeal.Resource.Repo","type":"behaviour"},{"doc":"Defines the module use -ing Ecto.Repo to be used by the resource. Defaults to the value set in config if present: config :ex_teal , repo : MyApp.Repo Default can be overridden per resource: def repo , do : MyApp.SecondaryRepo","ref":"ExTeal.Resource.Repo.html#c:repo/0","title":"ExTeal.Resource.Repo.repo/0","type":"callback"},{"doc":"Serializes a resource response into json","ref":"ExTeal.Resource.Serializer.html","title":"ExTeal.Resource.Serializer","type":"module"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#as_json/3","title":"ExTeal.Resource.Serializer.as_json/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#error/2","title":"ExTeal.Resource.Serializer.error/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_create/3","title":"ExTeal.Resource.Serializer.render_create/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_errors/2","title":"ExTeal.Resource.Serializer.render_errors/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_index/3","title":"ExTeal.Resource.Serializer.render_index/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_related/3","title":"ExTeal.Resource.Serializer.render_related/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_show/3","title":"ExTeal.Resource.Serializer.render_show/3","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#render_update/3","title":"ExTeal.Resource.Serializer.render_update/3","type":"function"},{"doc":"Generates a map that summarizes the specified schema for global and relational searches.","ref":"ExTeal.Resource.Serializer.html#schema_summary/2","title":"ExTeal.Resource.Serializer.schema_summary/2","type":"function"},{"doc":"","ref":"ExTeal.Resource.Serializer.html#send/3","title":"ExTeal.Resource.Serializer.send/3","type":"function"},{"doc":"Defines a behaviour for displaying a resource and the function to execute it. It relies on (and uses): ExTeal.Resource.Record ExTeal.Resource.Serializable When used ExTeal.Resource.Show defines the show/2 action suitable for handling api requests. To customize the behaviour of the show action the following callbacks can be implemented: handle_show/2 render_show/2 ExTeal.Resource.Record.record/2 ExTeal.Resource.Record.records/1","ref":"ExTeal.Resource.Show.html","title":"ExTeal.Resource.Show","type":"behaviour"},{"doc":"Execute the show action on a given module implementing Show behaviour and conn.","ref":"ExTeal.Resource.Show.html#call/3","title":"ExTeal.Resource.Show.call/3","type":"function"},{"doc":"Returns the model to be represented by this resource. Default implementation is the result of the ExTeal.Resource.Record.record/2 callback. handle_show/2 can return nil to send a 404, a conn with any response/body, or a record to be serialized. Example custom implementation: def handle_show ( conn , id ) do Repo . get_by ( Post , slug : id ) end In most cases ExTeal.Resource.Record.record/2 and ExTeal.Resource.Records.records/1 are the better customization hooks.","ref":"ExTeal.Resource.Show.html#c:handle_show/2","title":"ExTeal.Resource.Show.handle_show/2","type":"callback"},{"doc":"Returns a Plug.Conn in response to successful show. Default implementation renders the view.","ref":"ExTeal.Resource.Show.html#c:render_show/3","title":"ExTeal.Resource.Show.render_show/3","type":"callback"},{"doc":"Defines a behaviour for updating a resource and the function to execute it. It relies on (and uses): ExTeal.Resource.Record ExTeal.Resource.Attributes When used ExTeal.Resource.Update defines the update/2 action suitable for handling json-api requests. To customize the behaviour of the update action the following callbacks can be implemented: ExTeal.Resource.Record.record/2 ExTeal.Resource.Records.records/1 handle_update/3 handle_invalid_update/2 render_update/2 ExTeal.Resource.Attributes.permitted_attributes/3","ref":"ExTeal.Resource.Update.html","title":"ExTeal.Resource.Update","type":"behaviour"},{"doc":"","ref":"ExTeal.Resource.Update.html#batch_update/2","title":"ExTeal.Resource.Update.batch_update/2","type":"function"},{"doc":"Execute the update action on a given module implementing Update behaviour and conn.","ref":"ExTeal.Resource.Update.html#call/3","title":"ExTeal.Resource.Update.call/3","type":"function"},{"doc":"Returns a Plug.Conn in response to errors during update. Default implementation sets the status to :unprocessable_entity and renders the error messages provided.","ref":"ExTeal.Resource.Update.html#c:handle_invalid_update/2","title":"ExTeal.Resource.Update.handle_invalid_update/2","type":"callback"},{"doc":"Returns an unpersisted changeset or persisted model representing the newly updated model. Receives the conn, the model as found by record/2 , and the attributes argument from the permitted_attributes function. Default implementation returns the results of calling Model.changeset(model, attrs) . handle_update/3 can return an %Ecto.Changeset, an Ecto.Schema struct, a list of errors ( {:error, [email: &quot;is not valid&quot;]} or a conn with any response/body. Example custom implementation: def handle_update ( conn , post , attributes ) do current_user_id = conn . assigns [ :current_user ] . id case post . author_id do ^ current_user_id -&gt; { :error , author_id : &quot;you can only edit your own posts&quot; } _ -&gt; Post . changeset ( post , attributes , :update ) end end","ref":"ExTeal.Resource.Update.html#c:handle_update/3","title":"ExTeal.Resource.Update.handle_update/3","type":"callback"},{"doc":"Returns a Plug.Conn in response to successful update. Default implementation renders the view.","ref":"ExTeal.Resource.Update.html#c:render_update/2","title":"ExTeal.Resource.Update.render_update/2","type":"callback"},{"doc":"A Plug.Router . This module is meant to be plugged into host applications. See the readme for more details.","ref":"ExTeal.Router.html","title":"ExTeal.Router","type":"module"},{"doc":"Callback implementation for Plug.init/1 .","ref":"ExTeal.Router.html#init/1","title":"ExTeal.Router.init/1","type":"function"},{"doc":"The default search adapter. Uses dynamic ecto queries to build a simple ILIKE comparison across the field specified by the search/2 function on the resource.","ref":"ExTeal.Search.SimpleSearch.html","title":"ExTeal.Search.SimpleSearch","type":"module"},{"doc":"Build a dynamic ecto where statement by reducing over the resource's searchable fields and creating an ilike where expression","ref":"ExTeal.Search.SimpleSearch.html#build/3","title":"ExTeal.Search.SimpleSearch.build/3","type":"function"},{"doc":"The Theme module provides functionality for engineers to customize the appearance of Teal by changing the colors used in the user interface. The struct provides the default values, and can be overriden by providing a custom struct in the ExTeal.Manifest module.","ref":"ExTeal.Theme.html","title":"ExTeal.Theme","type":"module"},{"doc":"","ref":"ExTeal.Theme.html#color_variables/1","title":"ExTeal.Theme.color_variables/1","type":"function"},{"doc":"","ref":"ExTeal.Theme.html#t:t/0","title":"ExTeal.Theme.t/0","type":"type"},{"doc":"Returns HTML to render as the main interface of Teal.","ref":"ExTeal.View.html","title":"ExTeal.View","type":"module"},{"doc":"","ref":"ExTeal.View.html#index/1","title":"ExTeal.View.index/1","type":"function"},{"doc":"","ref":"ExTeal.View.html#render/1","title":"ExTeal.View.render/1","type":"function"},{"doc":"The default dashboard that contains links to documentation for new engineers.","ref":"ExTeal.WelcomeDashboard.html","title":"ExTeal.WelcomeDashboard","type":"module"},{"doc":"Callback implementation for ExTeal.Dashboard.cards/1 .","ref":"ExTeal.WelcomeDashboard.html#cards/1","title":"ExTeal.WelcomeDashboard.cards/1","type":"function"},{"doc":"Callback implementation for ExTeal.Dashboard.display?/1 .","ref":"ExTeal.WelcomeDashboard.html#display?/1","title":"ExTeal.WelcomeDashboard.display?/1","type":"function"},{"doc":"Callback implementation for ExTeal.Dashboard.title/0 .","ref":"ExTeal.WelcomeDashboard.html#title/0","title":"ExTeal.WelcomeDashboard.title/0","type":"function"},{"doc":"Callback implementation for ExTeal.Dashboard.uri/0 .","ref":"ExTeal.WelcomeDashboard.html#uri/0","title":"ExTeal.WelcomeDashboard.uri/0","type":"function"},{"doc":"Policies Policies are a way of controlling access to resources within Teal.","ref":"policies.html","title":"Policies","type":"extras"},{"doc":"The default policy is ExTeal.OpenEverywherePolicy , which has the following implementations: # Resource level permissions def create_any? ( _conn ) , do : true def view_any? ( _conn ) , do : true def update_any? ( _conn ) , do : true def delete_any? ( _conn ) , do : true # Resource item level permissions def view? ( _conn , _item ) , do : true def update? ( _conn , _item ) , do : true def delete? ( _conn , _item ) , do : true To change the default policy, create a new policy module e.g: # lib/my_app_web/ex_teal/closed_everywhere_policy.ex defmodule MyAppWeb.ExTeal.ClosedEverywherePolicy do use ExTeal.Policy def create_any? ( _conn ) , do : false def view_any? ( _conn ) , do : false def update_any? ( _conn ) , do : false def delete_any? ( _conn ) , do : false def view? ( _conn , _item ) , do : false def update? ( _conn , _item ) , do : false def delete? ( _conn , _item ) , do : false end Then set it in your manifest: # lib/my_app_web/ex_teal/manifest.ex defmodule MyAppWeb.ExTeal.Manifest do use ExTeal.Manifest # ... def default_policy , do : MyAppWeb.ExTeal.ClosedEverywherePolicy # ... end","ref":"policies.html#default-policy","title":"Policies - Default policy","type":"extras"},{"doc":"You can override the policy at the resource level by implementing the policy/0 callback # lib/my_app_web/ex_teal/resources/thing_resource.ex defmodule MyAppWeb.ExTeal.ThingResource do use ExTeal.Resource alias ExTeal.Fields . { ID , Text } def policy , do : MyAppWeb.ExTeal.ThingPolicy # ... def fields , do : [ ID . make ( :id ) , Text . make ( :title ) , ] end Lets create that resource policy: # lib/my_app_web/ex_teal/thing_policy.ex defmodule MyAppWeb.ExTeal.ThingPolicy do use ExTeal.Policy # Only allow the super_admin role to interact with &quot;Thing&quot;s def create_any? ( conn ) do conn . assigns . current_user . role == :super_admin end def view_any? ( conn ) do conn . assigns . current_user . role == :super_admin end def update_any? ( conn ) do conn . assigns . current_user . role == :super_admin end def delete_any? ( conn ) do conn . assigns . current_user . role == :super_admin end def view? ( conn , _thing ) do conn . assigns . current_user . role == :super_admin end def update? ( conn , _thing ) do conn . assigns . current_user . role == :super_admin end def delete? ( conn , _thing ) do conn . assigns . current_user . role == :super_admin end end","ref":"policies.html#resource-policies","title":"Policies - Resource Policies","type":"extras"},{"doc":"ExTeal","ref":"readme.html","title":"ExTeal","type":"extras"},{"doc":"Add ExTeal to your packages: def deps do [ { :ex_teal , &quot;~&gt; 0.1&quot; } ] end Stuff here! One Day! defmodule YourAppWeb.ExTeal do alias YourAppWeb.Resources def resources , do : [ Resources.User ] end","ref":"readme.html#installation","title":"ExTeal - Installation","type":"extras"},{"doc":"Update a project that uses Teal to point to your local repo: defp deps do [ { :ex_teal , path : &quot;../ex_teal&quot; } ] In the same project's dev config, configure Teal to use vue-cli generated assets rather than the compiled assets. config :ex_teal , compiled_assets : false In Teal's assets/ , host the assets by running yarn &amp;&amp; yarn dev","ref":"readme.html#developing-teal","title":"ExTeal - Developing Teal","type":"extras"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug Fixes Add permissions to Delete Menu on Resource Index ( 40faef1 )","ref":"changelog.html#0-25-1-2023-08-11","title":"Changelog - 0.25.1 (2023-08-11)","type":"extras"},{"doc":"Features More Many-To-Many customization ( 35039ab ) Bug Fixes index queries filtered by a relationship should still use virtual fields for sorting ( 3ad1ea7 )","ref":"changelog.html#0-25-0-2023-07-20","title":"Changelog - 0.25.0 (2023-07-20)","type":"extras"},{"doc":"Features Support Has Many Through Relationships ( 26d4187 )","ref":"changelog.html#0-24-0-2023-07-14","title":"Changelog - 0.24.0 (2023-07-14)","type":"extras"},{"doc":"Bug Fixes Serializer should consider errors where the key is an array ( #205 ) ( 59953fc )","ref":"changelog.html#0-23-1-2023-07-10","title":"Changelog - 0.23.1 (2023-07-10)","type":"extras"},{"doc":"Features Customize the index fields on a has many field ( #197 ) ( 4a2dde1 ) Bug Fixes except on forms should only touch forms ( #202 ) ( fbd489b ) Surface BelongsTo Errors in form validation errors, move ex-teal-js code ( #201 ) ( 6542f67 ) virtual fields should just mark themselves virtual, do not force field visibility ( #204 ) ( 479cc35 )","ref":"changelog.html#0-23-0-2023-07-07","title":"Changelog - 0.23.0 (2023-07-07)","type":"extras"},{"doc":"Bug Fixes BelongsTo fields should not assume an non-nil value ( #198 ) ( 90f9bbf ) Default Field filters should always apply on initialization, not just initially ( #200 ) ( 9707662 )","ref":"changelog.html#0-22-2-2023-06-30","title":"Changelog - 0.22.2 (2023-06-30)","type":"extras"},{"doc":"Bug Fixes BelongsTo polish ( #193 ) ( 99d1c55 )","ref":"changelog.html#0-22-1-2023-06-16","title":"Changelog - 0.22.1 (2023-06-16)","type":"extras"},{"doc":"Features Dashboard Resource Table, Virtual Aggregates ( #189 ) ( 03273a2 )","ref":"changelog.html#0-22-0-2023-06-15","title":"Changelog - 0.22.0 (2023-06-15)","type":"extras"},{"doc":"Features Add a Greeting Card, enabled by adding a conn argument to options on Card ( #186 ) ( 48180d8 ) Bug Fixes reset the detail page when resources change so that cards are not persisted ( #183 ) ( b04d582 )","ref":"changelog.html#0-21-0-2023-05-25","title":"Changelog - 0.21.0 (2023-05-25)","type":"extras"},{"doc":"Bug Fixes Allow Distinct in handle_index/2 callbacks ( #181 ) ( f7e8ada )","ref":"changelog.html#0-20-1-2023-04-19","title":"Changelog - 0.20.1 (2023-04-19)","type":"extras"},{"doc":"Features Introduce can_see?/2 to add field specific authorization ( 1d52b6b ) Bug Fixes Panels were lost in the see_more/2 release ( d28fa73 ) Separate Query Preloads from records/2 call ( a6026f9 )","ref":"changelog.html#0-20-0-2023-04-11","title":"Changelog - 0.20.0 (2023-04-11)","type":"extras"},{"doc":"Bug Fixes compare, display and use select values in field filters ( ffb7d87 ) deps: upgrade nimble csv ( #174 ) ( 21a3dd4 ) embedded schema filtering may not be possible with postgres due to json magic ( 8e28eeb )","ref":"changelog.html#0-19-4-2023-04-04","title":"Changelog - 0.19.4 (2023-04-04)","type":"extras"},{"doc":"Bug Fixes default panel title and flatten panels while sorting ( #172 ) ( 66db8c0 )","ref":"changelog.html#0-19-3-2023-03-31","title":"Changelog - 0.19.3 (2023-03-31)","type":"extras"},{"doc":"Bug Fixes Allow users to customize the singular name of a resource for when naming is hard ( #169 ) ( d1075bb )","ref":"changelog.html#0-19-2-2023-03-31","title":"Changelog - 0.19.2 (2023-03-31)","type":"extras"},{"doc":"Bug Fixes add some styles for direct upload ( #167 ) ( 9809763 )","ref":"changelog.html#0-19-1-2023-03-29","title":"Changelog - 0.19.1 (2023-03-29)","type":"extras"},{"doc":"Features Embedded Resources and Panel Upgrades ( #164 ) ( b5d75e0 )","ref":"changelog.html#0-19-0-2023-03-28","title":"Changelog - 0.19.0 (2023-03-28)","type":"extras"},{"doc":"Features Elixir Version Bump and add default field filters ( #155 ) ( ae3408a ) Bug Fixes table row should acknowledge resource permissions ( #154 ) ( 71e5e4c ) 0.17.1 (2022-06-17) Bug Fixes array field wouldn't save empty value ( #145 ) ( ef09ca2 )","ref":"changelog.html#0-18-0-2023-03-22","title":"Changelog - 0.18.0 (2023-03-22)","type":"extras"},{"doc":"Features Add Rich MultiSelect functionality ( 7c39bf7 ) Bug Fixes show empty status ( 09297df ) 0.16.4 (2021-11-11) Bug Fixes All fields should include subfields nested in a field ( 75de0fc ) ManyToManys with Pivot Fields should use the child key when the model is the pivot schema, not the child schema ( 6dc6aec ) 0.16.3 (2021-10-19) Bug Fixes BooleanGroup options changed ( 189027e ) 0.16.2 (2021-10-06) Bug Fixes Resource responder was using the incorrect function signature for Fields.apply_values/5 ( 1780a67 ) 0.16.1 (2021-10-01) Bug Fixes BelongsTo and SearchInput need valid props and disabled mode ( #123 ) ( cc5dd8b )","ref":"changelog.html#0-17-0-2022-01-20","title":"Changelog - 0.17.0 (2022-01-20)","type":"extras"},{"doc":"Features add individual resource policies ( #114 ) ( b660f73 ) 0.15.1 (2021-08-12) Bug Fixes show errors on array form ( 0d4e9d6 )","ref":"changelog.html#0-16-0-2021-09-13","title":"Changelog - 0.16.0 (2021-09-13)","type":"extras"},{"doc":"Features New Boolean Group Options functionality ( f79e867 ) 0.14.1 (2021-05-21) Bug Fixes Clean up compiler warnings in 1.11 versions of Elixir ( 836de32 ) Invalid Typespecs from default functions on Trend Metrics ( 0eb02fd )","ref":"changelog.html#0-15-0-2021-06-08","title":"Changelog - 0.15.0 (2021-06-08)","type":"extras"},{"doc":"Features Select fields can represent Ecto.Enums ( 5823c9f ) 0.13.2 (2021-05-12) Bug Fixes Number fields are now represented as string fields, parse them to integers before reordering ( 4a91569 ) 0.13.1 (2021-05-11) Bug Fixes cast fields to string for simple search ( 2e6637d )","ref":"changelog.html#0-14-0-2021-05-18","title":"Changelog - 0.14.0 (2021-05-18)","type":"extras"},{"doc":"Features As a user, I should be able to search a resource by the primary id ( c129c97 ) BelongsTo should always be searchable ( defbda6 ) Upgrade Number Field ( 3a61e4d ) 0.12.5 (2021-04-23) Bug Fixes Broken tests due to timezone offsets ( e7e0b47 ) Broken Type Specs ( e3673a9 ) 0.12.4 (2021-02-03) Bug Fixes Cannot return multi in handle create ( #51 ) ( 7aaabf1 ) 0.12.3 (2020-12-14) Bug Fixes Delete requests should use the correct params ( 331b996 ) 0.12.2 (2020-12-14) Bug Fixes Deleting with 'select all' was not including relationships ( 8945a1b ) 0.12.1 (2020-12-03) Bug Fixes The Naive DateTime Picker was using the incorrect month token ( 780146b )","ref":"changelog.html#0-13-0-2021-05-07","title":"Changelog - 0.13.0 (2021-05-07)","type":"extras"},{"doc":"Features Select refactor ( #43 ) ( 667dbd9 ) 0.11.2 (2020-11-17) Bug Fixes Action Relationship Params are non-empty ( #41 ) ( 592c220 ) 0.11.1 (2020-11-13) Bug Fixes Fix Naive DateTime Selector ( #39 ) ( 226b8c4 )","ref":"changelog.html#0-12-0-2020-11-18","title":"Changelog - 0.12.0 (2020-11-18)","type":"extras"},{"doc":"Features Enable Naive DateTime Fields ( 4b96d70 ), closes #36 Update BooleanGroup for ecto 3.5 ( #35 ) ( 49228f0 ) Bug Fixes Day Light Savings brittle tests ( a5f7261 ) 0.10.4 (2020-10-27) Bug Fixes Enable ex_teal_dependency_container to include it's params. ( #33 ) ( f96edc2 ) 0.10.3 (2020-10-14) Bug Fixes Use the correct select props and events for the non-searchable attach view ( #30 ) ( d17e02d ) Value Format should be a string, not charlist ( #31 ) ( e2d8137 ) 0.10.2 (2020-10-09) Bug Fixes Query Params need to be snake cased ( #28 ) ( e48a952 ) 0.10.1 (2020-10-09) Bug Fixes Actions should use all index filtering tools when building a query ( 9c55bcf ) Include the version.txt in the release ( 6ecf7d7 )","ref":"changelog.html#0-11-0-2020-11-04","title":"Changelog - 0.11.0 (2020-11-04)","type":"extras"},{"doc":"Features Trend and Value metrics should use formatting ( 89797bd ) Bug Fixes Adjust partition metric size ( 0bffd66 ) Card Wrapper xl window size was being purged ( #21 ) ( 7c3f977 ) Fix compile warning ( 9299be5 ) 0.9.3 (2020-08-26) Features Partition Metrics Teal Themes Bug Fixes Darken h3 side-nav headers Card Wrapper was losing it's xl break points 0.9.2 (2020-08-26) Features Metric Style Improvements Metrics have their own time controls again Time controls are configurable per metric. 0.9.1 (2020-08-24) Features New Boolean Group Field 0.9.0 (2020-07-28) Features A complete rewrite of Metrics to introduce Trend metrics. 0.8.8 (2020-06-22) Bug Fixes Empty HasOne fields threw an error. 0.8.7 (2020-06-20) Bug Fixes Invalid 204 Status 0.8.6 (2020-06-19) Bug Fixes HasOne Index Field had a bad url ( af5c411 ) UpdateAttached does not function. ( #8 ) ( d4aee01 ), closes #9 0.8.5 (2020-06-15) Features export: Configurable export ( #4 ) ( 4fccd4d ) Bug Fixes Resources with panels were broken ( aaaa485 ) Use Dialyxir in Test ( #5 ) ( ef28bc9 )","ref":"changelog.html#0-10-0-2020-09-16","title":"Changelog - 0.10.0 (2020-09-16)","type":"extras"},{"doc":"Fixes Forgot to compile assets","ref":"changelog.html#0-8-4-2020-05-26","title":"Changelog - [0.8.4] - 2020-05-26","type":"extras"},{"doc":"Changed Changed the function arguments for search.","ref":"changelog.html#0-8-3-2020-05-26","title":"Changelog - [0.8.3] - 2020-05-26","type":"extras"},{"doc":"Added The Many To Many Attach view can now use searchable relationships. Unified UX and engineering ergonomics for searchable results.","ref":"changelog.html#0-8-2-2020-05-11","title":"Changelog - [0.8.2] - 2020-05-11","type":"extras"},{"doc":"Changed Updated Download Icon Export file name now uses the resources uri rather then it's title","ref":"changelog.html#0-8-1-2020-05-07","title":"Changelog - [0.8.1] - 2020-05-07","type":"extras"},{"doc":"Added Teal has removed the concept of static, per-field filters for automatically build field_filters . These filters can now be combined, extended and can use far more advanced and useful customizable operators. New dynamic filters. See below for required changes. New Table UX Export as a CSV Depreciated To update to 0.8.0: Remove the filters/0 functions from your resources Remove old filters If you need to extend the logic of the included field filters, use the ExTeal.Field.filter_as/2 function to modify the appropriate field and define a custom module that implements the behaviour of ExTeal.FieldFilter","ref":"changelog.html#0-8-0-2020-05-06","title":"Changelog - [0.8.0] - 2020-05-06","type":"extras"},{"doc":"Fixes An Empty MultiSelect Form","ref":"changelog.html#0-7-9-2020-04-13","title":"Changelog - [0.7.9] - 2020-04-13","type":"extras"},{"doc":"Added Help Text","ref":"changelog.html#0-7-8-2020-04-02","title":"Changelog - [0.7.8] - 2020-04-02","type":"extras"},{"doc":"Added Ability to override the default search tool.","ref":"changelog.html#0-7-7-2020-03-25","title":"Changelog - [0.7.7] - 2020-03-25","type":"extras"},{"doc":"Added Ability to skip the sanitizers on a per resource basis.","ref":"changelog.html#0-7-6-2020-02-11","title":"Changelog - [0.7.6] - 2020-02-11","type":"extras"},{"doc":"Added Action queries now use the Index functionality for preloads.","ref":"changelog.html#0-7-5-2020-02-03","title":"Changelog - [0.7.5] - 2020-02-03","type":"extras"},{"doc":"Changes Adds the ActionResponse struct that allows completed actions to change the user interface.","ref":"changelog.html#0-7-4-2020-01-23","title":"Changelog - [0.7.4] - 2020-01-23","type":"extras"},{"doc":"Fixes Fixes a regression in the update to apply_options_for for update","ref":"changelog.html#0-7-3-2020-01-09","title":"Changelog - [0.7.3] - 2020-01-09","type":"extras"},{"doc":"Fixes Fixes a regression in the update to apply_options_for for the create-fields","ref":"changelog.html#0-7-2-2020-01-09","title":"Changelog - [0.7.2] - 2020-01-09","type":"extras"},{"doc":"Fixes Fixes a regression in the update to apply_options_for","ref":"changelog.html#0-7-1-2020-01-09","title":"Changelog - [0.7.1] - 2020-01-09","type":"extras"},{"doc":"Breaking Changes [breaking] Changes ExTeal.Field.apply_options_for to accept a third argument. See !77","ref":"changelog.html#0-7-0-2020-01-09","title":"Changelog - [0.7.0] - 2020-01-09","type":"extras"},{"doc":"Adds Adds a default_order callback to the resource to allow engineers to define the default order of a resource.","ref":"changelog.html#0-6-1-2020-01-09","title":"Changelog - [0.6.1] - 2020-01-09","type":"extras"},{"doc":"Adds Adds a dropdown_content function to the AuthProvider . Adds an Array field Changes [breaking] Changes gravatar to avatar_url for the current_user map Fixes Cleans up the spec for current_user_for","ref":"changelog.html#0-6-0-2020-01-06","title":"Changelog - [0.6.0] - 2020-01-06","type":"extras"},{"doc":"Adds DateTime field luxon datetime library Removes date-fns date parsing Changes Refactors Date , and DateTimePicker fields Depreciates Date.with_options/2 was depreciated in favor of Date.format/2 and Date.picker_format/2 . Will be removed in 1.0.0","ref":"changelog.html#0-5-0-2019-12-09","title":"Changelog - [0.5.0] - 2019-12-09","type":"extras"},{"doc":"Fixes Excerpts were ignoring line breaks Rich Text field content was being sanitized Flatpickr date time styles were missing","ref":"changelog.html#0-4-4-2019-10-22","title":"Changelog - [0.4.4] - 2019-10-22","type":"extras"},{"doc":"Fixes Broken Form submission when panels are used Broken Address Fields","ref":"changelog.html#0-4-3-2019-10-11","title":"Changelog - [0.4.3] - 2019-10-11","type":"extras"},{"doc":"Adds as_html field modifier Computed fields with a new get field modifier","ref":"changelog.html#0-4-2-2019-09-19","title":"Changelog - [0.4.2] - 2019-09-19","type":"extras"},{"doc":"Fixes Dashboard was missing cards","ref":"changelog.html#0-4-1-2019-09-12","title":"Changelog - [0.4.1] - 2019-09-12","type":"extras"},{"doc":"Adds Value Metrics Dashboards A default dashboard Pagination Labels to Resource Index Tables Resource Index Tables can be searched BelongsTo fields can be searched Fixes An empty string is now sanitized to nil","ref":"changelog.html#0-4-0-2019-09-05","title":"Changelog - [0.4.0] - 2019-09-05","type":"extras"},{"doc":"Fixes Styles for a better nav layout Global Search was broken Field visibility for Pivot Fields","ref":"changelog.html#0-3-6-2019-08-06","title":"Changelog - [0.3.6] - 2019-08-06","type":"extras"},{"doc":"Fixes Don't attempt to sanitize non-bitstring params","ref":"changelog.html#0-3-5-2019-07-26","title":"Changelog - [0.3.5] - 2019-07-26","type":"extras"},{"doc":"Fixes Edge Cases in new Attribute Logic","ref":"changelog.html#0-3-4-2019-07-26","title":"Changelog - [0.3.4] - 2019-07-26","type":"extras"},{"doc":"Fixes Broken Router and CSRF Plugin","ref":"changelog.html#0-3-3-2019-07-25","title":"Changelog - [0.3.3] - 2019-07-25","type":"extras"},{"doc":"Fixes Broken Dependencies","ref":"changelog.html#0-3-2-2019-07-25","title":"Changelog - [0.3.2] - 2019-07-25","type":"extras"},{"doc":"Adds XSS Protection Changed Cleaned up Router","ref":"changelog.html#0-3-1-2019-07-24","title":"Changelog - [0.3.1] - 2019-07-24","type":"extras"},{"doc":"Adds CSRF Protection (Thanks @lkoller) ManyToMany Fields and Relationships with pivot fields and sorting.","ref":"changelog.html#0-3-0-2019-07-15","title":"Changelog - [0.3.0] - 2019-07-15","type":"extras"},{"doc":"Changed Changed the HasOne field to be represented by a simplified resource index table.","ref":"changelog.html#0-2-4-2019-06-26","title":"Changelog - [0.2.4] - 2019-06-26","type":"extras"},{"doc":"Added HasOne Field Fixed Detail Page not changing if the ids are identical after switching resources","ref":"changelog.html#0-2-3-2019-06-25","title":"Changelog - [0.2.3] - 2019-06-25","type":"extras"},{"doc":"Fixed Broken Default Logo Attributes that have &quot;null&quot; values should be transformed to nil","ref":"changelog.html#0-2-2-2019-06-11","title":"Changelog - [0.2.2] - 2019-06-11","type":"extras"},{"doc":"Removed Teal Page Components","ref":"changelog.html#0-2-1-2019-06-07","title":"Changelog - [0.2.1] - 2019-06-07","type":"extras"},{"doc":"Added Boot Process for Plugins Script and Style definitions for a Plugin Changed Major rework of the front end. If this wasn't pre-release software, it would be considered a breaking change.","ref":"changelog.html#0-2-0-2019-06-04","title":"Changelog - [0.2.0] - 2019-06-04","type":"extras"},{"doc":"Changed Simplified Mount Point","ref":"changelog.html#0-1-8-2019-05-09","title":"Changelog - [0.1.8] - 2019-05-09","type":"extras"},{"doc":"Added Color Picker Fixes Subtitles not displayed while searching Broken default Teal logo in sidenav","ref":"changelog.html#0-1-7-2019-05-06","title":"Changelog - [0.1.7] - 2019-05-06","type":"extras"},{"doc":"Added Additional, dropdown options for viewing more resources without pagination","ref":"changelog.html#0-1-6-2019-03-08","title":"Changelog - [0.1.6] - 2019-03-08","type":"extras"},{"doc":"Fixes Missing window.teal in axios error interceptor Aggressive id requirement that broke pages.","ref":"changelog.html#0-1-5-2019-01-14","title":"Changelog - [0.1.5] - 2019-01-14","type":"extras"},{"doc":"Added Actions Multi-Select on Index Views New tool for easier development of teal alongside a parent app. LiveReload and HMR while developing the Vue App Changed Upgraded Vue-CLI Dependencies Applied new Vue-CLI Linter Rules Fixes Broken Delete Icon on the ResourceTable","ref":"changelog.html#0-1-4-2018-12-17","title":"Changelog - [0.1.4] - 2018-12-17","type":"extras"},{"doc":"Fixes: Missing Static Index File in production environments","ref":"changelog.html#0-1-3-2018-11-29","title":"Changelog - [0.1.3] - 2018-11-29","type":"extras"},{"doc":"Fixes: Sets the correct location for the static index file","ref":"changelog.html#0-1-2-2018-11-28","title":"Changelog - [0.1.2] - 2018-11-28","type":"extras"},{"doc":"Adds: Client assets compiled for production.","ref":"changelog.html#0-1-1-2018-11-28","title":"Changelog - [0.1.1] - 2018-11-28","type":"extras"},{"doc":"Initial Release","ref":"changelog.html#0-1-0-2018-11-28","title":"Changelog - [0.1.0] - 2018-11-28","type":"extras"}]